\
\ Handle environmental dependencies
\

1 VALUE ansi-terminal?
1 VALUE color-terminal?		\ only meaningfull if ansi-terminal? is true
10 CONSTANT eol			\ end-of-line character (for file output)

0 VALUE bits/u
0 VALUE bits/ud

: count-bits  ( u -- )
   1 SWAP
   BEGIN 1 RSHIFT ?DUP WHILE  SWAP 1+ SWAP   REPEAT ;
: d-count-bits  ( ud -- )
   count-bits SWAP count-bits + ;
S" MAX-U" ENVIRONMENT? 0= THROW count-bits TO bits/u
S" MAX-UD" ENVIRONMENT? 0= THROW d-count-bits TO bits/ud      

: [DEF?]  ( "name" -- flag )
   BL WORD FIND NIP ; IMMEDIATE
: [-DEF?]  ( "name" -- flag )
   POSTPONE [DEF?] 0= ; IMMEDIATE

S" gforth" ENVIRONMENT? [IF]
   2DROP
   INCLUDE ansi.fs
[ELSE]
   0 TO ansi-terminal?
[THEN]

[-DEF?] NOOP [IF]
: NOOP  ( -- ) ;
[THEN]

[-DEF?] DEFER [IF]
: DEFER  ( "name" -- )  CREATE ['] NOOP ,
   DOES> @ EXECUTE ;
: IS  ( xt "name" -- )
   ' >BODY   STATE @ IF  POSTPONE LITERAL  POSTPONE !  ELSE  ! THEN ; IMMEDIATE
[THEN]

[-DEF?] PERFORM [IF]
: PERFORM  ( j*x a-addr -- i*x )
   STATE @ IF   POSTPONE @  POSTPONE EXECUTE ELSE @ EXECUTE THEN ; IMMEDIATE
[THEN]

[-DEF?] -ROT [IF]
: -ROT  ( x1 x2 x3 -- x3 x1 x2 )
   STATE @ IF  POSTPONE ROT  POSTPONE ROT  ELSE ROT ROT THEN ; IMMEDIATE
[THEN]

[-DEF?] TIME&DATE [IF]
  .( !TIME&DATE not defined!  )
: TIME&DATE  ( -- 0 0 0 0 0 0 )  0 0 0 0 0 0 ;
[THEN]

[-DEF?] ARRAY [IF]
   \ thanks to Bernd Paysan for the following code (increases speed by about
   \ 10%)
   s" bigFORTH" ENVIRONMENT? [IF] 2drop \ drop version number
      .( using machine-CODE ARRAYs  )
      CODE array-access ( i -- addr )
         101010 ax *4 i#) ax lea
         Next
      END-CODE MACRO
      ALSO dos
      : ARRAY  ( size -- )  ALIGN HERE >R CELLS ALLOT
         : POSTPONE array-access  R> HERE 6 - ! POSTPONE ; MACRO ;
   [ELSE]
      : ARRAY  ( u "name" -- )  CREATE CELLS ALLOT   DOES> SWAP CELLS + ;
   [THEN]
[THEN]

[-DEF?] 2ARRAY [IF]
: 2ARRAY  ( u "name" -- )  CREATE 2* CELLS ALLOT   DOES> SWAP 2* CELLS + ;
[THEN]


