\
\ New Tree search 
\ 

\
\ Todo: don't use get-best-move for getting the calculated move, since
\ pawn transformations aren't handled correctly! -- or fix the
\ principal variation to hold move types?? aaaaarrrgggg
\ killer moves?? generate-single-move??
\


\
\ Move sorting?? Check / Mate / Stalemate Detection ??
\

: recurse?  ( -- flag )  think-depth think-limit < ;
: +depth  ( -- )  think-depth 1+ TO think-depth ;
: -depth  ( -- )  think-depth 1- TO think-depth ;
: switch-alpha-beta  ( -- )  alpha NEGATE beta NEGATE TO alpha TO beta ;
: check-mate-eval  ( -- eval )  -infinity 1+  think-depth + ;
: ?check-mate  ( -- )
   moves-exist? 0= IF
      check? ABORT" check mate"
      TRUE   ABORT" stale mate"
   THEN ;

0 VALUE cutoff?
: is-cutoff?  ( eval -- flag )  beta < 0= DUP TO cutoff? ;
: adjust-alpha  ( move-index eval -- )
   DUP alpha > IF
      TO alpha  is-principal-move
   ELSE 2DROP THEN ;
: best-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff? DUP alpha MAX TO alpha
   BEGIN next-best-move DUP 0< 0= WHILE		( S: eval move-i )
      DUP >R eval-move-recursive		( S: eval eval2 ) ( R: move-i )
      0 TO cutoff?   
      2DUP < IF
	 R@ OVER adjust-alpha
	 NIP DUP is-cutoff? IF
	    R> is-killer EXIT
	 THEN
      ELSE DROP THEN R> DROP
   REPEAT DROP ;
0 VALUE #null
: null-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   ( disabled...) EXIT
   curr-eval beta <  think-depth think-limit < OR IF EXIT THEN
   null-move? IF
      #null 1+ TO #null
      -1 eval-move-recursive
      DUP is-cutoff? DROP
      DUP alpha MAX TO alpha
      MAX
   THEN ;
: single-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   0 set-move-eval  0 eval-move-recursive
   DUP is-cutoff? IF  0 is-killer THEN
   0 OVER adjust-alpha
   MAX ;
: killer-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   generate-fast-killer #moves IF
      single-move-eval
   THEN forget-moves ;
: capture-killer-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   generate-fast-strike-killer #moves IF
      single-move-eval
   THEN forget-moves ;
: target-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   opponent-move-target
   generate-moves-to delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: capture-not-target-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   opponent-move-target DUP opponent? 0= IF DROP 0 THEN
   generate-strike-moves-not-to delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: capture-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   generate-strike-moves delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: quiescence-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   generate-quiescence-moves delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: all-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   generate-moves delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: not-target-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   opponent-move-target DUP opponent? 0= IF DROP 0 THEN
   generate-moves-not-to delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: peaceful-move-eval  ( curr-eval -- curr-eval|better-eval )
   0 TO cutoff?
   generate-peaceful-moves delete-fast-killer eval-moves weight-moves
   best-move-eval forget-move-weights forget-moves ;
: minimum-quiescence-move-eval  ( curr-eval -- curr-eval|better-eval )
   opponent-move-target generate-cheapest-move-to #moves IF
      single-move-eval
   THEN  forget-moves ;

: (eval-position-recursive)  ( -- eval )
   #nodes 1+ TO #nodes
   -infinity
   null-move-eval cutoff? 0= IF
      killer-move-eval cutoff? 0= IF
	 target-move-eval cutoff? 0= IF
	    not-target-move-eval cutoff? 0= IF
	       moves-exist? 0= IF  DROP curr-check? check-mate-eval AND THEN
	    THEN
	 THEN
      THEN
   THEN ;

' (eval-position-recursive) IS eval-position-recursive

: (quiescence-eval-nocheck)  ( -- eval ) \ used if not in check
   #nodes 1+ TO #nodes
   curr-eval DUP alpha MAX TO alpha
   DUP is-cutoff? IF
      moves-exist? 0= IF DROP 0 THEN
   ELSE
      think-depth full-quiescence-limit < IF
	 capture-killer-move-eval cutoff? 0= IF
	    quiescence-move-eval cutoff? 0= IF
	       moves-exist? 0= IF  DROP 0 THEN
	    THEN
	 THEN
      ELSE think-depth simple-quiescence-limit < IF
	 capture-killer-move-eval cutoff? 0= IF
	    capture-move-eval cutoff? 0= IF
	       moves-exist? 0= IF  DROP 0 THEN
	    THEN
	 THEN
      ELSE
	 minimum-quiescence-move-eval
      THEN THEN
   THEN ;
: (quiescence-eval-check)  ( -- eval ) \ used if in check
   (eval-position-recursive) ;
: (quiescence-eval-position)  ( -- eval )
   curr-check?
   IF (quiescence-eval-check) ELSE (quiescence-eval-nocheck) THEN ;
' (quiescence-eval-position) IS quiescence-eval-position

: (eval-move-recursive)  ( move-index|-1 -- eval )
   alpha beta 2>R switch-alpha-beta
   on-principal-variation? >R  DUP ?on-principal-variation
   DUP 0< IF   DROP get-null-move   ELSE DUP ?set-move-eval get-move THEN
   do-move-undo-info
   remembering-position? IF
      0
   ELSE
      recurse? IF
	 think-depth think-limit 1 - =		( Futility Pruning)
	 curr-eval 128 - beta > AND
	 on-principal-variation? 0= AND
	 curr-check? 0= AND
	 IF curr-eval 
	 ELSE
	    +depth eval-position-recursive -depth
	 THEN
      ELSE
	 +depth quiescence-eval-position -depth
      THEN NEGATE
   THEN
   >R undo-move R>
   R> TO on-principal-variation?   2R> TO beta TO alpha ;
' (eval-move-recursive) IS eval-move-recursive

0 VALUE start-time

0 VALUE root-alpha
0 VALUE root-beta

: root-search  ( -- eval )
   -infinity
   root-alpha -infinity MAX TO alpha
   root-beta +infinity MIN TO beta
   TRUE TO on-principal-variation?
   root-alpha . ." - " root-beta .
   sort-moves-by-weight
   #moves 0 ?DO  -infinity I move-weight ! LOOP
   best-move find-move-x IF  first-move THEN
   #moves 0 ?DO
      0 TO think-depth
      I eval-move-recursive
      DUP beta < 0=  OVER root-beta < AND IF
	 I SWAP adjust-alpha root-beta TO beta
	 I eval-move-recursive
      THEN
      I OVER adjust-alpha
      DUP root-beta < 0= IF  NIP LEAVE THEN
      DUP I move-weight !
      think-limit 2 > IF  alpha 1+ TO beta THEN
      MAX
   LOOP
   DUP root-alpha > IF
      best-move find-move-x 0= ABORT" ??" display-move SPACE  DUP .
   THEN ;

: setup-think-limit  ( limit -- )
   DUP TO think-limit
   DUP 2* 1+ TO full-quiescence-limit
   3 * 3 + TO simple-quiescence-limit ;
: calculate-move  ( -- move-index )
   ?check-mate check? TO curr-check?
   total-eval TO curr-abs-eval
   generate-moves eval-moves weight-moves init-killers
   secs TO start-time
   curr-eval TO alpha
   max-think-limit 1+ 0 ?DO
      CR I 1+ .
      I setup-think-limit
      ?use-null-moves
      think-limit 2 < IF
	 -infinity TO root-alpha
	 +infinity TO root-beta
      ELSE
	 alpha 50 - to root-alpha
	 alpha 50 + TO root-beta
      THEN
      root-search
      TRUE TO on-principal-variation?
      DUP root-alpha > 0= IF
	 CR I 1+ . ." <"
	 TO root-beta
	 -infinity TO root-alpha root-search
      ELSE DUP root-beta < 0= IF
	 CR I 1+ . ." >"
	 TO root-alpha
	 +infinity TO root-beta root-search
      THEN THEN DROP
      secs start-time - abort-time > IF LEAVE THEN
   LOOP
   forget-move-weights forget-moves
   best-move find-move-x 0= ABORT" Move not found??" ;

