\ basics.fs
\ 	$Id: basics.fs,v 1.30 2001/02/18 18:58:45 f Exp $	

decimal

[UNDEFINED] 1-   [IF]		: 1-   1 - ;				[THEN]
[UNDEFINED] cell [IF]		1 cells CONSTANT cell			[THEN]
[UNDEFINED] 0<=  [IF]		: 0<= ( n -- f )   1 < ;		[THEN]
[UNDEFINED] >=   [IF]		: >= ( n1 n2 -- f )   1- > ;		[THEN]
[UNDEFINED] <=   [IF]		: <= ( n1 n2 -- f )   1+ < ;		[THEN]
[UNDEFINED] d<>  [IF]		: d<> ( d1 d2 -- f )  d= 0= ;		[THEN]
[UNDEFINED] -rot [IF]		: -rot ( w1 w2 w3 -- w3 w1 w2) rot rot ; [THEN]
[UNDEFINED] clearstack [IF]	: clearstack   depth 0 ?DO drop LOOP ;	[THEN]

[UNDEFINED] rdrop [IF]
    [UNDEFINED] r>drop [IF]
	: rdrop ( r: x -- r: - )   POSTPONE r>  POSTPONE drop ; IMMEDIATE
    [ELSE] \ Guido Draheim
	: rdrop ( r: x -- r: - )   POSTPONE r>drop ; IMMEDIATE
    [THEN]
[THEN]

[UNDEFINED] 2rdrop [IF]
    [UNDEFINED] 2r>drop [IF]
	: 2rdrop ( r: x1 x2 -- r: - ) POSTPONE rdrop POSTPONE rdrop ; IMMEDIATE
    [ELSE] \ Guido Draheim
	: 2rdrop ( r: x1 x2 -- r: - ) POSTPONE 2r>drop ; IMMEDIATE
    [THEN]
[THEN]


\ compiler syntax:

false [if] \ simple version
: OFFSET: ( n -- n+1 )
    CREATE
	dup cells , 1+
    DOES> @ + ;

[else] \ special treatment for zero offset

: (offset:) ( n -- n )
    CREATE
	dup cells ,
    DOES> @ + ;

: (zero-offset:) ( 0 -- 0 )  :  postpone ;   ;

: OFFSET: ( n -- n+1 )	\ as a naming convention i use '>name' for offsets.
    dup IF
	(offset:)
    ELSE
	(zero-offset:) immediate
    THEN
    1+ ;
[then]

: -OFFSET: dup negate OFFSET: drop 1+ ;

: N-OFFSET: ( counter width -- counter+1 )  \ witdh *must* be multiple of cell
    over >r
    * cell / OFFSET: drop
    r> 1+ ;

: MASK: ( bit-position -- bit-position+1 )
    dup 1 swap lshift CONSTANT
    1+
    dup cell 2* 2* 2* >= ABORT" Too many bits in bit-mask" ;

\ compile constants with inreasing values
[UNDEFINED] enum: [IF]		: ENUM: ( n -- n+1 ) dup CONSTANT 1+ ;	[THEN]

\ more things:

\ word to set a range of bits
: set-bitrange ( mask upper+1 lower -- mask' )
    ?DO
	1 i lshift OR
    LOOP ;

: num>string ( n -- c-addr u )	dup abs 0 <# #s rot sign #> ;

: m/ ( d n -- )    1 swap m*/ d>s ;

\ In the following usage example passing an xt (to set menu prefixes) to
\ 'default-function-keys' saying ' NOOP default-function-keys would give
\ a wrong impression.  So using FALSE instead is allowed:
: ?execute ( xt|0 -- ) dup IF EXECUTE EXIT THEN drop ;

\ resizes an allocated area at addr of old-length to the double
\ and erases new upper half.
: double-allocated ( addr old-length -- addr ior )
    dup >r
    2* resize
    dup 0= IF
	over r@ + r@ erase	\ erase new area
    THEN rdrop ;

\ : signed-c@ ( addr - n )    c@ dup $80 and IF $100 - THEN ;

\ : chained! ( addr n -- addr' )  over !  cell+ ;

: char-search-backwards ( addr count char -- count' true | false )
    >r
    1-
    BEGIN	( addr count  r: char )
	2dup + c@ r@ <>
    WHILE
	1-
	dup 0<
    UNTIL
	2drop FALSE
    ELSE
	nip TRUE
    THEN
    rdrop ;

\ use '*/' to scale a value at addr1 by the rate at addr2
: addr-rate ( addr-of-value-to-rate addr-of-rating-factor -- )
    >r
    r@ 2@	 = IF drop rdrop EXIT THEN	\ ratio = 1
    r@ cell+ @ 0 = IF off  rdrop EXIT THEN	\ ratio = 0
    dup @ r> 2@ */ swap ! ;			\ others

\ As CATCHing 0 / (and others) can give error messages we
\ might need to do this system specific.
[UNDEFINED] ?/ [IF]

\ use this if / 0 and other malformed combinations dont give error messages.
: ?/ ( n n -- n|0 )   ['] / CATCH IF 2drop 0 THEN ;

    FALSE [IF] \ Handmade version. Trying to avoid crashes:
	\ Doing it by hand is not trivial, because you might have to
	\ watch for malformed combinations here.  Overflow or so
	\ can produce such sometimes.  I can't exclude that there are
	\ other combinations that should be included here.
	\ I guess it's processor dependent too.
	: ?/ ( n n -- n )
	    dup IF
		over [ decimal ] 2147483648 = IF	\ check for NAN
		    dup -1 = IF			\ this combination crashes!
			2drop 0			\ meaningless result...
			EXIT
		    THEN
		THEN
		/
	    ELSE 2drop 0 THEN ;

	\   old handmade version, NOT identical, ended like this:
	\   ELSE drop THEN ;	\ result differed from catch version!
    [THEN]

[THEN]

[UNDEFINED] bell [IF]		: bell 7 emit ;				[THEN]

\ arrays for single and double cell values, initializing but no check:
\  : n-ARRAY: ( u -- )
\      CREATE
\      0 DO 0 , LOOP	\ allot initializing with zero
\      DOES> ( u -- addr )
\  	swap cells + ;

\  : n-2ARRAY: ( u -- )
\      CREATE
\      0 DO 0 , 0 , LOOP	\ allot initializing with zero
\      DOES> ( u -- addr )
\  	swap 2* cells + ;
