\ long-mutations.fs
\ 	$Id: long-mutations.fs,v 1.14 2001/02/18 22:31:28 f Exp $	

\ benchmark long-mutations.fs
\ Mutation is set up in a way to build very long gene sequences.

\ In the second phase genes are kept longer than usual in trial phase, which
\ means that a lot of FORTH code is interpreted.

\ I deliberately mess up search order a bit to stress dictionary searches.
also brew-words
also genes

page
cr .( 'brew' running benchmark:  long mutations. )
cr

variable benchmark-steps
display-slots off
no-messages on
no-snapshots display-switch !
			
cr .( Phase 1   Mutation builds some long gene sequences. )

\ starting from scratch:

\ restart with an unpopulated world:
free-field

\  set probabilities in actual pool:
' gene-primitives actual-genepool-xt !
actual-genepool-xt @ execute nul-all-probabilities
internal' 0=	2 actual-genepool-xt @ execute set-xt-probability
internal' 0<	5 actual-genepool-xt @ execute set-xt-probability
internal' 0>	5 actual-genepool-xt @ execute set-xt-probability
internal' =	1 actual-genepool-xt @ execute set-xt-probability
internal' >	10 actual-genepool-xt @ execute set-xt-probability
internal' <	10 actual-genepool-xt @ execute set-xt-probability
internal' within	8 actual-genepool-xt @ execute set-xt-probability
internal' and	10 actual-genepool-xt @ execute set-xt-probability
internal' or	10 actual-genepool-xt @ execute set-xt-probability
internal' xor	10 actual-genepool-xt @ execute set-xt-probability
internal' g-IF-ELSE-THEN	10 actual-genepool-xt @ execute set-xt-probability
internal' dup	6 actual-genepool-xt @ execute set-xt-probability
internal' 2dup	2 actual-genepool-xt @ execute set-xt-probability
internal' drop	2 actual-genepool-xt @ execute set-xt-probability
internal' drop(a-)	2 actual-genepool-xt @ execute set-xt-probability
internal' nip	2 actual-genepool-xt @ execute set-xt-probability
internal' nip(aa-a)	2 actual-genepool-xt @ execute set-xt-probability
internal' nip(an-n)	2 actual-genepool-xt @ execute set-xt-probability
internal' nip(na-a)	2 actual-genepool-xt @ execute set-xt-probability
internal' tuck	4 actual-genepool-xt @ execute set-xt-probability
internal' swap	8 actual-genepool-xt @ execute set-xt-probability
internal' swap(aa-aa)	8 actual-genepool-xt @ execute set-xt-probability
internal' over	7 actual-genepool-xt @ execute set-xt-probability
internal' over(an-ana)	6 actual-genepool-xt @ execute set-xt-probability
internal' +	10 actual-genepool-xt @ execute set-xt-probability
internal' -	10 actual-genepool-xt @ execute set-xt-probability
internal' negate	8 actual-genepool-xt @ execute set-xt-probability
internal' *	4 actual-genepool-xt @ execute set-xt-probability
internal' ?/	4 actual-genepool-xt @ execute set-xt-probability
internal' organ-A	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-B	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-C	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-D	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-E	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-F	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-G	10 actual-genepool-xt @ execute set-xt-probability
internal' A-quality	10 actual-genepool-xt @ execute set-xt-probability
internal' B-quality	10 actual-genepool-xt @ execute set-xt-probability
internal' C-quality	10 actual-genepool-xt @ execute set-xt-probability
internal' @	10 actual-genepool-xt @ execute set-xt-probability
internal' take	10 actual-genepool-xt @ execute set-xt-probability
internal' !(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' +!(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' -!(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' swap!(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' take-some	10 actual-genepool-xt @ execute set-xt-probability
internal' off	2 actual-genepool-xt @ execute set-xt-probability

\ set brew variables:
1 world-do-direction !
' noop spot-do-xt !
' noop cell-do-before-xt !
' noop cell-do-after-xt !
-1 future-quality-change !
0 cell-division-moves-both !
0 cell-division-diversify-both !
0 cell-division-mutate-both !
0 world-food-supply !
200 food-share/spot !
0 individual-fixed-food-share !
0 nuc-do-cost !
0 code-price !
0 1 code-price-scale 2!
0 leave-energy-after-death !
1 additive-stress !
4 additive-release !
1 1 stress-rate 2!
4 multiplicative-release !
1 code-additive-stress !
1 1 code-stress-rate 2!
640 high-water-mark !
1728 flood-mark !
110 100 flood-stress-rate 2!
0 1 flood-kill-rate 2!
0 1 flood-energy-rate 2!
9 10 flood-food-rate 2!
38 sos-mark !
1 sos-sow !
1 2 sos-release-rate 2!
100 low-water-mark !
300 up-regulation-start !
-1 nuc-cost-can-be-help? !
-1 code-price-can-be-help? !
33 diversification-range !
1 4 diversification-rate 2!
2 diversification-closeness !
127 diversification-mask !
' A-quality>color background-color-xt !
' genome>color foreground-color-xt !
' show-genom-b look-at-xt !
100 2-ascii-scale !
100 food>color-scale !
20 age>color-scale !
192 A-quality>color-scale !
200 B-quality>color-scale !
200 C-quality>color-scale !
100 (A-scale) !
100 (B-scale) !
100 (C-scale) !
' random-BRODIE random-xt !
272958469 0 (random-generalized) 2!
1334532601 seed-BRODIE !	 \ gets recorded changed or not -1
0 cell-division-moves-both !
0 cell-division-diversify-both !
0 cell-division-mutate-both !
1 5 mutation-rate 2!
1 2 top-level-insert 2!
1 3 top-level-replace 2!
1 3 top-snipping 2!
1 top-random-snipping !
1 top-short-snipping !
1 top-long-snipping !
1 3 top-address-replace 2!
1 3 top-token-replace 2!
1 60 top-from-scratch 2!
4 stack-turning-point !
5 mutations-threshold !
10 trial-phase !
33 conditional-token-price !
1 resolve-flags !
4 max-if-items !
\ 1 display-switch !
' .step 0 display-slot !
0 (scan-index) !
8 (scan-detail-index) !
1 5 horizontal-zoom-scale 2!
1 4 vertical-zoom-scale 2!
0 (vertical-display-range) !
' default-color scan-foreground-xt !
' blue scan-background-xt !
0 log-mask !
0 code-file-mask !
' menus-menu F1-xt !
' toggle-display-&-go F2-xt !
' spot-scan-menu F3-xt !
' nuc-scan-menu F4-xt !
' menu-select-nuc-var F5-xt !
' noop F6-xt !
' noop F7-xt !
' noop F8-xt !
' do-FORTH F9-xt !
' noop F10-xt !
' toggle-anything F11-xt !
' goodbye F12-xt !
' noop shift-F1-xt !
' noop shift-F2-xt !
' noop shift-F3-xt !
' noop shift-F4-xt !
' noop shift-F5-xt !
' noop shift-F6-xt !
' noop shift-F7-xt !
' noop shift-F8-xt !

\ define nuc and set it actual:
100 new-nucleus DROP cp!
100 length !
0 nuc-flags !
0 nuc-supplements !
0 id !
0 genome-id !
0 age !
0 generation !
0 genom-generation !
100 code-cost !
0 energy !
0 reproduction-threshold !
0 age-threshold !
0 appearance !
7 my-diversification-bitmask !
0 organ-A !
0 organ-B !
0 organ-C !
0 organ-D !
0 organ-E !
0 organ-F !
0 organ-G !
gene' g-noop    	wake-me-xt !
' violet-eater-5    	eat-xt !
' cell-division    	reproduce-xt !
' <look-at>    	show-me-xt !

\ sow above nuc:
' random-BRODIE random-xt !
1334532601 seed-BRODIE !
-1 (sow-diversified) !
12 sow drop time-step

\ changed parameters:
-754512200 seed-BRODIE !	 \ gets recorded changed or not 2

\ brew the gene soup:
50 brew drop

\ changed parameters:
451698507 seed-BRODIE !	 \ gets recorded changed or not 4

\ brew the gene soup:
1 brew drop

\ changed parameters:
' trial>color foreground-color-xt !
-1601308205 seed-BRODIE !	 \ gets recorded changed or not 6
1 10 mutation-rate 2!
3 stack-turning-point !
2 mutations-threshold !
36 trial-phase !
\ 3 display-switch !

0 4 at-xy
cr .( Phase 2   Continue mutation and force evaluation of long buffered strings. )
cr .(           This implies a lot of dictionary searches. )

\ brew the gene soup:
1 brew drop

\ changed parameters:
-1919838485 seed-BRODIE !	 \ gets recorded changed or not 8

\ brew the gene soup:
198 brew drop

\ assert-state-entry
\ assert expected results:

seed-BRODIE @ 2046257799 =
cloned @ 48490 = AND
living @ 1633 = AND
nuc-do-cost @ 2413 = AND
code-price @ 2413 = AND
(mutated-max) @ 40970 = AND
compiled-genes @ 129 = AND
cr
[IF]
    .( Result is valid. )
[ELSE]
    ping .( Unexpected result. Not comparable to other systems! )
[THEN] cr

bye
