\ brew-options.fs
\ 	$Id: brew-options.fs,v 1.23 2001/02/15 15:30:18 f Exp $	

\  This file is included after loading all other files
\  just before including 'my-brew-options.fs' and starting to brew.

\ You can change options here or make a 'my-brew-options.fs' file.
\ It would be included just after this one.

\ Uncomment for debugging.  Writes huge log and code files then.
\ Do set 'log-mask' as *compile* option too.
\ log-mask ON		code-file-mask ON


\ *********************************************************************
\ Run as benchmark?

\ If your FORTH has an option to pass a string which is evaluate'd
\ during startup start benchmarks by defining a word with the
\ benchmarks name (without the '.fs' suffix). So in Gforth you'd say:
\ time  gforth-fast --dictionary-size 2M  -e "create startup-bench"   brew.fs
\ time  gforth-fast --dictionary-size 2M  -e "create simple-bench"    brew.fs
\ time  gforth-fast --dictionary-size 2M  -e "create mutations-1"     brew.fs
\ time  gforth-fast --dictionary-size 2M  -e "create displayed-bench" brew.fs
\ time  gforth-fast --dictionary-size 2M  -e "create long-mutations"  brew.fs

\ If your FORTH does not have such an option you can uncomment one of
\ the following 'include xxx' lines and use starting commands given below:
\ *********************************************************************

\ include benchmarks/startup-bench.fs
\		Startup only.

\ include benchmarks/simple-bench.fs
\ That's the simplest benchmark. It does work under Gforth, bigFORTH, pfe.
\ tested:	GForth 0.5.0
\		ANS bigforth 386-Linux rev. 1.22
\		pfe  Portable Forth Environment 0.30.38 (Dec 31 2000 09:38:15)

\ include benchmarks/mutations-1.fs
\ This benchmark is much more complex.
\ It includes a fair amount of interpreting buffered strings and compilation.
\ tested:	GForth 0.5.0
\		    start with 'time gforth-fast --dictionary-size 2M brew.fs'
\		pfe  Portable Forth Environment 0.30.38 (Dec 31 2000 09:38:15)
\		    start with 'time pfe -k 2048 brew.fs'

\ include benchmarks/displayed-bench.fs
\ This benchmark has display switched on. It does use colours sometimes.
\ Use the others, if you don't want this.
\ tested:	GForth 0.5.0
\		    start with 'time gforth-fast --dictionary-size 2M brew.fs'
\		pfe  Portable Forth Environment 0.30.40 (Jan  1 2001 18:17:50)
\		    start with 'time pfe brew.fs'

\ include benchmarks/long-mutations.fs
\ This imposes a heavy load on you're machine and FORTH system.
\ Mutation is set up in a way to build very long gene sequences.
\ In the second phase genes are kept longer than usual in trial phase, which
\ means that a lot of FORTH code is interpreted.
\ I deliberately messed up search order a bit to stress dictionary searches.
\ tested:	GForth 0.5.0
\		Portable Forth Environment 0.30.40 (Jan  1 2001 18:17:50)

FALSE [IF] \ fake old mutation pool setup until 'brew-0_03z'

\  set probabilities in actual pool:
' gene-primitives actual-genepool-xt !
actual-genepool-xt @ execute nul-all-probabilities
internal' 0=	2 actual-genepool-xt @ execute set-xt-probability
internal' 0<	5 actual-genepool-xt @ execute set-xt-probability
internal' 0>	5 actual-genepool-xt @ execute set-xt-probability
internal' =	1 actual-genepool-xt @ execute set-xt-probability
internal' >	10 actual-genepool-xt @ execute set-xt-probability
internal' <	10 actual-genepool-xt @ execute set-xt-probability
internal' within	8 actual-genepool-xt @ execute set-xt-probability
internal' and	10 actual-genepool-xt @ execute set-xt-probability
internal' or	10 actual-genepool-xt @ execute set-xt-probability
internal' xor	10 actual-genepool-xt @ execute set-xt-probability
internal' g-IF-ELSE-THEN	10 actual-genepool-xt @ execute set-xt-probability
internal' dup	6 actual-genepool-xt @ execute set-xt-probability
internal' 2dup	2 actual-genepool-xt @ execute set-xt-probability
internal' drop	2 actual-genepool-xt @ execute set-xt-probability
internal' drop(a-)	2 actual-genepool-xt @ execute set-xt-probability
internal' nip	2 actual-genepool-xt @ execute set-xt-probability
internal' nip(aa-a)	2 actual-genepool-xt @ execute set-xt-probability
internal' nip(an-n)	2 actual-genepool-xt @ execute set-xt-probability
internal' nip(na-a)	2 actual-genepool-xt @ execute set-xt-probability
internal' tuck	4 actual-genepool-xt @ execute set-xt-probability
internal' swap	8 actual-genepool-xt @ execute set-xt-probability
internal' swap(aa-aa)	8 actual-genepool-xt @ execute set-xt-probability
internal' over	7 actual-genepool-xt @ execute set-xt-probability
internal' over(an-ana)	6 actual-genepool-xt @ execute set-xt-probability
internal' +	10 actual-genepool-xt @ execute set-xt-probability
internal' -	10 actual-genepool-xt @ execute set-xt-probability
internal' negate	8 actual-genepool-xt @ execute set-xt-probability
internal' *	4 actual-genepool-xt @ execute set-xt-probability
internal' ?/	4 actual-genepool-xt @ execute set-xt-probability
internal' organ-A	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-B	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-C	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-D	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-E	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-F	10 actual-genepool-xt @ execute set-xt-probability
internal' organ-G	10 actual-genepool-xt @ execute set-xt-probability
internal' A-quality	10 actual-genepool-xt @ execute set-xt-probability
internal' B-quality	10 actual-genepool-xt @ execute set-xt-probability
internal' C-quality	10 actual-genepool-xt @ execute set-xt-probability
internal' @	10 actual-genepool-xt @ execute set-xt-probability
internal' take	10 actual-genepool-xt @ execute set-xt-probability
internal' !(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' +!(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' -!(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' swap!(some)	10 actual-genepool-xt @ execute set-xt-probability
internal' take-some	10 actual-genepool-xt @ execute set-xt-probability
internal' off	2 actual-genepool-xt @ execute set-xt-probability
[THEN]
