\ console-codes.fs
\ 	$Id: console-codes.fs,v 1.6 2001/02/12 20:42:17 f Exp $	

[UNDEFINED] push-key [IF]	include keybuf.fs 			[THEN]

decimal

[UNDEFINED] at?  TRUE or [IF] \ bigFORTH has it but it does not behave the same
: at? ( -- x y )		\ gives cursor position 'at? at-xy' is a noop
\ see man console_codes:
\      ECMA-48 Status Report Commands
\      ESC [ 6 n
\      Cursor position report (CPR): Answer is ESC [ y ; x
\      R, where x,y is the cursor location.
    BEGIN key? WHILE key push-key REPEAT
    27 emit ." [6n"
    BEGIN key 27 = UNTIL	\ wait until ESC arrives
    key	dup [char] [ <> IF
	cr ." keycode was wrong"
	push-key
	0 0 EXIT	\ ####### how to recover here?
    ELSE drop THEN

    0 BEGIN			\ get y
	key
	dup [char] ; <> WHILE	\ ';' is delimiter
	>r 10 * r>
	[char] 0 -   +
    REPEAT drop 1-
    0 BEGIN			\ get x
	key
	dup [char] R <> WHILE	\ 'R' is delimiter
	>r 10 * r>
	[char] 0 -   +
    REPEAT drop 1- swap ;
[THEN]

: cursor-visible	27 emit ." [?25h" ;
: cursor-off		27 emit ." [?25l" ;

true [IF] \ not using escape sequences here.
    \ new version, inspired by a suggestion from Marcel Hendrix.
    \ do not use escape sequences here, but leave work to 'at?'.
    \ let's hope it just stop on screen borders, as it does on my system.
    : cursor-up             at? 1- at-xy ;
    : cursor-down           at? 1+ at-xy ;
    : cursor-right          at? >r 1+ r> at-xy ;
    : cursor-left           at? >r 1- r> at-xy ;
[ELSE]  \ my old version using escape sequences
    : cursor-up			27 emit ." [A" ;
    : cursor-down		27 emit ." [B" ;
    : cursor-right  		27 emit ." [C" ;
    : cursor-left	  	27 emit ." [D" ;
[THEN]

8 CONSTANT colors
0 CONSTANT black
1 CONSTANT red
2 CONSTANT green
3 CONSTANT brown
4 CONSTANT blue
5 CONSTANT magenta
6 CONSTANT cyan
7 CONSTANT white
9 CONSTANT default-color

LIST: color-list
' black color-list >list
' red color-list >list
' green color-list >list
' brown color-list >list
' blue color-list >list
' magenta color-list >list
' cyan color-list >list
' white color-list >list
' default-color color-list >list
