\ display.fs
\ 	$Id: display.fs,v 1.23 2001/02/13 14:01:02 f Exp $	

\ compile option: 'color-offset' not used, never tested.
\ could give problems in other places (data vizualization).


variable display-switch			\ switches at run time

\ if you define (uncomment) 'never-use-colors' in 'compile-options.fs'
\ there will be no colors used. (Most color stuff will still get compiled
\ in though for the sake of simplicity.)

\ bit masks for 'display-switch':
LIST: display-switch-masks
display-switch-masks
0
LISTED-MASK: spot-display-on		\ spot display on
LISTED-MASK: spot-foreground-coloring	\ spot foreground color on
LISTED-MASK: spot-background-coloring	\ spot background color on
LISTED-MASK: step-display-on		\ step statistic info, nuc/world scans
LISTED-MASK: step-foreground-coloring	\ spot foreground color on
LISTED-MASK: step-background-coloring	\ spot background color on
\ if nothing else is displayed snapshots are shown as default
\ I'm thinking about turning the logic back to normal.
LISTED-MASK: no-snapshots		\ no-snapshots switches snapshots off
LISTED-MASK: continuous-display-used	\ does *not* switch continuous display
2drop

spot-display-on display-switch !

\ these switches work on *spot* display: (currently)
: toggle-foreground-colorizing ( -- )
    display-switch dup @ spot-foreground-coloring xor swap ! ;
: toggle-background-colorizing ( -- )
    display-switch dup @ spot-background-coloring xor swap ! ;

: toggle-colorizing ( -- )
    display-switch dup @		( switch-addr switch-bitmask )

    dup spot-display-on and IF		\ spot display on
	[ spot-foreground-coloring spot-background-coloring + ] literal >r
	dup r@ and r@ = IF			\ full colored spot display?
	    spot-foreground-coloring xor	\ colors off
	    spot-background-coloring xor
	ELSE r@ or THEN rdrop			\ colors on
    THEN

    dup step-display-on and IF		\ step display on
    THEN

    swap ! ;

\ transform any given number in an allowed color code.
[UNDEFINED] 2-color [IF] \ could be defined system dependent.

\ assuming continuous range from zero (or 'color-offset') upwards.
\ compile option: 'color-offset' not used, never tested.
\ could give problems in other places (data visualization).
: 2-color ( col -- col' )
    colors mod
    dup 0< IF colors + THEN

    [DEFINED] color-offset [IF]	\ color-offset is the lowest color code
	[ color-offset ] literal +  \ for systems where colors don't start at 0
    [THEN]
;
[THEN]

\ you like bluescreens?  say: 'blue color-background' :)
[UNDEFINED] color-foreground [IF]
: color-foreground ( color -- )
    [UNDEFINED] never-use-colors [IF]
	27 emit  ." [3"  [char] 0 + emit  ." m"
    [ELSE] drop [THEN]	;
[THEN]

[UNDEFINED] color-background [IF]
: color-background ( color -- )
    [UNDEFINED] never-use-colors [IF]
	27 emit  ." [4"  [char] 0 + emit  ." m"
    [ELSE] drop [THEN]	;
[THEN]

variable background-color-xt	' black background-color-xt !
: <background-color> ( -- col )		background-color-xt @ EXECUTE ;

variable foreground-color-xt	' white foreground-color-xt !
: <foreground-color> ( -- col )		foreground-color-xt @ EXECUTE ;

: set-colors ( -- )	\ for spot display
    display-switch @ spot-display-on and IF
	display-switch @ spot-foreground-coloring and IF
	    <foreground-color> color-foreground
	THEN
	display-switch @ spot-background-coloring and IF
	    <background-color> color-background
	THEN
    THEN ;

LIST: x>bg-color		\ words that set color depending on something
LIST: x>fg-color		\ words that set color depending on something

\ first the trivial cases:
' black		dup x>bg-color >list	x>fg-color >list
' red		dup x>bg-color >list	x>fg-color >list
' green		dup x>bg-color >list	x>fg-color >list
' brown		dup x>bg-color >list	x>fg-color >list
' blue		dup x>bg-color >list	x>fg-color >list
' magenta	dup x>bg-color >list	x>fg-color >list
' cyan		dup x>bg-color >list	x>fg-color >list
' white		dup x>bg-color >list	x>fg-color >list
' default-color	dup x>bg-color >list	x>fg-color >list

[DEFINED] default-foreground [IF]
    ' default-foreground x>fg-color >list
[THEN]
[DEFINED] default-background [IF]
    ' default-background x>bg-color >list
[THEN]

: paint-background ( -- )
    display-switch @ spot-background-coloring and IF
	<background-color> color-background
    THEN ;

: reset-default-colors ( -- )	
    default-color color-foreground
    default-color color-background ;

: set-default-colors ( -- )	\ same, but checks if needed
    display-switch @
    dup spot-foreground-coloring and IF default-color color-foreground THEN
	spot-background-coloring and IF default-color color-background THEN ;

