\ fileselect.fs
\ 	$Id: fileselect.fs,v 1.4 2001/02/11 08:20:21 f Exp $	

\ very simple file selection implementation (as a menu).

[UNDEFINED] file-names-length#	[IF] &256 constant file-names-length#	[THEN]
[UNDEFINED] S-BUF:		[IF] include stringbuf-0.3.fs		[THEN]

variable (current-directory)
file-names-length# S-BUF: (current-directory-name)

: normalize-current-dir-name ( -- )	\ works on (current-directory-name)
	\ append a '/' if it's not there already
	(current-directory-name) s-buf>string + 1- c@ [char] / <> IF
	    [char] / (current-directory-name) s-buf-char-cat
	THEN

	\ don't include '../' or './' in (current-directory-name)
	(current-directory-name) s-buf>string  s" ../"  search IF
	    1+ negate (current-directory-name) +!
	    drop
	    (current-directory-name) s-buf>string
	    [char] / char-search-backwards IF
		1+ (current-directory-name) !
	    ELSE
\		s" ../" (current-directory-name) dup s-buf-clear s-buf-cat
\		r> EXIT
		(current-directory-name) s-buf-clear
	    THEN
	ELSE 2drop THEN

	(current-directory-name) s-buf>string
	s" ./" search IF
	    negate (current-directory-name) +!
	    drop
	ELSE 2drop THEN

	\ replace empty string by './'
	(current-directory-name) s-buf>size 0= IF
	    s" ./" (current-directory-name) s-buf-cat	\ does not work right
\	    s" ~+/" (current-directory-name) s-buf-cat	\ does not work either
	THEN ;

: open-directory ( addr count -- flag )
    2dup open-dir	( c_addr u wdirid wior )
    0= >r		( c_addr u wdirid   r: flag )
    r@ IF
	(current-directory) !
	(current-directory-name)  dup s-buf-clear  s-buf-cat
	normalize-current-dir-name
    ELSE
	drop 2drop
    THEN
    r> ;

file-names-length# S-BUF: (next-filename)
: read-dir-next ( -- addr count true | false )
    file-names-length# stringbuf-open >r
    r@ buffer-pointer 2@  drop file-names-length#  (current-directory) @
    read-dir
    ABORT" read-dir-next: Couldn't read-dir."
    IF
	r@ handle>stringbuf-descriptor >stringbuf-count !	\ store count
	(next-filename) >r r@ s-buf-clear
	(current-directory-name) s-buf>string r> s-buf-cat
	r> buffer-as-string (next-filename) s-buf-cat
	(next-filename) s-buf>string
	TRUE
    ELSE
	rdrop drop FALSE
    THEN ;

: close-current-dir ( -- )
    (current-directory) @ close-dir
    ABORT" close-current-dir: Couldn't close-dir." ;

[IFUNDEF] MENU:		include menu-0.3.fs		[THEN]
MENU: fileselect-men

: n'th-file-name ( n -- addr count true )
[ true ] [IF] \ close and open again
    close-current-dir						\ close
    (current-directory-name) s-buf>string open-directory	\ and re-open
    0= ABORT" n'th-file-name: Couldn't (re)open-dir."
[ELSE] \ reposition-file does not seam to work with directories. ########
    0 (current-directory) @ reposition-file
    0= ABORT" n'th-file-name: Couldn't reposition-file."
[THEN]
    >r 0 0	( dummy dummy   r: n )
    r> 0 DO
	2drop
	read-dir-next
	0= ABORT" n'th-file-name: Couldn't read-dir."
    LOOP
    true ;

: is-directory? ( addr count -- flag )
    open-dir 0=
    dup IF
	swap close-dir
	ABORT" is-directory?: Couldn't close-dir."
    ELSE
	nip
    THEN ;

: open-n'th-directory ( n -- )
    normalize-current-dir-name
    n'th-file-name
    0= ABORT" open-n'th-directory: File isn't a directory."
    open-directory
    0= ABORT" open-n'th-directory: Couldn't open-directory" ;

&256 S-BUF: (title)
: .fileselect-menu ( -- )
    page  (title) s-buf>string type cr

    0 >r
    BEGIN
	read-dir-next
    WHILE
	r@  last-line  /   c-l 3 /   *	\ 3 colomns
	r@  last-line  mod  1+
	at-xy
	r> 1+ dup >r  >stack
	2dup is-directory? IF
	    ['] open-n'th-directory   redisplay	menu-entry
	    [char] / emit
	ELSE
	    ['] n'th-file-name   menu-done	menu-entry
	THEN
    REPEAT rdrop

    s" z" ['] bye			menu-key-entry
[IFDEF] do-FORTH
    s" !" ['] do-FORTH redisplay	menu-key-entry
[THEN]
    s" qQ" menu-done ['] false		menu-key-entry
[IFDEF] .menu-short-help	.menu-short-help [THEN]
;

: fileselect-menu ( addr-title count-title -- addr count true | false)
    (title)  dup s-buf-clear  s-buf-cat

    fileselect-men
    ['] .fileselect-menu menu-display-xt !
    menu-done	['] false	menu-key-default
    menu-done	['] false	menu-default
    do-menu-loop
    free-menus ;

false [if]
: t
    s" OUTPUT/tmp" open-directory IF cr
	s" Select a file:" fileselect-menu
	page
	IF   ." selected: " type  ELSE  ." no selection."  THEN 2000 ms cr
	close-current-dir
    ELSE 7 emit THEN ; t
[then]
