\ ###################### WORK IN PROGRESS ############### ;-)

\ stacked-variables.fs

\ Stacked variables are a mixture between variables and stacks.
\ They are used basically like ordinary variables.
\ If they are 'pushed' a new address will become visible
\ and the old one can be 'popped' later on.
\ This makes it possible to use these variables in reentrant code.

\ static version should survive savesystem (not tested)
\ dynamic version
create DYNAMIC-STATIC-VARIABLES		\ comment or uncomment as desired

0
OFFSET: >stacked-var-actual
OFFSET: >stacked-var-items#
OFFSET: >stacked-var-pointer
CONSTANT stacked-var-descriptors-items

[ifdef] DYNAMIC-STATIC-VARIABLES	\ dynamic version

: stacked-variable: ( items -- )
    CREATE
	-1 ,	\ actual
	,	\ items
	0 ,	\ pointer off
    DOES>
	>r
	r@ >stacked-var-pointer @ 0= IF	\ first time: initialize descriptor
	    r@ >stacked-var-items# stacked-var-descriptors-items * cells dup
	    allocate
	    ABORT" stacked-variable: Couldn't allocate descriptor."
	    dup r@ >stacked-var-pointer !
	    swap erase
	THEN

	r@ >stacked-var-pointer @	\ start of data stored
	r@ >stacked-var-actual @	\ actual
	[ stacked-var-descriptors-items cells ] literal	*  \ * descriptor size
	+ @
    ;

: (push-stacked-var) ( body-addr -- )
    dup 2@ 1-
    = ABORT" too many items in stacked variable."
    cell+ 1 swap +! ;

[else]	\ static version

: stacked-variable: ( items -- )
    CREATE
	dup ,		\ how many items
	-1 ,		\ actual item
	cells allot
    DOES>
	cell+ dup @
	dup -1 = ABORT" stacked-variable not initialized"
	1+ cells + ;

: (push-stacked-var) ( body-addr -- )
    dup 2@ 1-
    = ABORT" too many items in stacked variable."
    cell+ 1 swap +! ;

: push-stacked-var
    bl word find
    IF >body
	state @ IF
	    POSTPONE literal POSTPONE (push-stacked-var)
	ELSE
	    (push-stacked-var)
	THEN
    ELSE drop THEN ; IMMEDIATE

: (pop-stacked-var) ( body-addr -- )
    cell+
    dup @ 0< ABORT" Pop-stacked-var: stacked variable was not pushed."
    -1 swap +! ;

: pop-stacked-var
    bl word find
    IF >body
	state @ IF
	    POSTPONE literal POSTPONE (pop-stacked-var)
	ELSE
	    (pop-stacked-var)
	THEN
    ELSE drop THEN ; IMMEDIATE

false [if]
10 stacked-variable: testvar

: t push-stacked-var testvar
    dup testvar !
    testvar @ cr .
    1+
    dup 10 < IF recurse THEN
    testvar @ cr .
    pop-stacked-var testvar ;
0 t drop
[then]
