\ statistics.fs
\ 	$Id: statistics.fs,v 1.14 2001/02/15 16:11:42 f Exp $	
decimal

false					\ true for testing, false otherwise

\ words to break down integer data to show a ascii graf of it.

[UNDEFINED] offset: [IF]	include basics.fs			[THEN]
0
OFFSET: >statistics-slices#
OFFSET: >statistics-data-range-min
OFFSET: >statistics-data-range
dup cells CONSTANT statistics-descriptor-length#
OFFSET: >statistics-data	drop	\ start of slice counters

\ after the slice counters array there's space for vertical index-boundaries
\  : >vertical-boundaries ( addr -- start-of-vertical-index-boundaries-array )
\      dup >statistics-data			\ start of slice counters
\      swap >statistics-slices# @ cells + ;	\ skip slice counters array

: statistic-array-size ( slices# -- size )
    cells 2* statistics-descriptor-length# + ;

: n'th-slice-counter ( n array-addr -- n'th-count-addr )
    >statistics-data  swap cells + ;

\  : n'th-vertical-boundary ( n array-addr -- n'th-vertical-boundary-addr )
\      >vertical-boundaries  swap cells + ;

: n'th-vertical-boundary ( n array-addr -- n'th-vertical-boundary-addr )
    tuck
    n'th-slice-counter
    swap >statistics-slices# @ cells + ;

\ Word called before reading in data's. Range of data must be known.
: init-statistic-array ( min max slices# addr -- )
    >r					( min max slices#   r:addr )
    r@ over statistic-array-size erase				\ erase all
    r@ >statistics-slices# !		( min max   r:addr )	\ set slices#
    over -							\ real range

    \ if range is smaller than screen width we take a one to one relationship
    c-l max							\ actual range

    r@ >statistics-data-range !					\ store range
    r> >statistics-data-range-min ! ;				\ store min 

\ word to count data within slices
\ new version gathering data out of range in border slices
variable data-out-of-range		\ counts data out of range
: data2slice ( data addr -- )
    >r					( data   r: addr )
    r@ >statistics-data-range-min @ -	( data-off-from-min     r: addr )
    r@ >statistics-slices# @  ( 1+ )	( data' slices#+1        r: addr )
    r@ >statistics-data-range @	1+	( data' slices#+1 range  r: addr )
    */					( slice-OK   r: addr )

\ old version. code left here for tests
\      dup 0< ABORT" data2slice: data below range"
\      dup r@ >statistics-slices# @ > ABORT" data2slice: data out of range"

    dup 0< IF
	1 data-out-of-range +!
	drop 0
    THEN
    dup r@ >statistics-slices# @ > IF
	1 data-out-of-range +!
	drop
	r@ >statistics-slices# @
    THEN

    r> n'th-slice-counter
    1 swap +! ;			\ increase count of data in this slice

\ words to determine max and min of a series of values at a double cell at addr
\ 2VARIABLE (min&max)		\ (min&max) 2@ gives ( -- min max )
0
OFFSET: >max
OFFSET: >min	drop

: min-max-init ( 2addr -- )
    >r
    lowest-integer#  r@ >max !
    highest-integer# r> >min ! ;

: data2min-max ( n 2addr -- )
    >r
    dup r@ >max @ max r@ >max !
    r> >min dup @ rot min swap ! ;

\ sometimes we want a steady zoom
defer <notify-zoom-change>
defer <vertical-zoom-scale>
defer <vertical-display-range>
1 constant horizontal
2 constant vertical
: vertical-zoom-control ( range -- display-range )
    >r

    <vertical-display-range> @			( displayed-range r: range )
    dup IF					\ initialized?
	dup r@ < IF					\ big enough?
	    r@ <vertical-display-range> !		\ take real size
	    vertical <notify-zoom-change>
	THEN

	r@ swap <vertical-zoom-scale> 2@ */  < IF	\ too small!
	    r@ <vertical-display-range> !		\ take real size
	    vertical <notify-zoom-change>
	THEN
    ELSE					\ was not initialized
	r@ <vertical-display-range> !			\ take real size
	\ vertical <notify-zoom-change>
	drop
    THEN

    rdrop
    <vertical-display-range> @ ;

\ after reading data in, we set up vertical slices
\ note that the slices count is off by one, so the status line will fit too.
: statistic-slice-up-vertical ( vertical-slices addr -- max-slice-count )
    >r				( slices#   r: addr )
    r@ >statistics-slices# @ cells swap	( record-size slices#   r: addr )

    \ get maximal count:
    lowest-integer#
    r@ >statistics-data				\ lower loop limit
    dup r@ >statistics-slices# @ cells +	\ upper loop limit
    swap 2dup 2>r				\ preserve loop limits
    ?DO	( record slices# actual-maximal-slice-count )
	i @ max					\ loop over counters, max
    cell +LOOP
    \	( record slices# maximal-slice-count   r: addr 2loop-limits )


    \ if max-count is less than the number of slices, we count one to one:
    over max

    \ sometimes we want a steady zoom
    vertical-zoom-control			\ handle zoom

    2r> ?DO ( record-size slices# max-slice-count )
	2dup i @ ( size slices# max slices# max-slice-count slice-count)
	swap */	 ( size slices# max-slice-count slice-OK )
	i 4 pick + !				\ store y boundary index
    cell +LOOP

    rdrop >r 2drop r> ;

[UNDEFINED] (zoomed) [IF]	variable (zoomed)	(zoomed) off	[THEN]

\ bar grafic display of 'lines' lines including status line.
\ set cursor before calling it.
: statistic-display ( addr lines addr-of-title count-of-title -- )
    2>r			( addr lines  r: addr-of-title count-of-title )
    2dup swap statistic-slice-up-vertical >r
    \			( addr lines  r: a-title c-title max-slice-count )

    0 swap 2 - DO
	c-l 0 DO
	    i over n'th-vertical-boundary @ j > IF
		[char] *
	    ELSE
		bl

		\ in the last row, we want to show if there's something or not:
		j 0= IF					\ last row?
		    i  2 pick  n'th-slice-counter @ IF	\ something there?
			drop [char] .
		    THEN
		THEN
	    THEN emit
	LOOP
    -1 +LOOP

    \ print range
    cr at?  clear-line-to-end  at-xy			\ clean display
    dup >statistics-data-range-min @
    dup highest-integer# = IF
	." No data."
	drop
	(zoomed) off	\ cosmetics
    ELSE
	dup .
	over >statistics-data-range @ + num>string dup c-l swap -
	[ lower-right-scrolls ] [IF]  1-  [THEN]
	at-x type
	\ this would be the logical place to display zoom change, but this
	\ gives problems with colors, if foreground color is not default
	\ &52 at-x ." vertical max: " r@ .		\ vertical maximum
	[ decimal ] 52 at-x ." vertical range: "
	<vertical-display-range> @ .			\ vertical range
    THEN rdrop drop
    [ decimal ] 12 at-x ." scanning: " 2r> type

    (zoomed) @ dup IF			\ show if zoom has changed. (see above)
	cyan color-foreground
	dup horizontal and IF
	    c-l 2/ 5 - at-x ." -"
	THEN
	c-l 2/ 4 - at-x ." <zooming>
	dup vertical and IF
	    c-l 2/ 5 + at-x ." |"
	THEN
	\ default-color color-foreground	\ default-color is not portable
	reset-default-colors			\ encapsulating default-color
	(zoomed) off
    THEN drop ;

[IF]
    include lists.fs
    include random.fs
\      include stringbuf-0.3.fs
\      &10000 cells S-BUF: (data)
    2VARIABLE (min&max)           \ (min&max) 2@ gives ( -- min max )

    defer <data>
2variable vertical-zoom-scale	     1 4 vertical-zoom-scale 2!
' vertical-zoom-scale is <vertical-zoom-scale>
variable (vertical-display-range)    (vertical-display-range) off
' (vertical-display-range) is <vertical-display-range>

: t
    c-l statistic-array-size ( slices# -- size )
    allocate drop >r

    (min&max) min-max-init
\    (data) s-buf-clear
    c-l 0 DO i <data> (min&max) data2min-max LOOP
(min&max) 2@ . . key drop
    (min&max) 2@ c-l r@ init-statistic-array

    r@
    c-l 0 DO
	i <data> over data2slice
    LOOP
    drop

    r@ l-s 1- s" test data." statistic-display
    r> free drop ;

\	c-l random-ranged
\	over data2slice

\	0 over data2slice
\	c-l 2/ over data2slice
\	c-l over data2slice

:NONAME c-l 2/ - ; IS <data>
:NONAME c-l 2/ - ; IS <data>
:NONAME dup c-l 3 / MOD - ; IS <data>
:NONAME drop 0 ; IS <data>
:NONAME ; IS <data>

t
\ (data) s-buf-close
key drop \ bye

[THEN]
