\ system-dependent.fs
\ 	$Id: system-dependent.fs,v 1.10 2001/01/15 20:38:52 f Exp $	
\ switch system dependent behaviour
\ this comes *before* compile time options. See 'compile-options.fs'.


\ variable forth-system
\ 1 CONSTANT gforth
\ 2 CONSTANT bigforth

\ symmetric division
s" floored" environment? drop [IF]
    cr .( Using symmetric division 'sm/rem' for '/' )
    : /   >r s>d r> sm/rem nip ;
[ELSE]
\      \ very likely to fail...
\      cr .( Using floored division 'fm/mod' for '/' )
\      : /   >r s>d r> fm/mod nip ;
[THEN]


\ check for different FORTHs:

s" gforth" environment? [IF]
    cr .( running on: Gforth ) type cr
    include gforth.fs

[ELSE] s" bigFORTH" environment? [IF]
    cr .( we're running bigFORTH ) . 8 emit char . emit . cr	\ version nr 
    cr .( buggy... )
    include bigFORTH.fs

[ELSE] s" PFE-DEBUG" environment? [IF] drop
    cr .( we're running 'PFE' )
    include pfe.fs

[ELSE] s" IFORTH" ENVIRONMENT? [IF] drop
    cr .( we're running iForth )
    cr .( not working yet... )
    include iForth.fs 	\ Thanks to Marcel Hendrix

[ELSE]
    cr .( Running a FORTH system, brew was not adapted for. )
    cr .( Please report success or failure.  Thank you. )
    cr

[THEN] [THEN] [THEN] [THEN]
\ FORTH system specific issues done.


\ cell size:
1 cells 4 = [IF]
    base @ hex
    -80000000 constant lowest-integer#
    7FFFFFFF  constant highest-integer#
    base !
[ELSE]
    7 emit
    cr .( Please define lowest-integer# and highest-integer# in 'system-dependent.fs')
    cr 5000 ms
[THEN]


\ check for some definitions:

[UNDEFINED] xt>name [IF]
    7 emit
    cr .( file system-dependent.fs:  Please define   xt>name )
    char ( emit
    .(  xt -- addr length )
    char ) emit
    cr .(                            You send me a copy for your system? )
    8000 ms cr
[THEN]

[UNDEFINED] see [IF]
    7 emit
    cr .( File system-dependent.fs:  Please do define   SEE )
    cr
    cr .( `see'       <spaces>name )
    char ( emit  .(  -- )  char ) emit
    cr .( Locate NAME using the current search order. Display the definition of NAME.)
    cr .( Coming brew versions might not need 'see' any more, this one does. )
    cr
    8000 ms
[THEN]
