GROUP( control)
LABEL(noop): /* noop ( -- ) */
/*  */
NAME("noop")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 141 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(lit): /* lit ( #w -- w ) */
/*  */
NAME("lit")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2w(IPTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
INC_IP(1);
sp += -1;
{
#line 145 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(execute): /* execute ( xt -- ) */
/* Perform the semantics represented by the execution token, @i{xt}. */
NAME("execute")
{
DEF_CA
Xt xt;
NEXT_P0;
vm_Cell2xt(spTOS,xt);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
sp += 1;
{
#line 150 "./prim"
ip=IP;
IF_spTOS(spTOS = sp[0]);
SUPER_END;
EXEC(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(perform): /* perform ( a_addr -- ) */
/* @code{@@ execute}. */
NAME("perform")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 157 "./prim"
/* and pfe */
ip=IP;
IF_spTOS(spTOS = sp[0]);
SUPER_END;
EXEC(*(Xt *)a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(branch_lp_plus_store_number): /* branch-lp+!# ( #ndisp #nlocals -- ) */
/*  */
NAME("branch-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
}
#endif
INC_IP(2);
{
#line 169 "./prim"
/* this will probably not be used */
lp += nlocals;
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

#endif
LABEL(branch): /* branch ( #ndisp -- ) */
/*  */
NAME("branch")
{
DEF_CA
Cell ndisp;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
INC_IP(1);
{
#line 176 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(question_branch): /* ?branch ( #ndisp f -- ) */
/*  */
NAME("?branch")
{
DEF_CA
Cell ndisp;
Bool f;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2f(spTOS,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(1);
sp += 1;
{
#line 209 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(question_branch_lp_plus_store_number): /* ?branch-lp+!# ( #ndisp #nlocals f -- ) */
/*  */
NAME("?branch-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Bool f;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
vm_Cell2f(spTOS,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(2);
sp += 1;
{
#line 209 "./prim"
if (f==0) {
#line 209
    lp += nlocals;
#line 209
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 209
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
#ifdef HAS_XCONDS
LABEL(question_dupe_question_branch): /* ?dup-?branch ( #ndisp f -- f ) */
/* The run-time procedure compiled by @code{?DUP-IF}. */
NAME("?dup-?branch")
{
DEF_CA
Cell ndisp;
Bool f;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2f(spTOS,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(1);
{
#line 218 "./prim"
if (f==0) {
  sp++;
  IF_spTOS(spTOS = sp[0]);
  SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
  SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(question_dupe_zero_equals_question_branch): /* ?dup-0=-?branch ( #ndisp f -- ) */
/* The run-time procedure compiled by @code{?DUP-0=-IF}. */
NAME("?dup-0=-?branch")
{
DEF_CA
Cell ndisp;
Bool f;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2f(spTOS,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
INC_IP(1);
sp += 1;
{
#line 228 "./prim"
/* the approach taken here of declaring the word as having the stack
effect ( f -- ) and correcting for it in the branch-taken case costs a
few cycles in that case, but is easy to convert to a CONDBRANCH
invocation */
if (f!=0) {
  sp--;
  SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
  NEXT;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
LABEL(paren_next): /* (next) ( #ndisp R:n1 -- R:n2 ) */
/*  */
NAME("(next)")
{
DEF_CA
Cell ndisp;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
{
#line 248 "./prim"
n2=n1-1;
#line 248
if (n1) {
#line 248
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 248
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;
#line 248
}
#line 248
SUPER_CONTINUE;
#line 248
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(paren_next_lp_plus_store_number): /* (next)-lp+!# ( #ndisp #nlocals R:n1 -- R:n2 ) */
/*  */
NAME("(next)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
{
#line 248 "./prim"
n2=n1-1;
#line 248
if (n1) {
#line 248
    lp += nlocals;
#line 248
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 248
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;
#line 248
}
#line 248
SUPER_CONTINUE;
#line 248
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;}

#endif
LABEL(paren_loop): /* (loop) ( #ndisp R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(loop)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
{
#line 256 "./prim"
n2=n1+1;
#line 256
if (n2 != nlimit) {
#line 256
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 256
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;
#line 256
}
#line 256
SUPER_CONTINUE;
#line 256
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(paren_loop_lp_plus_store_number): /* (loop)-lp+!# ( #ndisp #nlocals R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
{
#line 256 "./prim"
n2=n1+1;
#line 256
if (n2 != nlimit) {
#line 256
    lp += nlocals;
#line 256
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 256
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;
#line 256
}
#line 256
SUPER_CONTINUE;
#line 256
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
NEXT_P2;}

#endif
LABEL(paren_plus_loop): /* (+loop) ( #ndisp n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(+loop)")
{
DEF_CA
Cell ndisp;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(spTOS,n);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
sp += 1;
{
#line 272 "./prim"
/* !! check this thoroughly */
#line 272
/* sign bit manipulation and test: (x^y)<0 is equivalent to (x<0) != (y<0) */
#line 272
/* dependent upon two's complement arithmetic */
#line 272
Cell olddiff = n1-nlimit;
#line 272
n2=n1+n;	
#line 272
if ((olddiff^(olddiff+n))>=0   /* the limit is not crossed */
#line 272
    || (olddiff^n)>=0          /* it is a wrap-around effect */) {
#line 272
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 272
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 272
}
#line 272
SUPER_CONTINUE;
#line 272
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(paren_plus_loop_lp_plus_store_number): /* (+loop)-lp+!# ( #ndisp #nlocals n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(+loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
vm_Cell2n(spTOS,n);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
sp += 1;
{
#line 272 "./prim"
/* !! check this thoroughly */
#line 272
/* sign bit manipulation and test: (x^y)<0 is equivalent to (x<0) != (y<0) */
#line 272
/* dependent upon two's complement arithmetic */
#line 272
Cell olddiff = n1-nlimit;
#line 272
n2=n1+n;	
#line 272
if ((olddiff^(olddiff+n))>=0   /* the limit is not crossed */
#line 272
    || (olddiff^n)>=0          /* it is a wrap-around effect */) {
#line 272
    lp += nlocals;
#line 272
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 272
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 272
}
#line 272
SUPER_CONTINUE;
#line 272
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
#ifdef HAS_XCONDS
LABEL(paren_minus_loop): /* (-loop) ( #ndisp u R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(-loop)")
{
DEF_CA
Cell ndisp;
UCell u;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2u(spTOS,u);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" u=", vm_out); printarg_u(u);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
sp += 1;
{
#line 280 "./prim"
UCell olddiff = n1-nlimit;
#line 280
n2=n1-u;
#line 280
if (olddiff>u) {
#line 280
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 280
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 280
}
#line 280
SUPER_CONTINUE;
#line 280
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(paren_minus_loop_lp_plus_store_number): /* (-loop)-lp+!# ( #ndisp #nlocals u R:nlimit R:n1 -- R:nlimit R:n2 ) */
/*  */
NAME("(-loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
UCell u;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
vm_Cell2u(spTOS,u);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" u=", vm_out); printarg_u(u);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
sp += 1;
{
#line 280 "./prim"
UCell olddiff = n1-nlimit;
#line 280
n2=n1-u;
#line 280
if (olddiff>u) {
#line 280
    lp += nlocals;
#line 280
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 280
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 280
}
#line 280
SUPER_CONTINUE;
#line 280
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
LABEL(paren_symmetric_plus_loop): /* (s+loop) ( #ndisp n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/* The run-time procedure compiled by S+LOOP. It loops until the index
crosses the boundary between limit and limit-sign(n). I.e. a symmetric
version of (+LOOP). */
NAME("(s+loop)")
{
DEF_CA
Cell ndisp;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(spTOS,n);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(1);
sp += 1;
{
#line 295 "./prim"
/* !! check this thoroughly */
#line 295
Cell diff = n1-nlimit;
#line 295
Cell newdiff = diff+n;
#line 295
if (n<0) {
#line 295
    diff = -diff;
#line 295
    newdiff = -newdiff;
#line 295
}
#line 295
n2=n1+n;
#line 295
if (diff>=0 || newdiff<0) {
#line 295
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 295
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 295
}
#line 295
SUPER_CONTINUE;
#line 295
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_GLOCALS
LABEL(paren_symmetric_plus_loop_lp_plus_store_number): /* (s+loop)-lp+!# ( #ndisp #nlocals n R:nlimit R:n1 -- R:nlimit R:n2 ) */
/* The run-time procedure compiled by S+LOOP. It loops until the index
crosses the boundary between limit and limit-sign(n). I.e. a symmetric
version of (+LOOP). */
NAME("(s+loop)-lp+!#")
{
DEF_CA
Cell ndisp;
Cell nlocals;
Cell n;
Cell nlimit;
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(IP[1],nlocals);
vm_Cell2n(spTOS,n);
vm_Cell2n(rp[1],nlimit);
vm_Cell2n(rpTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlocals=", vm_out); printarg_n(nlocals);
fputs(" n=", vm_out); printarg_n(n);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
INC_IP(2);
sp += 1;
{
#line 295 "./prim"
/* !! check this thoroughly */
#line 295
Cell diff = n1-nlimit;
#line 295
Cell newdiff = diff+n;
#line 295
if (n<0) {
#line 295
    diff = -diff;
#line 295
    newdiff = -newdiff;
#line 295
}
#line 295
n2=n1+n;
#line 295
if (diff>=0 || newdiff<0) {
#line 295
    lp += nlocals;
#line 295
SET_IP((Xt *)(((Cell)(IP-2))+ndisp));
#line 295
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 295
}
#line 295
SUPER_CONTINUE;
#line 295
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
#endif
LABEL(unloop): /* unloop ( R:w1 R:w2 -- ) */
/*  */
NAME("unloop")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(rp[1],w1);
vm_Cell2w(rpTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
rp += 2;
{
#line 300 "./prim"
/* !! alias for 2rdrop */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(paren_for): /* (for) ( ncount -- R:nlimit R:ncount ) */
/*  */
NAME("(for)")
{
DEF_CA
Cell ncount;
Cell nlimit;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(spTOS,ncount);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ncount=", vm_out); printarg_n(ncount);
}
#endif
sp += 1;
rp += -2;
{
#line 305 "./prim"
/* or (for) = >r -- collides with unloop! */
nlimit=0;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(ncount,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(paren_do): /* (do) ( nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(do)")
{
DEF_CA
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(sp[1],nlimit);
vm_Cell2n(spTOS,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
sp += 2;
rp += -2;
{
#line 311 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(paren_question_do): /* (?do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(?do)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(sp[1],nlimit);
vm_Cell2n(spTOS,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 315 "./prim"
if (nstart == nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_XCONDS
LABEL(paren_plus_do): /* (+do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(+do)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(sp[1],nlimit);
vm_Cell2n(spTOS,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 331 "./prim"
if (nstart >= nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(paren_u_plus_do): /* (u+do) ( #ndisp ulimit ustart -- R:ulimit R:ustart ) */
/*  */
NAME("(u+do)")
{
DEF_CA
Cell ndisp;
UCell ulimit;
UCell ustart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(IPTOS,ndisp);
vm_Cell2u(sp[1],ulimit);
vm_Cell2u(spTOS,ustart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" ulimit=", vm_out); printarg_u(ulimit);
fputs(" ustart=", vm_out); printarg_u(ustart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 347 "./prim"
if (ustart >= ulimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(ulimit,rp[1]);
vm_u2Cell(ustart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(ulimit,rp[1]);
vm_u2Cell(ustart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(paren_minus_do): /* (-do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
/*  */
NAME("(-do)")
{
DEF_CA
Cell ndisp;
Cell nlimit;
Cell nstart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(IPTOS,ndisp);
vm_Cell2n(sp[1],nlimit);
vm_Cell2n(spTOS,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 363 "./prim"
if (nstart <= nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nlimit,rp[1]);
vm_n2Cell(nstart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(paren_u_minus_do): /* (u-do) ( #ndisp ulimit ustart -- R:ulimit R:ustart ) */
/*  */
NAME("(u-do)")
{
DEF_CA
Cell ndisp;
UCell ulimit;
UCell ustart;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2n(IPTOS,ndisp);
vm_Cell2u(sp[1],ulimit);
vm_Cell2u(spTOS,ustart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" ulimit=", vm_out); printarg_u(ulimit);
fputs(" ustart=", vm_out); printarg_u(ustart);
}
#endif
INC_IP(1);
sp += 2;
rp += -2;
{
#line 379 "./prim"
if (ustart <= ulimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(ulimit,rp[1]);
vm_u2Cell(ustart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(ulimit,rp[1]);
vm_u2Cell(ustart,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
LABEL(i): /* i ( R:n -- R:n n ) */
/*  */
NAME("i")
{
DEF_CA
Cell n;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2n(rpTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += -1;
{
#line 400 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(i_tick): /* i' ( R:w R:w2 -- R:w R:w2 w ) */
/*  */
NAME("i'")
{
DEF_CA
Cell w;
Cell w2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2w(rp[1],w);
vm_Cell2w(rpTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -1;
{
#line 405 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(j): /* j ( R:n R:d1 -- n R:n R:d1 ) */
/*  */
NAME("j")
{
DEF_CA
Cell n;
DCell d1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2n(rp[2],n);
vm_twoCell2d((Cell)rp[1], (Cell)rpTOS, d1)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
sp += -1;
{
#line 411 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
vm_d2twoCell(d1, rp[1], rpTOS)
NEXT_P2;}

LABEL(k): /* k ( R:n R:d1 R:d2 -- n R:n R:d1 R:d2 ) */
/*  */
NAME("k")
{
DEF_CA
Cell n;
DCell d1;
DCell d2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2n(rp[4],n);
vm_twoCell2d((Cell)rp[3], (Cell)rp[2], d1)
vm_twoCell2d((Cell)rp[1], (Cell)rpTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += -1;
{
#line 417 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
vm_d2twoCell(d1, rp[3], rp[2])
vm_d2twoCell(d2, rp[1], rpTOS)
NEXT_P2;}

GROUP( strings)
LABEL(move): /* move ( c_from c_to ucount -- ) */
/* Copy the contents of @i{ucount} aus at @i{c-from} to
@i{c-to}. @code{move} works correctly even if the two areas overlap. */
NAME("move")
{
DEF_CA
Char * c_from;
Char * c_to;
UCell ucount;
NEXT_P0;
vm_Cell2c_(sp[2],c_from);
vm_Cell2c_(sp[1],c_to);
vm_Cell2u(spTOS,ucount);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
sp += 3;
{
#line 431 "./prim"
/* !! note that the standard specifies addr, not c-addr */
memmove(c_to,c_from,ucount);
/* make an Ifdef for bsd and others? */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(c_move): /* cmove ( c_from c_to u -- ) */
/* Copy the contents of @i{ucount} characters from data space at
@i{c-from} to @i{c-to}. The copy proceeds @code{char}-by-@code{char}
from low address to high address; i.e., for overlapping areas it is
safe if @i{c-to}=<@i{c-from}. */
NAME("cmove")
{
DEF_CA
Char * c_from;
Char * c_to;
UCell u;
NEXT_P0;
vm_Cell2c_(sp[2],c_from);
vm_Cell2c_(sp[1],c_to);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
{
#line 442 "./prim"
while (u-- > 0)
  *c_to++ = *c_from++;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(c_move_up): /* cmove> ( c_from c_to u -- ) */
/* Copy the contents of @i{ucount} characters from data space at
@i{c-from} to @i{c-to}. The copy proceeds @code{char}-by-@code{char}
from high address to low address; i.e., for overlapping areas it is
safe if @i{c-to}>=@i{c-from}. */
NAME("cmove>")
{
DEF_CA
Char * c_from;
Char * c_to;
UCell u;
NEXT_P0;
vm_Cell2c_(sp[2],c_from);
vm_Cell2c_(sp[1],c_to);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
{
#line 452 "./prim"
while (u-- > 0)
  c_to[u] = c_from[u];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fill): /* fill ( c_addr u c -- ) */
/* Store @i{c} in @i{u} chars starting at @i{c-addr}. */
NAME("fill")
{
DEF_CA
Char * c_addr;
UCell u;
Char c;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2c(spTOS,c);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c=", vm_out); printarg_c(c);
}
#endif
sp += 3;
{
#line 461 "./prim"
memset(c_addr,c,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(compare): /* compare ( c_addr1 u1 c_addr2 u2 -- n ) */
/* Compare two strings lexicographically. If they are equal, @i{n} is 0; if
the first string is smaller, @i{n} is -1; if the first string is larger, @i{n}
is 1. Currently this is based on the machine's character
comparison. In the future, this may change to consider the current
locale and its collation order. */
NAME("compare")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
Cell n;
NEXT_P0;
vm_Cell2c_(sp[3],c_addr1);
vm_Cell2u(sp[2],u1);
vm_Cell2c_(sp[1],c_addr2);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 3;
{
#line 472 "./prim"
/* close ' to keep fontify happy */ 
n = memcmp(c_addr1, c_addr2, u1<u2 ? u1 : u2);
if (n==0)
  n = u1-u2;
if (n<0)
  n = -1;
else if (n>0)
  n = 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(dash_text): /* -text ( c_addr1 u c_addr2 -- n ) */
/*  */
NAME("-text")
{
DEF_CA
Char * c_addr1;
UCell u;
Char * c_addr2;
Cell n;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr1);
vm_Cell2u(sp[1],u);
vm_Cell2c_(spTOS,c_addr2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
}
#endif
sp += 2;
{
#line 487 "./prim"
n = memcmp(c_addr1, c_addr2, u);
if (n<0)
  n = -1;
else if (n>0)
  n = 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(toupper): /* toupper ( c1 -- c2 ) */
/* If @i{c1} is a lower-case character (in the current locale), @i{c2}
is the equivalent upper-case character. All other characters are unchanged. */
NAME("toupper")
{
DEF_CA
Char c1;
Char c2;
NEXT_P0;
vm_Cell2c(spTOS,c1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c1=", vm_out); printarg_c(c1);
}
#endif
{
#line 502 "./prim"
c2 = toupper(c1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c2=", vm_out); printarg_c(c2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c2Cell(c2,spTOS);
NEXT_P2;}

LABEL(capscomp): /* capscomp ( c_addr1 u c_addr2 -- n ) */
/*  */
NAME("capscomp")
{
DEF_CA
Char * c_addr1;
UCell u;
Char * c_addr2;
Cell n;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr1);
vm_Cell2u(sp[1],u);
vm_Cell2c_(spTOS,c_addr2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
}
#endif
sp += 2;
{
#line 507 "./prim"
n = memcasecmp(c_addr1, c_addr2, u); /* !! use something that works in all locales */
if (n<0)
  n = -1;
else if (n>0)
  n = 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(dash_trailing): /* -trailing ( c_addr u1 -- c_addr u2 ) */
/* Adjust the string specified by @i{c-addr, u1} to remove all trailing
spaces. @i{u2} is the length of the modified string. */
NAME("-trailing")
{
DEF_CA
Char * c_addr;
UCell u1;
UCell u2;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
{
#line 522 "./prim"
u2 = u1;
while (u2>0 && c_addr[u2-1] == ' ')
  u2--;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(slash_string): /* /string ( c_addr1 u1 n -- c_addr2 u2 ) */
/* Adjust the string specified by @i{c-addr1, u1} to remove @i{n}
characters from the start of the string. */
NAME("/string")
{
DEF_CA
Char * c_addr1;
UCell u1;
Cell n;
Char * c_addr2;
UCell u2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr1);
vm_Cell2u(sp[1],u1);
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 532 "./prim"
c_addr2 = c_addr1+n;
u2 = u1-n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr2,sp[1]);
vm_u2Cell(u2,spTOS);
NEXT_P2;}

GROUP( arith)
LABEL(plus): /* + ( n1 n2 -- n ) */
/*  */
NAME("+")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 540 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(under_plus): /* under+ ( n1 n2 n3 -- n n2 ) */
/* add @i{n3} to @i{n1} (giving @i{n}) */
NAME("under+")
{
DEF_CA
Cell n1;
Cell n2;
Cell n3;
Cell n;
NEXT_P0;
vm_Cell2n(sp[2],n1);
vm_Cell2n(sp[1],n2);
vm_Cell2n(spTOS,n3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
fputs(" n3=", vm_out); printarg_n(n3);
}
#endif
sp += 1;
{
#line 545 "./prim"
n = n1+n3;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,sp[1]);
IF_spTOS(vm_n2Cell(n2,spTOS););
NEXT_P2;}

LABEL(minus): /* - ( n1 n2 -- n ) */
/*  */
NAME("-")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 550 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(negate): /* negate ( n1 -- n2 ) */
/*  */
NAME("negate")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 555 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(one_plus): /* 1+ ( n1 -- n2 ) */
/*  */
NAME("1+")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 561 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(one_minus): /* 1- ( n1 -- n2 ) */
/*  */
NAME("1-")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 566 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(max): /* max ( n1 n2 -- n ) */
/*  */
NAME("max")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 571 "./prim"
if (n1<n2)
  n = n2;
else
  n = n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(min): /* min ( n1 n2 -- n ) */
/*  */
NAME("min")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 579 "./prim"
if (n1<n2)
  n = n1;
else
  n = n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(abs): /* abs ( n -- u ) */
/*  */
NAME("abs")
{
DEF_CA
Cell n;
UCell u;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 587 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u,spTOS);
NEXT_P2;}

LABEL(star): /* * ( n1 n2 -- n ) */
/*  */
NAME("*")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 595 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(slash): /* / ( n1 n2 -- n ) */
/*  */
NAME("/")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 600 "./prim"
n = n1/n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(mod): /* mod ( n1 n2 -- n ) */
/*  */
NAME("mod")
{
DEF_CA
Cell n1;
Cell n2;
Cell n;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 605 "./prim"
n = n1%n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(slash_mod): /* /mod ( n1 n2 -- n3 n4 ) */
/*  */
NAME("/mod")
{
DEF_CA
Cell n1;
Cell n2;
Cell n3;
Cell n4;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 610 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n3,sp[1]);
vm_n2Cell(n4,spTOS);
NEXT_P2;}

LABEL(two_star): /* 2* ( n1 -- n2 ) */
/* Shift left by 1; also works on unsigned numbers */
NAME("2*")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 617 "./prim"
n2 = 2*n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(two_slash): /* 2/ ( n1 -- n2 ) */
/* Arithmetic shift right by 1.  For signed numbers this is a floored
division by 2 (note that @code{/} not necessarily floors). */
NAME("2/")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 624 "./prim"
n2 = n1>>1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(f_m_slash_mod): /* fm/mod ( d1 n1 -- n2 n3 ) */
/* Floored division: @i{d1} = @i{n3}*@i{n1}+@i{n2}, @i{n1}>@i{n2}>=0 or 0>=@i{n2}>@i{n1}. */
NAME("fm/mod")
{
DEF_CA
DCell d1;
Cell n1;
Cell n2;
Cell n3;
NEXT_P0;
vm_twoCell2d((Cell)sp[2], (Cell)sp[1], d1)
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
sp += 1;
{
#line 634 "./prim"
#ifdef BUGGY_LONG_LONG
DCell r = fmdiv(d1,n1);
n2=r.hi;
n3=r.lo;
#else
/* assumes that the processor uses either floored or symmetric division */
n3 = d1/n1;
n2 = d1%n1;
/* note that this 1%-3>0 is optimized by the compiler */
if (1%-3>0 && (d1<0) != (n1<0) && n2!=0) {
  n3--;
  n2+=n1;
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputs(" n3=", vm_out); printarg_n(n3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,sp[1]);
vm_n2Cell(n3,spTOS);
NEXT_P2;}

LABEL(s_m_slash_rem): /* sm/rem ( d1 n1 -- n2 n3 ) */
/* Symmetric division: @i{d1} = @i{n3}*@i{n1}+@i{n2}, sign(@i{n2})=sign(@i{d1}) or 0. */
NAME("sm/rem")
{
DEF_CA
DCell d1;
Cell n1;
Cell n2;
Cell n3;
NEXT_P0;
vm_twoCell2d((Cell)sp[2], (Cell)sp[1], d1)
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
sp += 1;
{
#line 656 "./prim"
#ifdef BUGGY_LONG_LONG
DCell r = smdiv(d1,n1);
n2=r.hi;
n3=r.lo;
#else
/* assumes that the processor uses either floored or symmetric division */
n3 = d1/n1;
n2 = d1%n1;
/* note that this 1%-3<0 is optimized by the compiler */
if (1%-3<0 && (d1<0) != (n1<0) && n2!=0) {
  n3++;
  n2-=n1;
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputs(" n3=", vm_out); printarg_n(n3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,sp[1]);
vm_n2Cell(n3,spTOS);
NEXT_P2;}

LABEL(m_star): /* m* ( n1 n2 -- d ) */
/*  */
NAME("m*")
{
DEF_CA
Cell n1;
Cell n2;
DCell d;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 677 "./prim"
#ifdef BUGGY_LONG_LONG
d = mmul(n1,n2);
#else
d = (DCell)n1 * (DCell)n2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS)
NEXT_P2;}

LABEL(u_m_star): /* um* ( u1 u2 -- ud ) */
/*  */
NAME("um*")
{
DEF_CA
UCell u1;
UCell u2;
UDCell ud;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
{
#line 688 "./prim"
/* use u* as alias */
#ifdef BUGGY_LONG_LONG
ud = ummul(u1,u2);
#else
ud = (UDCell)u1 * (UDCell)u2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ud=", vm_out); printarg_ud(ud);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_ud2twoCell(ud, sp[1], spTOS)
NEXT_P2;}

LABEL(u_m_slash_mod): /* um/mod ( ud u1 -- u2 u3 ) */
/* ud=u3*u1+u2, u1>u2>=0 */
NAME("um/mod")
{
DEF_CA
UDCell ud;
UCell u1;
UCell u2;
UCell u3;
NEXT_P0;
vm_twoCell2ud((Cell)sp[2], (Cell)sp[1], ud)
vm_Cell2u(spTOS,u1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
sp += 1;
{
#line 706 "./prim"
#ifdef BUGGY_LONG_LONG
UDCell r = umdiv(ud,u1);
u2=r.hi;
u3=r.lo;
#else
u3 = ud/u1;
u2 = ud%u1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,sp[1]);
vm_u2Cell(u3,spTOS);
NEXT_P2;}

LABEL(m_plus): /* m+ ( d1 n -- d2 ) */
/*  */
NAME("m+")
{
DEF_CA
DCell d1;
Cell n;
DCell d2;
NEXT_P0;
vm_twoCell2d((Cell)sp[2], (Cell)sp[1], d1)
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 725 "./prim"
#ifdef BUGGY_LONG_LONG
d2.lo = d1.lo+n;
d2.hi = d1.hi - (n<0) + (d2.lo<d1.lo);
#else
d2 = d1+n;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS)
NEXT_P2;}

LABEL(d_plus): /* d+ ( d1 d2 -- d ) */
/*  */
NAME("d+")
{
DEF_CA
DCell d1;
DCell d2;
DCell d;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 2;
{
#line 735 "./prim"
#ifdef BUGGY_LONG_LONG
d.lo = d1.lo+d2.lo;
d.hi = d1.hi + d2.hi + (d.lo<d1.lo);
#else
d = d1+d2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS)
NEXT_P2;}

LABEL(d_minus): /* d- ( d1 d2 -- d ) */
/*  */
NAME("d-")
{
DEF_CA
DCell d1;
DCell d2;
DCell d;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 2;
{
#line 745 "./prim"
#ifdef BUGGY_LONG_LONG
d.lo = d1.lo - d2.lo;
d.hi = d1.hi-d2.hi-(d1.lo<d2.lo);
#else
d = d1-d2;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS)
NEXT_P2;}

LABEL(d_negate): /* dnegate ( d1 -- d2 ) */
/*  */
NAME("dnegate")
{
DEF_CA
DCell d1;
DCell d2;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d1)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
{
#line 755 "./prim"
/* use dminus as alias */
#ifdef BUGGY_LONG_LONG
d2 = dnegate(d1);
#else
d2 = -d1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS)
NEXT_P2;}

LABEL(d_two_star): /* d2* ( d1 -- d2 ) */
/* Shift left by 1; also works on unsigned numbers */
NAME("d2*")
{
DEF_CA
DCell d1;
DCell d2;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d1)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
{
#line 766 "./prim"
#ifdef BUGGY_LONG_LONG
d2.lo = d1.lo<<1;
d2.hi = (d1.hi<<1) | (d1.lo>>(CELL_BITS-1));
#else
d2 = 2*d1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS)
NEXT_P2;}

LABEL(d_two_slash): /* d2/ ( d1 -- d2 ) */
/* Arithmetic shift right by 1.  For signed numbers this is a floored
division by 2. */
NAME("d2/")
{
DEF_CA
DCell d1;
DCell d2;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d1)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
}
#endif
{
#line 778 "./prim"
#ifdef BUGGY_LONG_LONG
d2.hi = d1.hi>>1;
d2.lo= (d1.lo>>1) | (d1.hi<<(CELL_BITS-1));
#else
d2 = d1>>1;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d2=", vm_out); printarg_d(d2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d2, sp[1], spTOS)
NEXT_P2;}

LABEL(and): /* and ( w1 w2 -- w ) */
/*  */
NAME("and")
{
DEF_CA
Cell w1;
Cell w2;
Cell w;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 789 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(or): /* or ( w1 w2 -- w ) */
/*  */
NAME("or")
{
DEF_CA
Cell w1;
Cell w2;
Cell w;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 792 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(x_or): /* xor ( w1 w2 -- w ) */
/*  */
NAME("xor")
{
DEF_CA
Cell w1;
Cell w2;
Cell w;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 797 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(invert): /* invert ( w1 -- w2 ) */
/*  */
NAME("invert")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(spTOS,w1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
}
#endif
{
#line 800 "./prim"
w2 = ~w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(r_shift): /* rshift ( u1 n -- u2 ) */
/* Logical shift right by @i{n} bits. */
NAME("rshift")
{
DEF_CA
UCell u1;
Cell n;
UCell u2;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 806 "./prim"
  u2 = u1>>n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(l_shift): /* lshift ( u1 n -- u2 ) */
/*  */
NAME("lshift")
{
DEF_CA
UCell u1;
Cell n;
UCell u2;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 811 "./prim"
  u2 = u1<<n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(zero_equals): /* 0= ( n -- f ) */
/*  */
NAME("0=")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 866 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(zero_not_equals): /* 0<> ( n -- f ) */
/*  */
NAME("0<>")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 866 "./prim"
f = FLAG(n!=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(zero_less_than): /* 0< ( n -- f ) */
/*  */
NAME("0<")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 866 "./prim"
f = FLAG(n<0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(zero_greater_than): /* 0> ( n -- f ) */
/*  */
NAME("0>")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 866 "./prim"
f = FLAG(n>0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(zero_less_or_equal): /* 0<= ( n -- f ) */
/*  */
NAME("0<=")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 866 "./prim"
f = FLAG(n<=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(zero_greater_or_equal): /* 0>= ( n -- f ) */
/*  */
NAME("0>=")
{
DEF_CA
Cell n;
Bool f;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 866 "./prim"
f = FLAG(n>=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(equals): /* = ( n1 n2 -- f ) */
/*  */
NAME("=")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 867 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(not_equals): /* <> ( n1 n2 -- f ) */
/*  */
NAME("<>")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 867 "./prim"
f = FLAG(n1!=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(less_than): /* < ( n1 n2 -- f ) */
/*  */
NAME("<")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 867 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(greater_than): /* > ( n1 n2 -- f ) */
/*  */
NAME(">")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 867 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(less_or_equal): /* <= ( n1 n2 -- f ) */
/*  */
NAME("<=")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 867 "./prim"
f = FLAG(n1<=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(greater_or_equal): /* >= ( n1 n2 -- f ) */
/*  */
NAME(">=")
{
DEF_CA
Cell n1;
Cell n2;
Bool f;
NEXT_P0;
vm_Cell2n(sp[1],n1);
vm_Cell2n(spTOS,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
sp += 1;
{
#line 867 "./prim"
f = FLAG(n1>=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(u_equals): /* u= ( u1 u2 -- f ) */
/*  */
NAME("u=")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 868 "./prim"
f = FLAG(u1==u2);
#line 868
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(u_not_equals): /* u<> ( u1 u2 -- f ) */
/*  */
NAME("u<>")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 868 "./prim"
f = FLAG(u1!=u2);
#line 868
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(u_less_than): /* u< ( u1 u2 -- f ) */
/*  */
NAME("u<")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 868 "./prim"
f = FLAG(u1<u2);
#line 868
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(u_greater_than): /* u> ( u1 u2 -- f ) */
/*  */
NAME("u>")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 868 "./prim"
f = FLAG(u1>u2);
#line 868
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(u_less_or_equal): /* u<= ( u1 u2 -- f ) */
/*  */
NAME("u<=")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 868 "./prim"
f = FLAG(u1<=u2);
#line 868
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(u_greater_or_equal): /* u>= ( u1 u2 -- f ) */
/*  */
NAME("u>=")
{
DEF_CA
UCell u1;
UCell u2;
Bool f;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 1;
{
#line 868 "./prim"
f = FLAG(u1>=u2);
#line 868
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

#ifdef HAS_DCOMPS
LABEL(d_equals): /* d= ( d1 d2 -- f ) */
/*  */
NAME("d=")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 918 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_not_equals): /* d<> ( d1 d2 -- f ) */
/*  */
NAME("d<>")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 918 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo!=d2.lo || d1.hi!=d2.hi);
#line 918
#else
#line 918
f = FLAG(d1!=d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_less_than): /* d< ( d1 d2 -- f ) */
/*  */
NAME("d<")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 918 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.hi==d2.hi ? d1.lo<d2.lo : d1.hi<d2.hi);
#line 918
#else
#line 918
f = FLAG(d1<d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_greater_than): /* d> ( d1 d2 -- f ) */
/*  */
NAME("d>")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 918 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.hi==d2.hi ? d1.lo>d2.lo : d1.hi>d2.hi);
#line 918
#else
#line 918
f = FLAG(d1>d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_less_or_equal): /* d<= ( d1 d2 -- f ) */
/*  */
NAME("d<=")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 918 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.hi==d2.hi ? d1.lo<=d2.lo : d1.hi<=d2.hi);
#line 918
#else
#line 918
f = FLAG(d1<=d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_greater_or_equal): /* d>= ( d1 d2 -- f ) */
/*  */
NAME("d>=")
{
DEF_CA
DCell d1;
DCell d2;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[3], (Cell)sp[2], d1)
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
sp += 3;
{
#line 918 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.hi==d2.hi ? d1.lo>=d2.lo : d1.hi>=d2.hi);
#line 918
#else
#line 918
f = FLAG(d1>=d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_zero_equals): /* d0= ( d -- f ) */
/*  */
NAME("d0=")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 919 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_zero_not_equals): /* d0<> ( d -- f ) */
/*  */
NAME("d0<>")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 919 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo!=DZERO.lo || d.hi!=DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d!=DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_zero_less_than): /* d0< ( d -- f ) */
/*  */
NAME("d0<")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 919 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.hi==DZERO.hi ? d.lo<DZERO.lo : d.hi<DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d<DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_zero_greater_than): /* d0> ( d -- f ) */
/*  */
NAME("d0>")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 919 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.hi==DZERO.hi ? d.lo>DZERO.lo : d.hi>DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d>DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_zero_less_or_equal): /* d0<= ( d -- f ) */
/*  */
NAME("d0<=")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 919 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.hi==DZERO.hi ? d.lo<=DZERO.lo : d.hi<=DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d<=DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_zero_greater_or_equal): /* d0>= ( d -- f ) */
/*  */
NAME("d0>=")
{
DEF_CA
DCell d;
Bool f;
NEXT_P0;
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 1;
{
#line 919 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.hi==DZERO.hi ? d.lo>=DZERO.lo : d.hi>=DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d>=DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_u_equals): /* du= ( ud1 ud2 -- f ) */
/*  */
NAME("du=")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud((Cell)sp[3], (Cell)sp[2], ud1)
vm_twoCell2ud((Cell)sp[1], (Cell)spTOS, ud2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 920 "./prim"
#ifdef BUGGY_LONG_LONG
#line 920
f = FLAG(ud1.lo==ud2.lo && ud1.hi==ud2.hi);
#line 920
#else
#line 920
f = FLAG(ud1==ud2);
#line 920
#endif
#line 920
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_u_not_equals): /* du<> ( ud1 ud2 -- f ) */
/*  */
NAME("du<>")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud((Cell)sp[3], (Cell)sp[2], ud1)
vm_twoCell2ud((Cell)sp[1], (Cell)spTOS, ud2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 920 "./prim"
#ifdef BUGGY_LONG_LONG
#line 920
f = FLAG(ud1.lo!=ud2.lo || ud1.hi!=ud2.hi);
#line 920
#else
#line 920
f = FLAG(ud1!=ud2);
#line 920
#endif
#line 920
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_u_less_than): /* du< ( ud1 ud2 -- f ) */
/*  */
NAME("du<")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud((Cell)sp[3], (Cell)sp[2], ud1)
vm_twoCell2ud((Cell)sp[1], (Cell)spTOS, ud2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 920 "./prim"
#ifdef BUGGY_LONG_LONG
#line 920
f = FLAG(ud1.hi==ud2.hi ? ud1.lo<ud2.lo : ud1.hi<ud2.hi);
#line 920
#else
#line 920
f = FLAG(ud1<ud2);
#line 920
#endif
#line 920
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_u_greater_than): /* du> ( ud1 ud2 -- f ) */
/*  */
NAME("du>")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud((Cell)sp[3], (Cell)sp[2], ud1)
vm_twoCell2ud((Cell)sp[1], (Cell)spTOS, ud2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 920 "./prim"
#ifdef BUGGY_LONG_LONG
#line 920
f = FLAG(ud1.hi==ud2.hi ? ud1.lo>ud2.lo : ud1.hi>ud2.hi);
#line 920
#else
#line 920
f = FLAG(ud1>ud2);
#line 920
#endif
#line 920
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_u_less_or_equal): /* du<= ( ud1 ud2 -- f ) */
/*  */
NAME("du<=")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud((Cell)sp[3], (Cell)sp[2], ud1)
vm_twoCell2ud((Cell)sp[1], (Cell)spTOS, ud2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 920 "./prim"
#ifdef BUGGY_LONG_LONG
#line 920
f = FLAG(ud1.hi==ud2.hi ? ud1.lo<=ud2.lo : ud1.hi<=ud2.hi);
#line 920
#else
#line 920
f = FLAG(ud1<=ud2);
#line 920
#endif
#line 920
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

LABEL(d_u_greater_or_equal): /* du>= ( ud1 ud2 -- f ) */
/*  */
NAME("du>=")
{
DEF_CA
UDCell ud1;
UDCell ud2;
Bool f;
NEXT_P0;
vm_twoCell2ud((Cell)sp[3], (Cell)sp[2], ud1)
vm_twoCell2ud((Cell)sp[1], (Cell)spTOS, ud2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud1=", vm_out); printarg_ud(ud1);
fputs(" ud2=", vm_out); printarg_ud(ud2);
}
#endif
sp += 3;
{
#line 920 "./prim"
#ifdef BUGGY_LONG_LONG
#line 920
f = FLAG(ud1.hi==ud2.hi ? ud1.lo>=ud2.lo : ud1.hi>=ud2.hi);
#line 920
#else
#line 920
f = FLAG(ud1>=ud2);
#line 920
#endif
#line 920
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

#endif
LABEL(within): /* within ( u1 u2 u3 -- f ) */
/* u2=<u1<u3 or: u3=<u2 and u1 is not in [u3,u2).  This works for
unsigned and signed numbers (but not a mixture).  Another way to think
about this word is to consider the numbers as a circle (wrapping
around from @code{max-u} to 0 for unsigned, and from @code{max-n} to
min-n for signed numbers); now consider the range from u2 towards
increasing numbers up to and excluding u3 (giving an empty range if
u2=u3); if u1 is in this range, @code{within} returns true. */
NAME("within")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
Bool f;
NEXT_P0;
vm_Cell2u(sp[2],u1);
vm_Cell2u(sp[1],u2);
vm_Cell2u(spTOS,u3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
}
#endif
sp += 2;
{
#line 932 "./prim"
f = FLAG(u1-u2 < u3-u2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
NEXT_P2;}

GROUP( internal)
LABEL(sp_fetch): /* sp@ ( -- a_addr ) */
/*  */
NAME("sp@")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 939 "./prim"
a_addr = sp+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,spTOS);
NEXT_P2;}

LABEL(sp_store): /* sp! ( a_addr -- ) */
/*  */
NAME("sp!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 942 "./prim"
sp = a_addr;
/* works with and without spTOS caching */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(rp_fetch): /* rp@ ( -- a_addr ) */
/*  */
NAME("rp@")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 946 "./prim"
a_addr = rp;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,spTOS);
NEXT_P2;}

LABEL(rp_store): /* rp! ( a_addr -- ) */
/*  */
NAME("rp!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 949 "./prim"
rp = a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_FLOATING
LABEL(fp_fetch): /* fp@ ( -- f_addr ) */
/*  */
NAME("fp@")
{
DEF_CA
Float * f_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 954 "./prim"
f_addr = fp;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f_addr=", vm_out); printarg_f_(f_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f_2Cell(f_addr,spTOS);
NEXT_P2;}

LABEL(fp_store): /* fp! ( f_addr -- ) */
/*  */
NAME("fp!")
{
DEF_CA
Float * f_addr;
NEXT_P0;
vm_Cell2f_(spTOS,f_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr=", vm_out); printarg_f_(f_addr);
}
#endif
sp += 1;
{
#line 957 "./prim"
fp = f_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
LABEL(semis): /* ;s ( R:w -- ) */
/* The primitive compiled by @code{EXIT}. */
NAME(";s")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(rpTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
rp += 1;
{
#line 963 "./prim"
SET_IP((Xt *)w);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

GROUP( stack)
LABEL(to_r): /* >r ( w -- R:w ) */
/*  */
NAME(">r")
{
DEF_CA
Cell w;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2w(spTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
rp += -1;
{
#line 968 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(r_from): /* r> ( R:w -- w ) */
/*  */
NAME("r>")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2w(rpTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += -1;
rp += 1;
{
#line 973 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(rdrop): /* rdrop ( R:w -- ) */
/*  */
NAME("rdrop")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(rpTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
rp += 1;
{
#line 978 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(two_to_r): /* 2>r ( w1 w2 -- R:w1 R:w2 ) */
/*  */
NAME("2>r")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 2;
rp += -2;
{
#line 982 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w1,rp[1]);
vm_w2Cell(w2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(two_r_from): /* 2r> ( R:w1 R:w2 -- w1 w2 ) */
/*  */
NAME("2r>")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2w(rp[1],w1);
vm_Cell2w(rpTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -2;
rp += 2;
{
#line 986 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(two_r_fetch): /* 2r@ ( R:w1 R:w2 -- R:w1 R:w2 w1 w2 ) */
/*  */
NAME("2r@")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2w(rp[1],w1);
vm_Cell2w(rpTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -2;
{
#line 990 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(two_r_drop): /* 2rdrop ( R:w1 R:w2 -- ) */
/*  */
NAME("2rdrop")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(rp[1],w1);
vm_Cell2w(rpTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
rp += 2;
{
#line 994 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(over): /* over ( w1 w2 -- w1 w2 w1 ) */
/*  */
NAME("over")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -1;
{
#line 998 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(vm_w2Cell(w2,sp[1]););
vm_w2Cell(w1,spTOS);
NEXT_P2;}

LABEL(drop): /* drop ( w -- ) */
/*  */
NAME("drop")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(spTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
{
#line 1002 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(swap): /* swap ( w1 w2 -- w2 w1 ) */
/*  */
NAME("swap")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 1006 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w2,sp[1]);
vm_w2Cell(w1,spTOS);
NEXT_P2;}

LABEL(dupe): /* dup ( w -- w w ) */
/*  */
NAME("dup")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(spTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += -1;
{
#line 1011 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(vm_w2Cell(w,sp[1]););
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(rote): /* rot ( w1 w2 w3 -- w2 w3 w1 ) */
/*  */
NAME("rot")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
NEXT_P0;
vm_Cell2w(sp[2],w1);
vm_Cell2w(sp[1],w2);
vm_Cell2w(spTOS,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 1015 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w2,sp[2]);
vm_w2Cell(w3,sp[1]);
vm_w2Cell(w1,spTOS);
NEXT_P2;}

LABEL(not_rote): /* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
/*  */
NAME("-rot")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
NEXT_P0;
vm_Cell2w(sp[2],w1);
vm_Cell2w(sp[1],w2);
vm_Cell2w(spTOS,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 1024 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w3,sp[2]);
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(nip): /* nip ( w1 w2 -- w2 ) */
/*  */
NAME("nip")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 1;
{
#line 1028 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(tuck): /* tuck ( w1 w2 -- w2 w1 w2 ) */
/*  */
NAME("tuck")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -1;
{
#line 1032 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w2,sp[2]);
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(question_dupe): /* ?dup ( w -- w ) */
/* Actually the stack effect is: @code{( w -- 0 | w w )}.  It performs a
@code{dup} if w is nonzero. */
NAME("?dup")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(spTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 1038 "./prim"
if (w!=0) {
  IF_spTOS(*sp-- = w;)
#ifndef USE_TOS
  *--sp = w;
#endif
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(pick): /* pick ( u -- w ) */
/* Actually the stack effect is @code{ x0 ... xu u -- x0 ... xu x0 }. */
NAME("pick")
{
DEF_CA
UCell u;
Cell w;
NEXT_P0;
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1049 "./prim"
w = sp[u+1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(two_drop): /* 2drop ( w1 w2 -- ) */
/*  */
NAME("2drop")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += 2;
{
#line 1054 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(two_dupe): /* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
/*  */
NAME("2dup")
{
DEF_CA
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2w(sp[1],w1);
vm_Cell2w(spTOS,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
sp += -2;
{
#line 1058 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(vm_w2Cell(w2,sp[2]););
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(two_over): /* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
/*  */
NAME("2over")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
vm_Cell2w(sp[3],w1);
vm_Cell2w(sp[2],w2);
vm_Cell2w(sp[1],w3);
vm_Cell2w(spTOS,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
sp += -2;
{
#line 1062 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(vm_w2Cell(w4,sp[2]););
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(two_swap): /* 2swap ( w1 w2 w3 w4 -- w3 w4 w1 w2 ) */
/*  */
NAME("2swap")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
vm_Cell2w(sp[3],w1);
vm_Cell2w(sp[2],w2);
vm_Cell2w(sp[1],w3);
vm_Cell2w(spTOS,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 1066 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w3,sp[3]);
vm_w2Cell(w4,sp[2]);
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(two_rote): /* 2rot ( w1 w2 w3 w4 w5 w6 -- w3 w4 w5 w6 w1 w2 ) */
/*  */
NAME("2rot")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
Cell w5;
Cell w6;
NEXT_P0;
vm_Cell2w(sp[5],w1);
vm_Cell2w(sp[4],w2);
vm_Cell2w(sp[3],w3);
vm_Cell2w(sp[2],w4);
vm_Cell2w(sp[1],w5);
vm_Cell2w(spTOS,w6);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
fputs(" w5=", vm_out); printarg_w(w5);
fputs(" w6=", vm_out); printarg_w(w6);
}
#endif
{
#line 1070 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w3,sp[5]);
vm_w2Cell(w4,sp[4]);
vm_w2Cell(w5,sp[3]);
vm_w2Cell(w6,sp[2]);
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(two_nip): /* 2nip ( w1 w2 w3 w4 -- w3 w4 ) */
/*  */
NAME("2nip")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
vm_Cell2w(sp[3],w1);
vm_Cell2w(sp[2],w2);
vm_Cell2w(sp[1],w3);
vm_Cell2w(spTOS,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
sp += 2;
{
#line 1074 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w3,sp[1]);
vm_w2Cell(w4,spTOS);
NEXT_P2;}

LABEL(two_tuck): /* 2tuck ( w1 w2 w3 w4 -- w3 w4 w1 w2 w3 w4 ) */
/*  */
NAME("2tuck")
{
DEF_CA
Cell w1;
Cell w2;
Cell w3;
Cell w4;
NEXT_P0;
vm_Cell2w(sp[3],w1);
vm_Cell2w(sp[2],w2);
vm_Cell2w(sp[1],w3);
vm_Cell2w(spTOS,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
sp += -2;
{
#line 1078 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w3,sp[5]);
vm_w2Cell(w4,sp[4]);
vm_w2Cell(w1,sp[3]);
vm_w2Cell(w2,sp[2]);
vm_w2Cell(w3,sp[1]);
vm_w2Cell(w4,spTOS);
NEXT_P2;}

LABEL(fetch): /* @ ( a_addr -- w ) */
/* @i{w} is the cell stored at @i{a_addr}. */
NAME("@")
{
DEF_CA
Cell * a_addr;
Cell w;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 1085 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(store): /* ! ( w a_addr -- ) */
/* Store @i{w} into the cell at @i{a-addr}. */
NAME("!")
{
DEF_CA
Cell w;
Cell * a_addr;
NEXT_P0;
vm_Cell2w(sp[1],w);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1089 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(plus_store): /* +! ( n a_addr -- ) */
/* Add @i{n} to the cell at @i{a-addr}. */
NAME("+!")
{
DEF_CA
Cell n;
Cell * a_addr;
NEXT_P0;
vm_Cell2n(sp[1],n);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1093 "./prim"
*a_addr += n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(c_fetch): /* c@ ( c_addr -- c ) */
/* @i{c} is the char stored at @i{c_addr}. */
NAME("c@")
{
DEF_CA
Char * c_addr;
Char c;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1099 "./prim"
c = *c_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c=", vm_out); printarg_c(c);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c2Cell(c,spTOS);
NEXT_P2;}

LABEL(c_store): /* c! ( c c_addr -- ) */
/* Store @i{c} into the char at @i{c-addr}. */
NAME("c!")
{
DEF_CA
Char c;
Char * c_addr;
NEXT_P0;
vm_Cell2c(sp[1],c);
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c=", vm_out); printarg_c(c);
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
sp += 2;
{
#line 1125 "./prim"
*c_addr = c;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(two_store): /* 2! ( w1 w2 a_addr -- ) */
/* Store @i{w2} into the cell at @i{c-addr} and @i{w1} into the next cell. */
NAME("2!")
{
DEF_CA
Cell w1;
Cell w2;
Cell * a_addr;
NEXT_P0;
vm_Cell2w(sp[2],w1);
vm_Cell2w(sp[1],w2);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 3;
{
#line 1155 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(two_fetch): /* 2@ ( a_addr -- w1 w2 ) */
/* @i{w2} is the content of the cell stored at @i{a-addr}, @i{w1} is
the content of the next cell. */
NAME("2@")
{
DEF_CA
Cell * a_addr;
Cell w1;
Cell w2;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += -1;
{
#line 1163 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w1,sp[1]);
vm_w2Cell(w2,spTOS);
NEXT_P2;}

LABEL(cell_plus): /* cell+ ( a_addr1 -- a_addr2 ) */
/* @code{1 cells +} */
NAME("cell+")
{
DEF_CA
Cell * a_addr1;
Cell * a_addr2;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr1=", vm_out); printarg_a_(a_addr1);
}
#endif
{
#line 1170 "./prim"
a_addr2 = a_addr1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr2=", vm_out); printarg_a_(a_addr2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr2,spTOS);
NEXT_P2;}

LABEL(cells): /* cells ( n1 -- n2 ) */
/*  @i{n2} is the number of address units of @i{n1} cells. */
NAME("cells")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1176 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(char_plus): /* char+ ( c_addr1 -- c_addr2 ) */
/* @code{1 chars +}. */
NAME("char+")
{
DEF_CA
Char * c_addr1;
Char * c_addr2;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
}
#endif
{
#line 1187 "./prim"
c_addr2 = c_addr1 + 1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr2,spTOS);
NEXT_P2;}

LABEL(paren_chars): /* (chars) ( n1 -- n2 ) */
/*  */
NAME("(chars)")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1192 "./prim"
n2 = n1 * sizeof(Char);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(count): /* count ( c_addr1 -- c_addr2 u ) */
/* @i{c-addr2} is the first character and @i{u} the length of the
counted string at @i{c-addr1}. */
NAME("count")
{
DEF_CA
Char * c_addr1;
Char * c_addr2;
UCell u;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
}
#endif
sp += -1;
{
#line 1199 "./prim"
u = *c_addr1;
c_addr2 = c_addr1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr2,sp[1]);
vm_u2Cell(u,spTOS);
NEXT_P2;}

LABEL(paren_f83find): /* (f83find) ( c_addr u f83name1 -- f83name2 ) */
/*  */
NAME("(f83find)")
{
DEF_CA
Char * c_addr;
UCell u;
struct F83Name * f83name1;
struct F83Name * f83name2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2f83name(spTOS,f83name1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" f83name1=", vm_out); printarg_f83name(f83name1);
}
#endif
sp += 2;
{
#line 1205 "./prim"
for (; f83name1 != NULL; f83name1 = (struct F83Name *)(f83name1->next))
  if ((UCell)F83NAME_COUNT(f83name1)==u &&
      memcasecmp(c_addr, f83name1->name, u)== 0 /* or inline? */)
    break;
f83name2=f83name1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f83name2=", vm_out); printarg_f83name(f83name2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f83name2Cell(f83name2,spTOS);
NEXT_P2;}

#ifdef HAS_HASH
LABEL(paren_hashfind): /* (hashfind) ( c_addr u a_addr -- f83name2 ) */
/*  */
NAME("(hashfind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct F83Name * f83name2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1222 "./prim"
struct F83Name *f83name1;
f83name2=NULL;
while(a_addr != NULL)
{
   f83name1=(struct F83Name *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)F83NAME_COUNT(f83name1)==u &&
       memcasecmp(c_addr, f83name1->name, u)== 0 /* or inline? */)
     {
	f83name2=f83name1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f83name2=", vm_out); printarg_f83name(f83name2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f83name2Cell(f83name2,spTOS);
NEXT_P2;}

LABEL(paren_tablefind): /* (tablefind) ( c_addr u a_addr -- f83name2 ) */
/* A case-sensitive variant of @code{(hashfind)} */
NAME("(tablefind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct F83Name * f83name2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 1245 "./prim"
struct F83Name *f83name1;
f83name2=NULL;
while(a_addr != NULL)
{
   f83name1=(struct F83Name *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)F83NAME_COUNT(f83name1)==u &&
       memcmp(c_addr, f83name1->name, u)== 0 /* or inline? */)
     {
	f83name2=f83name1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f83name2=", vm_out); printarg_f83name(f83name2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f83name2Cell(f83name2,spTOS);
NEXT_P2;}

LABEL(paren_hashkey): /* (hashkey) ( c_addr u1 -- u2 ) */
/*  */
NAME("(hashkey)")
{
DEF_CA
Char * c_addr;
UCell u1;
UCell u2;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
sp += 1;
{
#line 1267 "./prim"
u2=0;
while(u1--)
   u2+=(Cell)toupper(*c_addr++);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(paren_hashkey1): /* (hashkey1) ( c_addr u ubits -- ukey ) */
/* ukey is the hash key for the string c_addr u fitting in ubits bits */
NAME("(hashkey1)")
{
DEF_CA
Char * c_addr;
UCell u;
UCell ubits;
UCell ukey;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2u(spTOS,ubits);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" ubits=", vm_out); printarg_u(ubits);
}
#endif
sp += 2;
{
#line 1275 "./prim"
/* this hash function rotates the key at every step by rot bits within
   ubits bits and xors it with the character. This function does ok in
   the chi-sqare-test.  Rot should be <=7 (preferably <=5) for
   ASCII strings (larger if ubits is large), and should share no
   divisors with ubits.
*/
unsigned rot = ((char []){5,0,1,2,3,4,5,5,5,5,3,5,5,5,5,7,5,5,5,5,7,5,5,5,5,6,5,5,5,5,7,5,5})[ubits];
Char *cp = c_addr;
for (ukey=0; cp<c_addr+u; cp++)
    ukey = ((((ukey<<rot) | (ukey>>(ubits-rot))) 
	     ^ toupper(*cp))
	    & ((1<<ubits)-1));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ukey=", vm_out); printarg_u(ukey);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(ukey,spTOS);
NEXT_P2;}

#endif
LABEL(paren_parse_white): /* (parse-white) ( c_addr1 u1 -- c_addr2 u2 ) */
/*  */
NAME("(parse-white)")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr1);
vm_Cell2u(spTOS,u1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
{
#line 1303 "./prim"
/* use !isgraph instead of isspace? */
Char *endp = c_addr1+u1;
while (c_addr1<endp && isspace(*c_addr1))
  c_addr1++;
if (c_addr1<endp) {
  for (c_addr2 = c_addr1; c_addr1<endp && !isspace(*c_addr1); c_addr1++)
    ;
  u2 = c_addr1-c_addr2;
}
else {
  c_addr2 = c_addr1;
  u2 = 0;
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr2,sp[1]);
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(aligned): /* aligned ( c_addr -- a_addr ) */
/*  @i{a-addr} is the first aligned address greater than or equal to @i{c-addr}. */
NAME("aligned")
{
DEF_CA
Char * c_addr;
Cell * a_addr;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1324 "./prim"
a_addr = (Cell *)((((Cell)c_addr)+(sizeof(Cell)-1))&(-sizeof(Cell)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,spTOS);
NEXT_P2;}

LABEL(f_aligned): /* faligned ( c_addr -- f_addr ) */
/*  @i{f-addr} is the first float-aligned address greater than or equal to @i{c-addr}. */
NAME("faligned")
{
DEF_CA
Char * c_addr;
Float * f_addr;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 1330 "./prim"
f_addr = (Float *)((((Cell)c_addr)+(sizeof(Float)-1))&(-sizeof(Float)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f_addr=", vm_out); printarg_f_(f_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f_2Cell(f_addr,spTOS);
NEXT_P2;}

LABEL(to_body): /* >body ( xt -- a_addr ) */
/*  Get the address of the body of the word represented by @i{xt} (the address
of the word's data field). */
NAME(">body")
{
DEF_CA
Xt xt;
Cell * a_addr;
NEXT_P0;
vm_Cell2xt(spTOS,xt);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
{
#line 1337 "./prim"
a_addr = PFA(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,spTOS);
NEXT_P2;}

LABEL(to_code_address): /* >code-address ( xt -- c_addr ) */
/* @i{c-addr} is the code address of the word @i{xt}. */
NAME(">code-address")
{
DEF_CA
Xt xt;
Char * c_addr;
NEXT_P0;
vm_Cell2xt(spTOS,xt);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
{
#line 1346 "./prim"
/* !! This behaves installation-dependently for DOES-words */
c_addr = (Address)CODE_ADDRESS(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr,spTOS);
NEXT_P2;}

LABEL(to_does_code): /* >does-code ( xt -- a_addr ) */
/* If @i{xt} is the execution token of a child of a @code{DOES>} word,
@i{a-addr} is the start of the Forth code after the @code{DOES>};
Otherwise @i{a-addr} is 0. */
NAME(">does-code")
{
DEF_CA
Xt xt;
Cell * a_addr;
NEXT_P0;
vm_Cell2xt(spTOS,xt);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
{
#line 1355 "./prim"
a_addr = (Cell *)DOES_CODE(xt);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,spTOS);
NEXT_P2;}

LABEL(code_address_store): /* code-address! ( c_addr xt -- ) */
/* Create a code field with code address @i{c-addr} at @i{xt}. */
NAME("code-address!")
{
DEF_CA
Char * c_addr;
Xt xt;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2xt(spTOS,xt);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
sp += 2;
{
#line 1361 "./prim"
MAKE_CF(xt, c_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(does_code_store): /* does-code! ( a_addr xt -- ) */
/* Create a code field at @i{xt} for a child of a @code{DOES>}-word;
@i{a-addr} is the start of the Forth code after @code{DOES>}. */
NAME("does-code!")
{
DEF_CA
Cell * a_addr;
Xt xt;
NEXT_P0;
vm_Cell2a_(sp[1],a_addr);
vm_Cell2xt(spTOS,xt);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputs(" xt=", vm_out); printarg_xt(xt);
}
#endif
sp += 2;
{
#line 1368 "./prim"
MAKE_DOES_CF(xt, a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(does_handler_store): /* does-handler! ( a_addr -- ) */
/* Create a @code{DOES>}-handler at address @i{a-addr}. Normally,
@i{a-addr} points just behind a @code{DOES>}. */
NAME("does-handler!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 1375 "./prim"
MAKE_DOES_HANDLER(a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(slash_does_handler): /* /does-handler ( -- n ) */
/* The size of a @code{DOES>}-handler (includes possible padding). */
NAME("/does-handler")
{
DEF_CA
Cell n;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1381 "./prim"
/* !! a constant or environmental query might be better */
n = DOES_HANDLER_SIZE;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(threading_method): /* threading-method ( -- n ) */
/* 0 if the engine is direct threaded. Note that this may change during
the lifetime of an image. */
NAME("threading-method")
{
DEF_CA
Cell n;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1389 "./prim"
#if defined(DOUBLY_INDIRECT)
n=2;
#else
# if defined(DIRECT_THREADED)
n=0;
# else
n=1;
# endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

GROUP( hostos)
LABEL(paren_key_file): /* key-file ( wfileid -- n ) */
/*  */
NAME("key-file")
{
DEF_CA
Cell wfileid;
Cell n;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1406 "./prim"
#ifdef HAS_FILE
fflush(stdout);
n = key((FILE*)wfileid);
#else
n = key(stdin);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

LABEL(key_q_file): /* key?-file ( wfileid -- n ) */
/*  */
NAME("key?-file")
{
DEF_CA
Cell wfileid;
Cell n;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1414 "./prim"
#ifdef HAS_FILE
fflush(stdout);
n = key_query((FILE*)wfileid);
#else
n = key_query(stdin);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,spTOS);
NEXT_P2;}

#ifdef HAS_OS
LABEL(stdin): /* stdin ( -- wfileid ) */
/*  */
NAME("stdin")
{
DEF_CA
Cell wfileid;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1424 "./prim"
wfileid = (Cell)stdin;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfileid,spTOS);
NEXT_P2;}

LABEL(stdout): /* stdout ( -- wfileid ) */
/*  */
NAME("stdout")
{
DEF_CA
Cell wfileid;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1427 "./prim"
wfileid = (Cell)stdout;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfileid,spTOS);
NEXT_P2;}

LABEL(stderr): /* stderr ( -- wfileid ) */
/*  */
NAME("stderr")
{
DEF_CA
Cell wfileid;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 1430 "./prim"
wfileid = (Cell)stderr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfileid,spTOS);
NEXT_P2;}

LABEL(form): /* form ( -- urows ucols ) */
/* The number of lines and columns in the terminal. These numbers may change
with the window size. */
NAME("form")
{
DEF_CA
UCell urows;
UCell ucols;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -2;
{
#line 1435 "./prim"
/* we could block SIGWINCH here to get a consistent size, but I don't
 think this is necessary or always beneficial */
urows=rows;
ucols=cols;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" urows=", vm_out); printarg_u(urows);
fputs(" ucols=", vm_out); printarg_u(ucols);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(urows,sp[1]);
vm_u2Cell(ucols,spTOS);
NEXT_P2;}

LABEL(flush_icache): /* flush-icache ( c_addr u -- ) */
/* Make sure that the instruction cache of the processor (if there is
one) does not contain stale data at @i{c-addr} and @i{u} bytes
afterwards. @code{END-CODE} performs a @code{flush-icache}
automatically. Caveat: @code{flush-icache} might not work on your
installation; this is usually the case if direct threading is not
supported on your machine (take a look at your @file{machine.h}) and
your machine has a separate instruction cache. In such cases,
@code{flush-icache} does nothing instead of flushing the instruction
cache. */
NAME("flush-icache")
{
DEF_CA
Char * c_addr;
UCell u;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 2;
{
#line 1450 "./prim"
FLUSH_ICACHE(c_addr,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(paren_bye): /* (bye) ( n -- ) */
/*  */
NAME("(bye)")
{
DEF_CA
Cell n;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 1453 "./prim"
SUPER_END;
return (Label *)n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(peren_system): /* (system) ( c_addr u -- wretval wior ) */
/*  */
NAME("(system)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wretval;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1457 "./prim"
#ifndef MSDOS
int old_tp=terminal_prepped;
deprep_terminal();
#endif
wretval=system(cstr(c_addr,u,1)); /* ~ expansion on first part of string? */
wior = IOR(wretval==-1 || (wretval==127 && errno != 0));
#ifndef MSDOS
if (old_tp)
  prep_terminal();
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wretval=", vm_out); printarg_w(wretval);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wretval,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(getenv): /* getenv ( c_addr1 u1 -- c_addr2 u2 ) */
/* The string @i{c-addr1 u1} specifies an environment variable. The string @i{c-addr2 u2}
is the host operating system's expansion of that environment variable. If the
environment variable does not exist, @i{c-addr2 u2} specifies a string 0 characters
in length. */
NAME("getenv")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr1);
vm_Cell2u(spTOS,u1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
{
#line 1473 "./prim"
/* close ' to keep fontify happy */
c_addr2 = getenv(cstr(c_addr1,u1,1));
u2 = (c_addr2 == NULL ? 0 : strlen(c_addr2));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr2,sp[1]);
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(open_pipe): /* open-pipe ( c_addr u wfam -- wfileid wior ) */
/*  */
NAME("open-pipe")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2w(spTOS,wfam);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" wfam=", vm_out); printarg_w(wfam);
}
#endif
sp += 1;
{
#line 1478 "./prim"
wfileid=(Cell)popen(cstr(c_addr,u,1),pfileattr[wfam]); /* ~ expansion of 1st arg? */
wior = IOR(wfileid==0); /* !! the man page says that errno is not set reliably */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfileid,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(close_pipe): /* close-pipe ( wfileid -- wretval wior ) */
/*  */
NAME("close-pipe")
{
DEF_CA
Cell wfileid;
Cell wretval;
Cell wior;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -1;
{
#line 1482 "./prim"
wretval = pclose((FILE *)wfileid);
wior = IOR(wretval==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wretval=", vm_out); printarg_w(wretval);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wretval,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(time_and_date): /* time&date ( -- nsec nmin nhour nday nmonth nyear ) */
/* Report the current time of day. Seconds, minutes and hours are numbered from 0.
Months are numbered from 1. */
NAME("time&date")
{
DEF_CA
Cell nsec;
Cell nmin;
Cell nhour;
Cell nday;
Cell nmonth;
Cell nyear;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -6;
{
#line 1488 "./prim"
struct timeval time1;
struct timezone zone1;
struct tm *ltime;
gettimeofday(&time1,&zone1);
/* !! Single Unix specification: 
   If tzp is not a null pointer, the behaviour is unspecified. */
ltime=localtime((time_t *)&time1.tv_sec);
nyear =ltime->tm_year+1900;
nmonth=ltime->tm_mon+1;
nday  =ltime->tm_mday;
nhour =ltime->tm_hour;
nmin  =ltime->tm_min;
nsec  =ltime->tm_sec;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nsec=", vm_out); printarg_n(nsec);
fputs(" nmin=", vm_out); printarg_n(nmin);
fputs(" nhour=", vm_out); printarg_n(nhour);
fputs(" nday=", vm_out); printarg_n(nday);
fputs(" nmonth=", vm_out); printarg_n(nmonth);
fputs(" nyear=", vm_out); printarg_n(nyear);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nsec,sp[5]);
vm_n2Cell(nmin,sp[4]);
vm_n2Cell(nhour,sp[3]);
vm_n2Cell(nday,sp[2]);
vm_n2Cell(nmonth,sp[1]);
vm_n2Cell(nyear,spTOS);
NEXT_P2;}

LABEL(ms): /* ms ( n -- ) */
/* Wait at least @i{n} milli-second. */
NAME("ms")
{
DEF_CA
Cell n;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += 1;
{
#line 1504 "./prim"
struct timeval timeout;
timeout.tv_sec=n/1000;
timeout.tv_usec=1000*(n%1000);
(void)select(0,0,0,0,&timeout);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(allocate): /* allocate ( u -- a_addr wior ) */
/* Allocate @i{u} address units of contiguous data space. The initial
contents of the data space is undefined. If the allocation is successful,
@i{a-addr} is the start address of the allocated region and @i{wior}
is 0. If the allocation fails, @i{a-addr} is undefined and @i{wior}
is a non-zero I/O result code. */
NAME("allocate")
{
DEF_CA
UCell u;
Cell * a_addr;
Cell wior;
NEXT_P0;
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += -1;
{
#line 1515 "./prim"
a_addr = (Cell *)malloc(u?u:1);
wior = IOR(a_addr==NULL);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(free): /* free ( a_addr -- wior ) */
/* Return the region of data space starting at @i{a-addr} to the system.
The region must originally have been obtained using @code{allocate} or
@code{resize}. If the operational is successful, @i{wior} is 0.
If the operation fails, @i{wior} is a non-zero I/O result code. */
NAME("free")
{
DEF_CA
Cell * a_addr;
Cell wior;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 1523 "./prim"
free(a_addr);
wior = 0;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(resize): /* resize ( a_addr1 u -- a_addr2 wior ) */
/* Change the size of the allocated area at @i{a-addr1} to @i{u}
address units, possibly moving the contents to a different
area. @i{a-addr2} is the address of the resulting area.
If the operation is successful, @i{wior} is 0.
If the operation fails, @i{wior} is a non-zero
I/O result code. If @i{a-addr1} is 0, Gforth's (but not the Standard)
@code{resize} @code{allocate}s @i{u} address units. */
NAME("resize")
{
DEF_CA
Cell * a_addr1;
UCell u;
Cell * a_addr2;
Cell wior;
NEXT_P0;
vm_Cell2a_(sp[1],a_addr1);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr1=", vm_out); printarg_a_(a_addr1);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1534 "./prim"
/* the following check is not necessary on most OSs, but it is needed
   on SunOS 4.1.2. */
/* close ' to keep fontify happy */
if (a_addr1==NULL)
  a_addr2 = (Cell *)malloc(u);
else
  a_addr2 = (Cell *)realloc(a_addr1, u);
wior = IOR(a_addr2==NULL);	/* !! Define a return code */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr2=", vm_out); printarg_a_(a_addr2);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr2,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(strerror): /* strerror ( n -- c_addr u ) */
/*  */
NAME("strerror")
{
DEF_CA
Cell n;
Char * c_addr;
UCell u;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += -1;
{
#line 1544 "./prim"
c_addr = strerror(n);
u = strlen(c_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr,sp[1]);
vm_u2Cell(u,spTOS);
NEXT_P2;}

LABEL(strsignal): /* strsignal ( n -- c_addr u ) */
/*  */
NAME("strsignal")
{
DEF_CA
Cell n;
Char * c_addr;
UCell u;
NEXT_P0;
vm_Cell2n(spTOS,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
sp += -1;
{
#line 1548 "./prim"
c_addr = strsignal(n);
u = strlen(c_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr,sp[1]);
vm_u2Cell(u,spTOS);
NEXT_P2;}

LABEL(call_c): /* call-c ( w -- ) */
/* Call the C function pointed to by @i{w}. The C function has to
access the stack itself. The stack pointers are exported in the global
variables @code{SP} and @code{FP}. */
NAME("call-c")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(spTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
{
#line 1555 "./prim"
/* This is a first attempt at support for calls to C. This may change in
   the future */
IF_fpTOS(fp[0]=fpTOS);
FP=fp;
SP=sp;
((void (*)())w)();
sp=SP;
fp=FP;
IF_spTOS(spTOS=sp[0]);
IF_fpTOS(fpTOS=fp[0]);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
#ifdef HAS_FILE
LABEL(close_file): /* close-file ( wfileid -- wior ) */
/*  */
NAME("close-file")
{
DEF_CA
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1570 "./prim"
wior = IOR(fclose((FILE *)wfileid)==EOF);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(open_file): /* open-file ( c_addr u wfam -- wfileid wior ) */
/*  */
NAME("open-file")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2w(spTOS,wfam);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" wfam=", vm_out); printarg_w(wfam);
}
#endif
sp += 1;
{
#line 1573 "./prim"
wfileid = (Cell)fopen(tilde_cstr(c_addr, u, 1), fileattr[wfam]);
wior =  IOR(wfileid == 0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfileid,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(create_file): /* create-file ( c_addr u wfam -- wfileid wior ) */
/*  */
NAME("create-file")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2w(spTOS,wfam);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" wfam=", vm_out); printarg_w(wfam);
}
#endif
sp += 1;
{
#line 1577 "./prim"
Cell	fd;
fd = open(tilde_cstr(c_addr, u, 1), O_CREAT|O_TRUNC|ufileattr[wfam], 0666);
if (fd != -1) {
  wfileid = (Cell)fdopen(fd, fileattr[wfam]);
  wior = IOR(wfileid == 0);
} else {
  wfileid = 0;
  wior = IOR(1);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfileid=", vm_out); printarg_w(wfileid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfileid,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(delete_file): /* delete-file ( c_addr u -- wior ) */
/*  */
NAME("delete-file")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 1588 "./prim"
wior = IOR(unlink(tilde_cstr(c_addr, u, 1))==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(rename_file): /* rename-file ( c_addr1 u1 c_addr2 u2 -- wior ) */
/* Rename file @i{c_addr1 u1} to new name @i{c_addr2 u2} */
NAME("rename-file")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[3],c_addr1);
vm_Cell2u(sp[2],u1);
vm_Cell2c_(sp[1],c_addr2);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 3;
{
#line 1592 "./prim"
char *s1=tilde_cstr(c_addr2, u2, 1);
wior = IOR(rename(tilde_cstr(c_addr1, u1, 0), s1)==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(file_position): /* file-position ( wfileid -- ud wior ) */
/*  */
NAME("file-position")
{
DEF_CA
Cell wfileid;
UDCell ud;
Cell wior;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -2;
{
#line 1596 "./prim"
/* !! use tell and lseek? */
ud = LONG2UD(ftell((FILE *)wfileid));
wior = IOR(UD2LONG(ud)==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_ud2twoCell(ud, sp[2], sp[1])
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(reposition_file): /* reposition-file ( ud wfileid -- wior ) */
/*  */
NAME("reposition-file")
{
DEF_CA
UDCell ud;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_twoCell2ud((Cell)sp[2], (Cell)sp[1], ud)
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 2;
{
#line 1601 "./prim"
wior = IOR(fseek((FILE *)wfileid, UD2LONG(ud), SEEK_SET)==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(file_size): /* file-size ( wfileid -- ud wior ) */
/*  */
NAME("file-size")
{
DEF_CA
Cell wfileid;
UDCell ud;
Cell wior;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -2;
{
#line 1604 "./prim"
struct stat buf;
wior = IOR(fstat(fileno((FILE *)wfileid), &buf)==-1);
ud = LONG2UD(buf.st_size);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_ud2twoCell(ud, sp[2], sp[1])
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(resize_file): /* resize-file ( ud wfileid -- wior ) */
/*  */
NAME("resize-file")
{
DEF_CA
UDCell ud;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_twoCell2ud((Cell)sp[2], (Cell)sp[1], ud)
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ud=", vm_out); printarg_ud(ud);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 2;
{
#line 1609 "./prim"
wior = IOR(ftruncate(fileno((FILE *)wfileid), UD2LONG(ud))==-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(read_file): /* read-file ( c_addr u1 wfileid -- u2 wior ) */
/*  */
NAME("read-file")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
UCell u2;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u1);
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 1;
{
#line 1612 "./prim"
/* !! fread does not guarantee enough */
u2 = fread(c_addr, sizeof(Char), u1, (FILE *)wfileid);
wior = FILEIO(u2<u1 && ferror((FILE *)wfileid));
/* !! is the value of ferror errno-compatible? */
if (wior)
  clearerr((FILE *)wfileid);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(read_line): /* read-line ( c_addr u1 wfileid -- u2 flag wior ) */
/*  */
NAME("read-line")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
UCell u2;
Bool flag;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u1);
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1620 "./prim"
/* this may one day be replaced with : read-line (read-line) nip ; */
Cell c;
flag=-1;
for(u2=0; u2<u1; u2++)
{
   c = getc((FILE *)wfileid);
   if (c=='\n') break;
   if (c=='\r') {
     if ((c = getc((FILE *)wfileid))!='\n')
       ungetc(c,(FILE *)wfileid);
     break;
   }
   if (c==EOF) {
	flag=FLAG(u2!=0);
	break;
     }
   c_addr[u2] = (Char)c;
}
wior=FILEIO(ferror((FILE *)wfileid));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" flag=", vm_out); printarg_f(flag);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,sp[2]);
vm_f2Cell(flag,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

#endif
LABEL(write_file): /* write-file ( c_addr u1 wfileid -- wior ) */
/*  */
NAME("write-file")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u1);
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 2;
{
#line 1643 "./prim"
/* !! fwrite does not guarantee enough */
#ifdef HAS_FILE
{
  UCell u2 = fwrite(c_addr, sizeof(Char), u1, (FILE *)wfileid);
  wior = FILEIO(u2<u1 && ferror((FILE *)wfileid));
  if (wior)
    clearerr((FILE *)wfileid);
}
#else
TYPE(c_addr, u1);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(emit_file): /* emit-file ( c wfileid -- wior ) */
/*  */
NAME("emit-file")
{
DEF_CA
Char c;
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2c(sp[1],c);
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c=", vm_out); printarg_c(c);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += 1;
{
#line 1656 "./prim"
#ifdef HAS_FILE
wior = FILEIO(putc(c, (FILE *)wfileid)==EOF);
if (wior)
  clearerr((FILE *)wfileid);
#else
PUTC(c);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

#ifdef HAS_FILE
LABEL(flush_file): /* flush-file ( wfileid -- wior ) */
/*  */
NAME("flush-file")
{
DEF_CA
Cell wfileid;
Cell wior;
NEXT_P0;
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
{
#line 1667 "./prim"
wior = IOR(fflush((FILE *) wfileid)==EOF);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(file_status): /* file-status ( c_addr u -- wfam wior ) */
/*  */
NAME("file-status")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wfam;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 1670 "./prim"
char *filename=tilde_cstr(c_addr, u, 1);
if (access (filename, F_OK) != 0) {
  wfam=0;
  wior=IOR(1);
}
else if (access (filename, R_OK | W_OK) == 0) {
  wfam=2; /* r/w */
  wior=0;
}
else if (access (filename, R_OK) == 0) {
  wfam=0; /* r/o */
  wior=0;
}
else if (access (filename, W_OK) == 0) {
  wfam=4; /* w/o */
  wior=0;
}
else {
  wfam=1; /* well, we cannot access the file, but better deliver a legal
	    access mode (r/o bin), so we get a decent error later upon open. */
  wior=0;
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wfam=", vm_out); printarg_w(wfam);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wfam,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

#endif
#ifdef HAS_FLOATING
GROUP( floating)
LABEL(f_equals): /* f= ( r1 r2 -- f ) */
/*  */
NAME("f=")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1698 "./prim"
f = FLAG(r1==r2);
#line 1698
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_not_equals): /* f<> ( r1 r2 -- f ) */
/*  */
NAME("f<>")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1698 "./prim"
f = FLAG(r1!=r2);
#line 1698
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_less_than): /* f< ( r1 r2 -- f ) */
/*  */
NAME("f<")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1698 "./prim"
f = FLAG(r1<r2);
#line 1698
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_greater_than): /* f> ( r1 r2 -- f ) */
/*  */
NAME("f>")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1698 "./prim"
f = FLAG(r1>r2);
#line 1698
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_less_or_equal): /* f<= ( r1 r2 -- f ) */
/*  */
NAME("f<=")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1698 "./prim"
f = FLAG(r1<=r2);
#line 1698
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_greater_or_equal): /* f>= ( r1 r2 -- f ) */
/*  */
NAME("f>=")
{
DEF_CA
Float r1;
Float r2;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
sp += -1;
fp += 2;
{
#line 1698 "./prim"
f = FLAG(r1>=r2);
#line 1698
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_zero_equals): /* f0= ( r -- f ) */
/*  */
NAME("f0=")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1699 "./prim"
f = FLAG(r==0.);
#line 1699
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_zero_not_equals): /* f0<> ( r -- f ) */
/*  */
NAME("f0<>")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1699 "./prim"
f = FLAG(r!=0.);
#line 1699
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_zero_less_than): /* f0< ( r -- f ) */
/*  */
NAME("f0<")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1699 "./prim"
f = FLAG(r<0.);
#line 1699
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_zero_greater_than): /* f0> ( r -- f ) */
/*  */
NAME("f0>")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1699 "./prim"
f = FLAG(r>0.);
#line 1699
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_zero_less_or_equal): /* f0<= ( r -- f ) */
/*  */
NAME("f0<=")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1699 "./prim"
f = FLAG(r<=0.);
#line 1699
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_zero_greater_or_equal): /* f0>= ( r -- f ) */
/*  */
NAME("f0>=")
{
DEF_CA
Float r;
Bool f;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -1;
fp += 1;
{
#line 1699 "./prim"
f = FLAG(r>=0.);
#line 1699
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(f,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(d_to_f): /* d>f ( d -- r ) */
/*  */
NAME("d>f")
{
DEF_CA
DCell d;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_twoCell2d((Cell)sp[1], (Cell)spTOS, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
sp += 2;
fp += -1;
{
#line 1702 "./prim"
#ifdef BUGGY_LONG_LONG
extern double ldexp(double x, int exp);
r = ldexp((Float)d.hi,CELL_BITS) + (Float)d.lo;
#else
r = d;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(f_to_d): /* f>d ( r -- d ) */
/*  */
NAME("f>d")
{
DEF_CA
Float r;
DCell d;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
sp += -2;
fp += 1;
{
#line 1710 "./prim"
#ifdef BUGGY_LONG_LONG
d.hi = ldexp(r,-(int)(CELL_BITS)) - (r<0);
d.lo = r-ldexp((Float)d.hi,CELL_BITS);
#else
d = r;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" d=", vm_out); printarg_d(d);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(d, sp[1], spTOS)
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_store): /* f! ( r f_addr -- ) */
/* Store @i{r} into the float at address @i{f-addr}. */
NAME("f!")
{
DEF_CA
Float r;
Float * f_addr;
NEXT_P0;
vm_Float2r(fpTOS,r);
vm_Cell2f_(spTOS,f_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" f_addr=", vm_out); printarg_f_(f_addr);
}
#endif
sp += 1;
fp += 1;
{
#line 1719 "./prim"
*f_addr = r;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_fetch): /* f@ ( f_addr -- r ) */
/* @i{r} is the float at address @i{f-addr}. */
NAME("f@")
{
DEF_CA
Float * f_addr;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2f_(spTOS,f_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr=", vm_out); printarg_f_(f_addr);
}
#endif
sp += 1;
fp += -1;
{
#line 1723 "./prim"
r = *f_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(d_f_fetch): /* df@ ( df_addr -- r ) */
/* Fetch the double-precision IEEE floating-point value @i{r} from the address @i{df-addr}. */
NAME("df@")
{
DEF_CA
DFloat * df_addr;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2df_(spTOS,df_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" df_addr=", vm_out); printarg_df_(df_addr);
}
#endif
sp += 1;
fp += -1;
{
#line 1727 "./prim"
#ifdef IEEE_FP
r = *df_addr;
#else
!! df@
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(d_f_store): /* df! ( r df_addr -- ) */
/* Store @i{r} as double-precision IEEE floating-point value to the
address @i{df-addr}. */
NAME("df!")
{
DEF_CA
Float r;
DFloat * df_addr;
NEXT_P0;
vm_Float2r(fpTOS,r);
vm_Cell2df_(spTOS,df_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" df_addr=", vm_out); printarg_df_(df_addr);
}
#endif
sp += 1;
fp += 1;
{
#line 1736 "./prim"
#ifdef IEEE_FP
*df_addr = r;
#else
!! df!
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(s_f_fetch): /* sf@ ( sf_addr -- r ) */
/* Fetch the single-precision IEEE floating-point value @i{r} from the address @i{sf-addr}. */
NAME("sf@")
{
DEF_CA
SFloat * sf_addr;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2sf_(spTOS,sf_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" sf_addr=", vm_out); printarg_sf_(sf_addr);
}
#endif
sp += 1;
fp += -1;
{
#line 1744 "./prim"
#ifdef IEEE_FP
r = *sf_addr;
#else
!! sf@
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(s_f_store): /* sf! ( r sf_addr -- ) */
/* Store @i{r} as single-precision IEEE floating-point value to the
address @i{sf-addr}. */
NAME("sf!")
{
DEF_CA
Float r;
SFloat * sf_addr;
NEXT_P0;
vm_Float2r(fpTOS,r);
vm_Cell2sf_(spTOS,sf_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" sf_addr=", vm_out); printarg_sf_(sf_addr);
}
#endif
sp += 1;
fp += 1;
{
#line 1753 "./prim"
#ifdef IEEE_FP
*sf_addr = r;
#else
!! sf!
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_plus): /* f+ ( r1 r2 -- r3 ) */
/*  */
NAME("f+")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1760 "./prim"
r3 = r1+r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_minus): /* f- ( r1 r2 -- r3 ) */
/*  */
NAME("f-")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1763 "./prim"
r3 = r1-r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_star): /* f* ( r1 r2 -- r3 ) */
/*  */
NAME("f*")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1766 "./prim"
r3 = r1*r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_slash): /* f/ ( r1 r2 -- r3 ) */
/*  */
NAME("f/")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1769 "./prim"
r3 = r1/r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_star_star): /* f** ( r1 r2 -- r3 ) */
/* @i{r3} is @i{r1} raised to the @i{r2}th power. */
NAME("f**")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1773 "./prim"
r3 = pow(r1,r2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_negate): /* fnegate ( r1 -- r2 ) */
/*  */
NAME("fnegate")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1776 "./prim"
r2 = - r1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_drop): /* fdrop ( r -- ) */
/*  */
NAME("fdrop")
{
DEF_CA
Float r;
NEXT_P0;
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
fp += 1;
{
#line 1779 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(f_dupe): /* fdup ( r -- r r ) */
/*  */
NAME("fdup")
{
DEF_CA
Float r;
NEXT_P0;
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
fp += -1;
{
#line 1781 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(vm_r2Float(r,fp[1]););
vm_r2Float(r,fpTOS);
NEXT_P2;}

LABEL(f_swap): /* fswap ( r1 r2 -- r2 r1 ) */
/*  */
NAME("fswap")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
{
#line 1783 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fp[1]);
vm_r2Float(r1,fpTOS);
NEXT_P2;}

LABEL(f_over): /* fover ( r1 r2 -- r1 r2 r1 ) */
/*  */
NAME("fover")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += -1;
{
#line 1785 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(vm_r2Float(r2,fp[1]););
vm_r2Float(r1,fpTOS);
NEXT_P2;}

LABEL(f_rote): /* frot ( r1 r2 r3 -- r2 r3 r1 ) */
/*  */
NAME("frot")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[2],r1);
vm_Float2r(fp[1],r2);
vm_Float2r(fpTOS,r3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
fputs(" r3=", vm_out); printarg_r(r3);
}
#endif
{
#line 1787 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fp[2]);
vm_r2Float(r3,fp[1]);
vm_r2Float(r1,fpTOS);
NEXT_P2;}

LABEL(f_nip): /* fnip ( r1 r2 -- r2 ) */
/*  */
NAME("fnip")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1789 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_tuck): /* ftuck ( r1 r2 -- r2 r1 r2 ) */
/*  */
NAME("ftuck")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += -1;
{
#line 1791 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fp[2]);
vm_r2Float(r1,fp[1]);
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(float_plus): /* float+ ( f_addr1 -- f_addr2 ) */
/* @code{1 floats +}. */
NAME("float+")
{
DEF_CA
Float * f_addr1;
Float * f_addr2;
NEXT_P0;
vm_Cell2f_(spTOS,f_addr1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr1=", vm_out); printarg_f_(f_addr1);
}
#endif
{
#line 1794 "./prim"
f_addr2 = f_addr1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f_addr2=", vm_out); printarg_f_(f_addr2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f_2Cell(f_addr2,spTOS);
NEXT_P2;}

LABEL(floats): /* floats ( n1 -- n2 ) */
/* @i{n2} is the number of address units of @i{n1} floats. */
NAME("floats")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1798 "./prim"
n2 = n1*sizeof(Float);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(floor): /* floor ( r1 -- r2 ) */
/* Round towards the next smaller integral value, i.e., round toward negative infinity. */
NAME("floor")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1802 "./prim"
/* !! unclear wording */
r2 = floor(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_round): /* fround ( r1 -- r2 ) */
/* Round to the nearest integral value. */
NAME("fround")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1807 "./prim"
/* !! unclear wording */
#ifdef HAVE_RINT
r2 = rint(r1);
#else
r2 = floor(r1+0.5);
/* !! This is not quite true to the rounding rules given in the standard */
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_max): /* fmax ( r1 r2 -- r3 ) */
/*  */
NAME("fmax")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1816 "./prim"
if (r1<r2)
  r3 = r2;
else
  r3 = r1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_min): /* fmin ( r1 r2 -- r3 ) */
/*  */
NAME("fmin")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1822 "./prim"
if (r1<r2)
  r3 = r1;
else
  r3 = r2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(represent): /* represent ( r c_addr u -- n f1 f2 ) */
/*  */
NAME("represent")
{
DEF_CA
Float r;
Char * c_addr;
UCell u;
Cell n;
Bool f1;
Bool f2;
NEXT_P0;
vm_Float2r(fpTOS,r);
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += -1;
fp += 1;
{
#line 1828 "./prim"
char *sig;
int flag;
int decpt;
sig=ecvt(r, u, &decpt, &flag);
n=(r==0 ? 1 : decpt);
f1=FLAG(flag!=0);
f2=FLAG(isdigit((unsigned)(sig[0]))!=0);
memmove(c_addr,sig,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputs(" f1=", vm_out); printarg_f(f1);
fputs(" f2=", vm_out); printarg_f(f2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n,sp[2]);
vm_f2Cell(f1,sp[1]);
vm_f2Cell(f2,spTOS);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(to_float): /* >float ( c_addr u -- flag ) */
/* Actual stack effect: ( c_addr u -- r t | f ).  Attempt to convert the
character string @i{c-addr u} to internal floating-point
representation. If the string represents a valid floating-point number
@i{r} is placed on the floating-point stack and @i{flag} is
true. Otherwise, @i{flag} is false. A string of blanks is a special
case and represents the floating-point number 0. */
NAME(">float")
{
DEF_CA
Char * c_addr;
UCell u;
Bool flag;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 1844 "./prim"
/* real signature: c_addr u -- r t / f */
Float r;
char *number=cstr(c_addr, u, 1);
char *endconv;
int sign = 0;
if(number[0]=='-') {
   sign = 1;
   number++;
   u--;
}
while(isspace((unsigned)(number[--u])) && u>0);
switch(number[u])
{
   case 'd':
   case 'D':
   case 'e':
   case 'E':  break;
   default :  u++; break;
}
number[u]='\0';
r=strtod(number,&endconv);
if((flag=FLAG(!(Cell)*endconv)))
{
   IF_fpTOS(fp[0] = fpTOS);
   fp += -1;
   fpTOS = sign ? -r : r;
}
else if(*endconv=='d' || *endconv=='D')
{
   *endconv='E';
   r=strtod(number,&endconv);
   if((flag=FLAG(!(Cell)*endconv)))
     {
	IF_fpTOS(fp[0] = fpTOS);
	fp += -1;
	fpTOS = sign ? -r : r;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" flag=", vm_out); printarg_f(flag);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(flag,spTOS);
NEXT_P2;}

LABEL(f_abs): /* fabs ( r1 -- r2 ) */
/*  */
NAME("fabs")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1884 "./prim"
r2 = fabs(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_cos): /* facos ( r1 -- r2 ) */
/*  */
NAME("facos")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1887 "./prim"
r2 = acos(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_sine): /* fasin ( r1 -- r2 ) */
/*  */
NAME("fasin")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1890 "./prim"
r2 = asin(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_tan): /* fatan ( r1 -- r2 ) */
/*  */
NAME("fatan")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1893 "./prim"
r2 = atan(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_tan_two): /* fatan2 ( r1 r2 -- r3 ) */
/* @i{r1/r2}=tan(@i{r3}). ANS Forth does not require, but probably
intends this to be the inverse of @code{fsincos}. In gforth it is. */
NAME("fatan2")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fp[1],r1);
vm_Float2r(fpTOS,r2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
fputs(" r2=", vm_out); printarg_r(r2);
}
#endif
fp += 1;
{
#line 1898 "./prim"
r3 = atan2(r1,r2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_cos): /* fcos ( r1 -- r2 ) */
/*  */
NAME("fcos")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1901 "./prim"
r2 = cos(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_e_x_p): /* fexp ( r1 -- r2 ) */
/*  */
NAME("fexp")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1904 "./prim"
r2 = exp(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_e_x_p_m_one): /* fexpm1 ( r1 -- r2 ) */
/* @i{r2}=@i{e}**@i{r1}@minus{}1 */
NAME("fexpm1")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1908 "./prim"
#ifdef HAVE_EXPM1
extern double
#ifdef NeXT
              const
#endif
                    expm1(double);
r2 = expm1(r1);
#else
r2 = exp(r1)-1.;
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_l_n): /* fln ( r1 -- r2 ) */
/*  */
NAME("fln")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1920 "./prim"
r2 = log(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_l_n_p_one): /* flnp1 ( r1 -- r2 ) */
/* @i{r2}=ln(@i{r1}+1) */
NAME("flnp1")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1924 "./prim"
#ifdef HAVE_LOG1P
extern double
#ifdef NeXT
              const
#endif
                    log1p(double);
r2 = log1p(r1);
#else
r2 = log(r1+1.);
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_log): /* flog ( r1 -- r2 ) */
/* The decimal logarithm. */
NAME("flog")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1937 "./prim"
r2 = log10(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_log): /* falog ( r1 -- r2 ) */
/* @i{r2}=10**@i{r1} */
NAME("falog")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1941 "./prim"
extern double pow10(double);
r2 = pow10(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_sine): /* fsin ( r1 -- r2 ) */
/*  */
NAME("fsin")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1945 "./prim"
r2 = sin(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_sine_cos): /* fsincos ( r1 -- r2 r3 ) */
/* @i{r2}=sin(@i{r1}), @i{r3}=cos(@i{r1}) */
NAME("fsincos")
{
DEF_CA
Float r1;
Float r2;
Float r3;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
fp += -1;
{
#line 1949 "./prim"
r2 = sin(r1);
r3 = cos(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputs(" r3=", vm_out); printarg_r(r3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fp[1]);
vm_r2Float(r3,fpTOS);
NEXT_P2;}

LABEL(f_square_root): /* fsqrt ( r1 -- r2 ) */
/*  */
NAME("fsqrt")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1953 "./prim"
r2 = sqrt(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_tan): /* ftan ( r1 -- r2 ) */
/*  */
NAME("ftan")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1956 "./prim"
r2 = tan(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_cinch): /* fsinh ( r1 -- r2 ) */
/*  */
NAME("fsinh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1961 "./prim"
r2 = sinh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_cosh): /* fcosh ( r1 -- r2 ) */
/*  */
NAME("fcosh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1966 "./prim"
r2 = cosh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_tan_h): /* ftanh ( r1 -- r2 ) */
/*  */
NAME("ftanh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1971 "./prim"
r2 = tanh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_cinch): /* fasinh ( r1 -- r2 ) */
/*  */
NAME("fasinh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1976 "./prim"
r2 = asinh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_cosh): /* facosh ( r1 -- r2 ) */
/*  */
NAME("facosh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1981 "./prim"
r2 = acosh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(f_a_tan_h): /* fatanh ( r1 -- r2 ) */
/*  */
NAME("fatanh")
{
DEF_CA
Float r1;
Float r2;
NEXT_P0;
vm_Float2r(fpTOS,r1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r1=", vm_out); printarg_r(r1);
}
#endif
{
#line 1986 "./prim"
r2 = atanh(r1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r2=", vm_out); printarg_r(r2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r2,fpTOS);
NEXT_P2;}

LABEL(s_floats): /* sfloats ( n1 -- n2 ) */
/* @i{n2} is the number of address units of @i{n1}
single-precision IEEE floating-point numbers. */
NAME("sfloats")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1994 "./prim"
n2 = n1*sizeof(SFloat);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(d_floats): /* dfloats ( n1 -- n2 ) */
/* @i{n2} is the number of address units of @i{n1}
double-precision IEEE floating-point numbers. */
NAME("dfloats")
{
DEF_CA
Cell n1;
Cell n2;
NEXT_P0;
vm_Cell2n(spTOS,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 1999 "./prim"
n2 = n1*sizeof(DFloat);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(n2,spTOS);
NEXT_P2;}

LABEL(s_f_aligned): /* sfaligned ( c_addr -- sf_addr ) */
/* @i{sf-addr} is the first single-float-aligned address greater
than or equal to @i{c-addr}. */
NAME("sfaligned")
{
DEF_CA
Char * c_addr;
SFloat * sf_addr;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 2004 "./prim"
sf_addr = (SFloat *)((((Cell)c_addr)+(sizeof(SFloat)-1))&(-sizeof(SFloat)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" sf_addr=", vm_out); printarg_sf_(sf_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_sf_2Cell(sf_addr,spTOS);
NEXT_P2;}

LABEL(d_f_aligned): /* dfaligned ( c_addr -- df_addr ) */
/* @i{df-addr} is the first double-float-aligned address greater
than or equal to @i{c-addr}. */
NAME("dfaligned")
{
DEF_CA
Char * c_addr;
DFloat * df_addr;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
{
#line 2011 "./prim"
df_addr = (DFloat *)((((Cell)c_addr)+(sizeof(DFloat)-1))&(-sizeof(DFloat)));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" df_addr=", vm_out); printarg_df_(df_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_df_2Cell(df_addr,spTOS);
NEXT_P2;}

#endif
#ifdef HAS_GLOCALS
LABEL(fetch_local_number): /* @local# ( #noffset -- w ) */
/*  */
NAME("@local#")
{
DEF_CA
Cell noffset;
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2n(IPTOS,noffset);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
sp += -1;
{
#line 2025 "./prim"
w = *(Cell *)(lp+noffset);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(fetch_local_zero): /* @local0 ( -- w ) */
/*  */
NAME("@local0")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2028 "./prim"
w = *(Cell *)(lp+0*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(fetch_local_four): /* @local1 ( -- w ) */
/*  */
NAME("@local1")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2031 "./prim"
w = *(Cell *)(lp+1*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(fetch_local_eight): /* @local2 ( -- w ) */
/*  */
NAME("@local2")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2034 "./prim"
w = *(Cell *)(lp+2*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

LABEL(fetch_local_twelve): /* @local3 ( -- w ) */
/*  */
NAME("@local3")
{
DEF_CA
Cell w;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2037 "./prim"
w = *(Cell *)(lp+3*sizeof(Cell));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(w,spTOS);
NEXT_P2;}

#ifdef HAS_FLOATING
LABEL(f_fetch_local_number): /* f@local# ( #noffset -- r ) */
/*  */
NAME("f@local#")
{
DEF_CA
Cell noffset;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2n(IPTOS,noffset);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
fp += -1;
{
#line 2042 "./prim"
r = *(Float *)(lp+noffset);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
NEXT_P2;}

LABEL(f_fetch_local_zero): /* f@local0 ( -- r ) */
/*  */
NAME("f@local0")
{
DEF_CA
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
fp += -1;
{
#line 2045 "./prim"
r = *(Float *)(lp+0*sizeof(Float));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
NEXT_P2;}

LABEL(f_fetch_local_eight): /* f@local1 ( -- r ) */
/*  */
NAME("f@local1")
{
DEF_CA
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
fp += -1;
{
#line 2048 "./prim"
r = *(Float *)(lp+1*sizeof(Float));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
NEXT_P2;}

#endif
LABEL(laddr_number): /* laddr# ( #noffset -- c_addr ) */
/*  */
NAME("laddr#")
{
DEF_CA
Cell noffset;
Char * c_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2n(IPTOS,noffset);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
sp += -1;
{
#line 2053 "./prim"
/* this can also be used to implement lp@ */
c_addr = (Char *)(lp+noffset);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr,spTOS);
NEXT_P2;}

LABEL(lp_plus_store_number): /* lp+!# ( #noffset -- ) */
/* used with negative immediate values it allocates memory on the
local stack, a positive immediate argument drops memory from the local
stack */
NAME("lp+!#")
{
DEF_CA
Cell noffset;
NEXT_P0;
vm_Cell2n(IPTOS,noffset);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" noffset=", vm_out); printarg_n(noffset);
}
#endif
INC_IP(1);
{
#line 2060 "./prim"
lp += noffset;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(minus_four_lp_plus_store): /* lp- ( -- ) */
/*  */
NAME("lp-")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2063 "./prim"
lp += -sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(eight_lp_plus_store): /* lp+ ( -- ) */
/*  */
NAME("lp+")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2066 "./prim"
lp += sizeof(Float);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(sixteen_lp_plus_store): /* lp+2 ( -- ) */
/*  */
NAME("lp+2")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2069 "./prim"
lp += 2*sizeof(Float);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(lp_store): /* lp! ( c_addr -- ) */
/*  */
NAME("lp!")
{
DEF_CA
Char * c_addr;
NEXT_P0;
vm_Cell2c_(spTOS,c_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
}
#endif
sp += 1;
{
#line 2072 "./prim"
lp = (Address)c_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(to_l): /* >l ( w -- ) */
/*  */
NAME(">l")
{
DEF_CA
Cell w;
NEXT_P0;
vm_Cell2w(spTOS,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
sp += 1;
{
#line 2075 "./prim"
lp -= sizeof(Cell);
*(Cell *)lp = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_FLOATING
LABEL(f_to_l): /* f>l ( r -- ) */
/*  */
NAME("f>l")
{
DEF_CA
Float r;
NEXT_P0;
vm_Float2r(fpTOS,r);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" r=", vm_out); printarg_r(r);
}
#endif
fp += 1;
{
#line 2081 "./prim"
lp -= sizeof(Float);
*(Float *)lp = r;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

LABEL(fpick): /* fpick ( u -- r ) */
/* Actually the stack effect is @code{ r0 ... ru u -- r0 ... ru r0 }. */
NAME("fpick")
{
DEF_CA
UCell u;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
fp += -1;
{
#line 2086 "./prim"
r = fp[u+1]; /* +1, because update of fp happens before this fragment */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
#endif
#ifdef HAS_OS
LABEL(open_lib): /* open-lib ( c_addr1 u1 -- u2 ) */
/*  */
NAME("open-lib")
{
DEF_CA
Char * c_addr1;
UCell u1;
UCell u2;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr1);
vm_Cell2u(spTOS,u1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
}
#endif
sp += 1;
{
#line 2127 "./prim"
#if defined(HAVE_LIBDL) || defined(HAVE_DLOPEN)
#ifndef RTLD_GLOBAL
#define RTLD_GLOBAL 0
#endif
u2=(UCell) dlopen(cstr(c_addr1, u1, 1), RTLD_GLOBAL | RTLD_LAZY);
#else
#  ifdef _WIN32
u2 = (Cell) GetModuleHandle(cstr(c_addr1, u1, 1));
#  else
#warning Define open-lib!
u2 = 0;
#  endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,spTOS);
NEXT_P2;}

LABEL(lib_sym): /* lib-sym ( c_addr1 u1 u2 -- u3 ) */
/*  */
NAME("lib-sym")
{
DEF_CA
Char * c_addr1;
UCell u1;
UCell u2;
UCell u3;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr1);
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 2;
{
#line 2142 "./prim"
#if defined(HAVE_LIBDL) || defined(HAVE_DLOPEN)
u3 = (UCell) dlsym((void*)u2,cstr(c_addr1, u1, 1));
#else
#  ifdef _WIN32
u3 = (Cell) GetProcAddress((HMODULE)u2, cstr(c_addr1, u1, 1));
#  else
#warning Define lib-sym!
u3 = 0;
#  endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u3=", vm_out); printarg_u(u3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u3,spTOS);
NEXT_P2;}

LABEL(icall0): /* icall0 ( u -- uret ) */
/*  */
NAME("icall0")
{
DEF_CA
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)())u)();
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall1): /* icall1 ( u1 u -- uret ) */
/*  */
NAME("icall1")
{
DEF_CA
UCell u1;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)(Cell))u)(u1);
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall2): /* icall2 ( u1 u2 u -- uret ) */
/*  */
NAME("icall2")
{
DEF_CA
UCell u1;
UCell u2;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[2],u1);
vm_Cell2u(sp[1],u2);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 2;
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell))u)(u1, u2);
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall3): /* icall3 ( u1 u2 u3 u -- uret ) */
/*  */
NAME("icall3")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[3],u1);
vm_Cell2u(sp[2],u2);
vm_Cell2u(sp[1],u3);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell))u)(u1, u2, u3);
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall4): /* icall4 ( u1 u2 u3 u4 u -- uret ) */
/*  */
NAME("icall4")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[4],u1);
vm_Cell2u(sp[3],u2);
vm_Cell2u(sp[2],u3);
vm_Cell2u(sp[1],u4);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 4;
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4);
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall5): /* icall5 ( u1 u2 u3 u4 u5 u -- uret ) */
/*  */
NAME("icall5")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[5],u1);
vm_Cell2u(sp[4],u2);
vm_Cell2u(sp[3],u3);
vm_Cell2u(sp[2],u4);
vm_Cell2u(sp[1],u5);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 5;
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5);
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall6): /* icall6 ( u1 u2 u3 u4 u5 u6 u -- uret ) */
/*  */
NAME("icall6")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[6],u1);
vm_Cell2u(sp[5],u2);
vm_Cell2u(sp[4],u3);
vm_Cell2u(sp[3],u4);
vm_Cell2u(sp[2],u5);
vm_Cell2u(sp[1],u6);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 6;
{
#line 2153 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6);
#line 2153
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(icall20): /* icall20 ( u1 u2 u3 u4 u5 u6 u7 u8 u9 u10 u11 u12 u13 u14 u15 u16 u17 u18 u19 u20 u -- uret ) */
/*  */
NAME("icall20")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u7;
UCell u8;
UCell u9;
UCell u10;
UCell u11;
UCell u12;
UCell u13;
UCell u14;
UCell u15;
UCell u16;
UCell u17;
UCell u18;
UCell u19;
UCell u20;
UCell u;
UCell uret;
NEXT_P0;
vm_Cell2u(sp[20],u1);
vm_Cell2u(sp[19],u2);
vm_Cell2u(sp[18],u3);
vm_Cell2u(sp[17],u4);
vm_Cell2u(sp[16],u5);
vm_Cell2u(sp[15],u6);
vm_Cell2u(sp[14],u7);
vm_Cell2u(sp[13],u8);
vm_Cell2u(sp[12],u9);
vm_Cell2u(sp[11],u10);
vm_Cell2u(sp[10],u11);
vm_Cell2u(sp[9],u12);
vm_Cell2u(sp[8],u13);
vm_Cell2u(sp[7],u14);
vm_Cell2u(sp[6],u15);
vm_Cell2u(sp[5],u16);
vm_Cell2u(sp[4],u17);
vm_Cell2u(sp[3],u18);
vm_Cell2u(sp[2],u19);
vm_Cell2u(sp[1],u20);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u7=", vm_out); printarg_u(u7);
fputs(" u8=", vm_out); printarg_u(u8);
fputs(" u9=", vm_out); printarg_u(u9);
fputs(" u10=", vm_out); printarg_u(u10);
fputs(" u11=", vm_out); printarg_u(u11);
fputs(" u12=", vm_out); printarg_u(u12);
fputs(" u13=", vm_out); printarg_u(u13);
fputs(" u14=", vm_out); printarg_u(u14);
fputs(" u15=", vm_out); printarg_u(u15);
fputs(" u16=", vm_out); printarg_u(u16);
fputs(" u17=", vm_out); printarg_u(u17);
fputs(" u18=", vm_out); printarg_u(u18);
fputs(" u19=", vm_out); printarg_u(u19);
fputs(" u20=", vm_out); printarg_u(u20);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 20;
{
#line 2154 "./prim"
uret = (SYSCALL(Cell(*)(Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11, u12, u13, u14, u15, u16, u17, u18, u19, u20);
#line 2154
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" uret=", vm_out); printarg_u(uret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(uret,spTOS);
NEXT_P2;}

LABEL(fcall0): /* fcall0 ( u -- rret ) */
/*  */
NAME("fcall0")
{
DEF_CA
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)())u)();
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall1): /* fcall1 ( u1 u -- rret ) */
/*  */
NAME("fcall1")
{
DEF_CA
UCell u1;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[1],u1);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 2;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)(Cell))u)(u1);
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall2): /* fcall2 ( u1 u2 u -- rret ) */
/*  */
NAME("fcall2")
{
DEF_CA
UCell u1;
UCell u2;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[2],u1);
vm_Cell2u(sp[1],u2);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 3;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell))u)(u1, u2);
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall3): /* fcall3 ( u1 u2 u3 u -- rret ) */
/*  */
NAME("fcall3")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[3],u1);
vm_Cell2u(sp[2],u2);
vm_Cell2u(sp[1],u3);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 4;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell))u)(u1, u2, u3);
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall4): /* fcall4 ( u1 u2 u3 u4 u -- rret ) */
/*  */
NAME("fcall4")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[4],u1);
vm_Cell2u(sp[3],u2);
vm_Cell2u(sp[2],u3);
vm_Cell2u(sp[1],u4);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 5;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4);
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall5): /* fcall5 ( u1 u2 u3 u4 u5 u -- rret ) */
/*  */
NAME("fcall5")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[5],u1);
vm_Cell2u(sp[4],u2);
vm_Cell2u(sp[3],u3);
vm_Cell2u(sp[2],u4);
vm_Cell2u(sp[1],u5);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 6;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5);
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall6): /* fcall6 ( u1 u2 u3 u4 u5 u6 u -- rret ) */
/*  */
NAME("fcall6")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[6],u1);
vm_Cell2u(sp[5],u2);
vm_Cell2u(sp[4],u3);
vm_Cell2u(sp[3],u4);
vm_Cell2u(sp[2],u5);
vm_Cell2u(sp[1],u6);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 7;
fp += -1;
{
#line 2155 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6);
#line 2155
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(fcall20): /* fcall20 ( u1 u2 u3 u4 u5 u6 u7 u8 u9 u10 u11 u12 u13 u14 u15 u16 u17 u18 u19 u20 u -- rret ) */
/*  */
NAME("fcall20")
{
DEF_CA
UCell u1;
UCell u2;
UCell u3;
UCell u4;
UCell u5;
UCell u6;
UCell u7;
UCell u8;
UCell u9;
UCell u10;
UCell u11;
UCell u12;
UCell u13;
UCell u14;
UCell u15;
UCell u16;
UCell u17;
UCell u18;
UCell u19;
UCell u20;
UCell u;
Float rret;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2u(sp[20],u1);
vm_Cell2u(sp[19],u2);
vm_Cell2u(sp[18],u3);
vm_Cell2u(sp[17],u4);
vm_Cell2u(sp[16],u5);
vm_Cell2u(sp[15],u6);
vm_Cell2u(sp[14],u7);
vm_Cell2u(sp[13],u8);
vm_Cell2u(sp[12],u9);
vm_Cell2u(sp[11],u10);
vm_Cell2u(sp[10],u11);
vm_Cell2u(sp[9],u12);
vm_Cell2u(sp[8],u13);
vm_Cell2u(sp[7],u14);
vm_Cell2u(sp[6],u15);
vm_Cell2u(sp[5],u16);
vm_Cell2u(sp[4],u17);
vm_Cell2u(sp[3],u18);
vm_Cell2u(sp[2],u19);
vm_Cell2u(sp[1],u20);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" u4=", vm_out); printarg_u(u4);
fputs(" u5=", vm_out); printarg_u(u5);
fputs(" u6=", vm_out); printarg_u(u6);
fputs(" u7=", vm_out); printarg_u(u7);
fputs(" u8=", vm_out); printarg_u(u8);
fputs(" u9=", vm_out); printarg_u(u9);
fputs(" u10=", vm_out); printarg_u(u10);
fputs(" u11=", vm_out); printarg_u(u11);
fputs(" u12=", vm_out); printarg_u(u12);
fputs(" u13=", vm_out); printarg_u(u13);
fputs(" u14=", vm_out); printarg_u(u14);
fputs(" u15=", vm_out); printarg_u(u15);
fputs(" u16=", vm_out); printarg_u(u16);
fputs(" u17=", vm_out); printarg_u(u17);
fputs(" u18=", vm_out); printarg_u(u18);
fputs(" u19=", vm_out); printarg_u(u19);
fputs(" u20=", vm_out); printarg_u(u20);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 21;
fp += -1;
{
#line 2156 "./prim"
rret = (SYSCALL(Float(*)(Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell, Cell))u)(u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11, u12, u13, u14, u15, u16, u17, u18, u19, u20);
#line 2156
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" rret=", vm_out); printarg_r(rret);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(rret,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#endif
LABEL(up_store): /* up! ( a_addr -- ) */
/*  */
NAME("up!")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 2161 "./prim"
UP=up=(char *)a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(wcall): /* wcall ( u -- ) */
/*  */
NAME("wcall")
{
DEF_CA
UCell u;
NEXT_P0;
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
sp += 1;
{
#line 2167 "./prim"
IF_fpTOS(fp[0]=fpTOS);
FP=fp;
sp=(Cell*)(SYSCALL(Cell(*)(Cell *, void *))u)(sp, &FP);
fp=FP;
IF_spTOS(spTOS=sp[0];)
IF_fpTOS(fpTOS=fp[0]);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

#ifdef HAS_FILE
LABEL(open_dir): /* open-dir ( c_addr u -- wdirid wior ) */
/* Open the directory specified by @i{c-addr, u}
and return @i{dir-id} for futher access to it. */
NAME("open-dir")
{
DEF_CA
Char * c_addr;
UCell u;
Cell wdirid;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[1],c_addr);
vm_Cell2u(spTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 2179 "./prim"
wdirid = (Cell)opendir(tilde_cstr(c_addr, u, 1));
wior =  IOR(wdirid == 0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wdirid=", vm_out); printarg_w(wdirid);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wdirid,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(read_dir): /* read-dir ( c_addr u1 wdirid -- u2 flag wior ) */
/* Attempt to read the next entry from the directory specified
by @i{dir-id} to the buffer of length @i{u1} at address @i{c-addr}. 
If the attempt fails because there is no more entries,
@i{ior}=0, @i{flag}=0, @i{u2}=0, and the buffer is unmodified.
If the attempt to read the next entry fails because of any other reason, 
return @i{ior}<>0.
If the attempt succeeds, store file name to the buffer at @i{c-addr}
and return @i{ior}=0, @i{flag}=true and @i{u2} equal to the size of the file name.
If the length of the file name is greater than @i{u1}, 
store first @i{u1} characters from file name into the buffer and
indicate "name too long" with @i{ior}, @i{flag}=true, and @i{u2}=@i{u1}. */
NAME("read-dir")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wdirid;
UCell u2;
Bool flag;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u1);
vm_Cell2w(spTOS,wdirid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wdirid=", vm_out); printarg_w(wdirid);
}
#endif
{
#line 2194 "./prim"
struct dirent * dent;
dent = readdir((DIR *)wdirid);
wior = 0;
flag = -1;
if(dent == NULL) {
  u2 = 0;
  flag = 0;
} else {
  u2 = strlen(dent->d_name);
  if(u2 > u1) {
    u2 = u1;
    wior = -512-ENAMETOOLONG;
  }
  memmove(c_addr, dent->d_name, u2);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" flag=", vm_out); printarg_f(flag);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,sp[2]);
vm_f2Cell(flag,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(close_dir): /* close-dir ( wdirid -- wior ) */
/* Close the directory specified by @i{dir-id}. */
NAME("close-dir")
{
DEF_CA
Cell wdirid;
Cell wior;
NEXT_P0;
vm_Cell2w(spTOS,wdirid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wdirid=", vm_out); printarg_w(wdirid);
}
#endif
{
#line 2212 "./prim"
wior = IOR(closedir((DIR *)wdirid));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wior,spTOS);
NEXT_P2;}

LABEL(match_file): /* filename-match ( c_addr1 u1 c_addr2 u2 -- flag ) */
/*  */
NAME("filename-match")
{
DEF_CA
Char * c_addr1;
UCell u1;
Char * c_addr2;
UCell u2;
Bool flag;
NEXT_P0;
vm_Cell2c_(sp[3],c_addr1);
vm_Cell2u(sp[2],u1);
vm_Cell2c_(sp[1],c_addr2);
vm_Cell2u(spTOS,u2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr1=", vm_out); printarg_c_(c_addr1);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" c_addr2=", vm_out); printarg_c_(c_addr2);
fputs(" u2=", vm_out); printarg_u(u2);
}
#endif
sp += 3;
{
#line 2215 "./prim"
char * string = cstr(c_addr1, u1, 1);
char * pattern = cstr(c_addr2, u2, 0);
flag = FLAG(!fnmatch(pattern, string, 0));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" flag=", vm_out); printarg_f(flag);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_f2Cell(flag,spTOS);
NEXT_P2;}

#endif
LABEL(newline): /* newline ( -- c_addr u ) */
/* String containing the newline sequence of the host OS */
NAME("newline")
{
DEF_CA
Char * c_addr;
UCell u;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -2;
{
#line 2223 "./prim"
char newline[] = {
#if defined(unix) || defined(__MACH__)
/* Darwin/MacOS X sets __MACH__, but not unix. */
'\n'
#else
'\r','\n'
#endif
};
c_addr=newline;
u=sizeof(newline);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_c_2Cell(c_addr,sp[1]);
vm_u2Cell(u,spTOS);
NEXT_P2;}

#ifdef HAS_OS
LABEL(utime): /* utime ( -- dtime ) */
/* Report the current time in microseconds since some epoch. */
NAME("utime")
{
DEF_CA
DCell dtime;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -2;
{
#line 2241 "./prim"
struct timeval time1;
gettimeofday(&time1,NULL);
dtime = timeval2us(&time1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" dtime=", vm_out); printarg_d(dtime);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(dtime, sp[1], spTOS)
NEXT_P2;}

LABEL(cputime): /* cputime ( -- duser dsystem ) */
/* duser and dsystem are the respective user- and system-level CPU
times used since the start of the Forth system (excluding child
processes), in microseconds (the granularity may be much larger,
however).  On platforms without the getrusage call, it reports elapsed
time (since some epoch) for duser and 0 for dsystem. */
NAME("cputime")
{
DEF_CA
DCell duser;
DCell dsystem;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -4;
{
#line 2251 "./prim"
#ifdef HAVE_GETRUSAGE
struct rusage usage;
getrusage(RUSAGE_SELF, &usage);
duser = timeval2us(&usage.ru_utime);
dsystem = timeval2us(&usage.ru_stime);
#else
struct timeval time1;
gettimeofday(&time1,NULL);
duser = timeval2us(&time1);
#ifndef BUGGY_LONG_LONG
dsystem = (DCell)0;
#else
dsystem=(DCell){0,0};
#endif
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" duser=", vm_out); printarg_d(duser);
fputs(" dsystem=", vm_out); printarg_d(dsystem);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_d2twoCell(duser, sp[3], sp[2])
vm_d2twoCell(dsystem, sp[1], spTOS)
NEXT_P2;}

#endif
#ifdef HAS_FLOATING
LABEL(v_star): /* v* ( f_addr1 nstride1 f_addr2 nstride2 ucount -- r ) */
/* dot-product: r=v1*v2.  The first element of v1 is at f_addr1, the
next at f_addr1+nstride1 and so on (similar for v2). Both vectors have
ucount elements. */
NAME("v*")
{
DEF_CA
Float * f_addr1;
Cell nstride1;
Float * f_addr2;
Cell nstride2;
UCell ucount;
Float r;
NEXT_P0;
IF_fpTOS(fp[0] = fpTOS);
vm_Cell2f_(sp[4],f_addr1);
vm_Cell2n(sp[3],nstride1);
vm_Cell2f_(sp[2],f_addr2);
vm_Cell2n(sp[1],nstride2);
vm_Cell2u(spTOS,ucount);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" f_addr1=", vm_out); printarg_f_(f_addr1);
fputs(" nstride1=", vm_out); printarg_n(nstride1);
fputs(" f_addr2=", vm_out); printarg_f_(f_addr2);
fputs(" nstride2=", vm_out); printarg_n(nstride2);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
sp += 5;
fp += -1;
{
#line 2275 "./prim"
for (r=0.; ucount>0; ucount--) {
  r += *f_addr1 * *f_addr2;
  f_addr1 = (Float *)(((Address)f_addr1)+nstride1);
  f_addr2 = (Float *)(((Address)f_addr2)+nstride2);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" r=", vm_out); printarg_r(r);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_r2Float(r,fpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(faxpy): /* faxpy ( ra f_x nstridex f_y nstridey ucount -- ) */
/* vy=ra*vx+vy */
NAME("faxpy")
{
DEF_CA
Float ra;
Float * f_x;
Cell nstridex;
Float * f_y;
Cell nstridey;
UCell ucount;
NEXT_P0;
vm_Float2r(fpTOS,ra);
vm_Cell2f_(sp[4],f_x);
vm_Cell2n(sp[3],nstridex);
vm_Cell2f_(sp[2],f_y);
vm_Cell2n(sp[1],nstridey);
vm_Cell2u(spTOS,ucount);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ra=", vm_out); printarg_r(ra);
fputs(" f_x=", vm_out); printarg_f_(f_x);
fputs(" nstridex=", vm_out); printarg_n(nstridex);
fputs(" f_y=", vm_out); printarg_f_(f_y);
fputs(" nstridey=", vm_out); printarg_n(nstridey);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
sp += 5;
fp += 1;
{
#line 2287 "./prim"
for (; ucount>0; ucount--) {
  *f_y += ra * *f_x;
  f_x = (Float *)(((Address)f_x)+nstridex);
  f_y = (Float *)(((Address)f_y)+nstridey);
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_fpTOS(fpTOS = fp[0]);
NEXT_P2;}

#endif
#ifdef HAS_FILE
LABEL(paren_read_line): /* (read-line) ( c_addr u1 wfileid -- u2 flag u3 wior ) */
/*  */
NAME("(read-line)")
{
DEF_CA
Char * c_addr;
UCell u1;
Cell wfileid;
UCell u2;
Bool flag;
UCell u3;
Cell wior;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u1);
vm_Cell2w(spTOS,wfileid);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" wfileid=", vm_out); printarg_w(wfileid);
}
#endif
sp += -1;
{
#line 2302 "./prim"
Cell c;
flag=-1;
u3=0;
for(u2=0; u2<u1; u2++)
{
   c = getc((FILE *)wfileid);
   u3++;
   if (c=='\n') break;
   if (c=='\r') {
     if ((c = getc((FILE *)wfileid))!='\n')
       ungetc(c,(FILE *)wfileid);
     else
       u3++;
     break;
   }
   if (c==EOF) {
	flag=FLAG(u2!=0);
	break;
     }
   c_addr[u2] = (Char)c;
}
wior=FILEIO(ferror((FILE *)wfileid));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u2=", vm_out); printarg_u(u2);
fputs(" flag=", vm_out); printarg_f(flag);
fputs(" u3=", vm_out); printarg_u(u3);
fputs(" wior=", vm_out); printarg_w(wior);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_u2Cell(u2,sp[3]);
vm_f2Cell(flag,sp[2]);
vm_u2Cell(u3,sp[1]);
vm_w2Cell(wior,spTOS);
NEXT_P2;}

#endif
LABEL(paren_listlfind): /* (listlfind) ( c_addr u longname1 -- longname2 ) */
/*  */
NAME("(listlfind)")
{
DEF_CA
Char * c_addr;
UCell u;
struct Longname * longname1;
struct Longname * longname2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2longname(spTOS,longname1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" longname1=", vm_out); printarg_longname(longname1);
}
#endif
sp += 2;
{
#line 2328 "./prim"
for (; longname1 != NULL; longname1 = (struct Longname *)(longname1->next))
  if ((UCell)LONGNAME_COUNT(longname1)==u &&
      memcasecmp(c_addr, longname1->name, u)== 0 /* or inline? */)
    break;
longname2=longname1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" longname2=", vm_out); printarg_longname(longname2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_longname2Cell(longname2,spTOS);
NEXT_P2;}

#ifdef HAS_HASH
LABEL(paren_hashlfind): /* (hashlfind) ( c_addr u a_addr -- longname2 ) */
/*  */
NAME("(hashlfind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct Longname * longname2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 2345 "./prim"
struct Longname *longname1;
longname2=NULL;
while(a_addr != NULL)
{
   longname1=(struct Longname *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)LONGNAME_COUNT(longname1)==u &&
       memcasecmp(c_addr, longname1->name, u)== 0 /* or inline? */)
     {
	longname2=longname1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" longname2=", vm_out); printarg_longname(longname2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_longname2Cell(longname2,spTOS);
NEXT_P2;}

LABEL(paren_tablelfind): /* (tablelfind) ( c_addr u a_addr -- longname2 ) */
/* A case-sensitive variant of @code{(hashfind)} */
NAME("(tablelfind)")
{
DEF_CA
Char * c_addr;
UCell u;
Cell * a_addr;
struct Longname * longname2;
NEXT_P0;
vm_Cell2c_(sp[2],c_addr);
vm_Cell2u(sp[1],u);
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 2;
{
#line 2368 "./prim"
struct Longname *longname1;
longname2=NULL;
while(a_addr != NULL)
{
   longname1=(struct Longname *)(a_addr[1]);
   a_addr=(Cell *)(a_addr[0]);
   if ((UCell)LONGNAME_COUNT(longname1)==u &&
       memcmp(c_addr, longname1->name, u)== 0 /* or inline? */)
     {
	longname2=longname1;
	break;
     }
}
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" longname2=", vm_out); printarg_longname(longname2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_longname2Cell(longname2,spTOS);
NEXT_P2;}

#endif
#ifdef HAS_PEEPHOLE
GROUP( peephole)
LABEL(primtable): /* primtable ( -- wprimtable ) */
/* wprimtable is a table containing the xts of the primitives indexed
by sequence-number in prim (for use in prepare-peephole-table). */
NAME("primtable")
{
DEF_CA
Cell wprimtable;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
sp += -1;
{
#line 2398 "./prim"
wprimtable = (Cell)primtable(symbols+DOESJUMP+1,MAX_SYMBOLS-DOESJUMP-1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wprimtable=", vm_out); printarg_w(wprimtable);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wprimtable,spTOS);
NEXT_P2;}

LABEL(prepare_peephole_opt): /* prepare-peephole-table ( wprimtable -- wpeeptable ) */
/* wpeeptable is a data structure used by @code{peephole-opt}; it is
constructed by combining a primitives table with a simple peephole
optimization table. */
NAME("prepare-peephole-table")
{
DEF_CA
Cell wprimtable;
Cell wpeeptable;
NEXT_P0;
vm_Cell2w(spTOS,wprimtable);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" wprimtable=", vm_out); printarg_w(wprimtable);
}
#endif
{
#line 2404 "./prim"
wpeeptable = prepare_peephole_table((Xt *)wprimtable);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" wpeeptable=", vm_out); printarg_w(wpeeptable);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_w2Cell(wpeeptable,spTOS);
NEXT_P2;}

LABEL(peephole_opt): /* peephole-opt ( xt1 xt2 wpeeptable -- xt ) */
/* xt is the combination of xt1 and xt2 (according to wpeeptable); if
they cannot be combined, xt is 0. */
NAME("peephole-opt")
{
DEF_CA
Xt xt1;
Xt xt2;
Cell wpeeptable;
Xt xt;
NEXT_P0;
vm_Cell2xt(sp[2],xt1);
vm_Cell2xt(sp[1],xt2);
vm_Cell2w(spTOS,wpeeptable);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt1=", vm_out); printarg_xt(xt1);
fputs(" xt2=", vm_out); printarg_xt(xt2);
fputs(" wpeeptable=", vm_out); printarg_w(wpeeptable);
}
#endif
sp += 2;
{
#line 2409 "./prim"
xt = peephole_opt(xt1, xt2, wpeeptable);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" xt=", vm_out); printarg_xt(xt);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_xt2Cell(xt,spTOS);
NEXT_P2;}

LABEL(call): /* call ( #a_callee -- R:a_retaddr ) */
/* Call callee (a variant of docol with inline argument). */
NAME("call")
{
DEF_CA
Cell * a_callee;
Cell * a_retaddr;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2a_(IPTOS,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
INC_IP(1);
rp += -1;
{
#line 2413 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_retaddr,rpTOS);
NEXT_P2;}

LABEL(useraddr): /* useraddr ( #u -- a_addr ) */
/*  */
NAME("useraddr")
{
DEF_CA
UCell u;
Cell * a_addr;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2u(IPTOS,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
INC_IP(1);
sp += -1;
{
#line 2424 "./prim"
a_addr = (Cell *)(up+u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_a_2Cell(a_addr,spTOS);
NEXT_P2;}

LABEL(compile_prim): /* compile-prim ( xt1 -- xt2 ) */
/*  */
NAME("compile-prim")
{
DEF_CA
Xt xt1;
Xt xt2;
NEXT_P0;
vm_Cell2xt(spTOS,xt1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" xt1=", vm_out); printarg_xt(xt1);
}
#endif
{
#line 2427 "./prim"
xt2 = (Xt)compile_prim((Label)xt1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" xt2=", vm_out); printarg_xt(xt2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_xt2Cell(xt2,spTOS);
NEXT_P2;}

LABEL(lit_fetch):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2427 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2427 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(lit_perform): /* lit-perform ( #a_addr -- ) */
/*  */
NAME("lit-perform")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(IPTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
INC_IP(1);
{
#line 2432 "./prim"
ip=IP;
SUPER_END;
EXEC(*(Xt *)a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(lit_plus):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2432 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2432 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(does_exec): /* does-exec ( #a_cfa -- R:nest a_pfa ) */
/*  */
NAME("does-exec")
{
DEF_CA
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2a_(IPTOS,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
INC_IP(1);
sp += -1;
rp += -1;
{
#line 2439 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_n2Cell(nest,rpTOS);
vm_a_2Cell(a_pfa,spTOS);
NEXT_P2;}

LABEL(register_compile): /* register-compile ( a_addr -- ) */
/*  */
NAME("register-compile")
{
DEF_CA
Cell * a_addr;
NEXT_P0;
vm_Cell2a_(spTOS,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
sp += 1;
{
#line 2452 "./prim"
register_compile((Label *)a_addr);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(bbend): /* bbend ( -- ) */
/*  */
NAME("bbend")
{
DEF_CA
NEXT_P0;
#ifdef VM_DEBUG
if (vm_debug) {
}
#endif
{
#line 2455 "./prim"
bbend();
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super1):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super2):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super3):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 3;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super4):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super5):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super6):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super7):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super8):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super9):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super10):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super11):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super12):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super13):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super14):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super15):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
rp += -1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super16):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super17):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super18):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super19):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super20):
{
DEF_CA
Cell _sp0;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super21):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super22):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super23):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super24):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super25):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super26):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super27):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super28):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
rp += -1;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super29):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
rp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super30):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super31):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
rp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super32):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
rp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super33):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super34):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super35):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super36):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 3;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super37):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super38):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super39):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super40):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super41):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super42):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super43):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super44):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super45):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super46):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super47):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super48):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super49):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super50):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super51):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super52):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super53):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super54):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super55):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super56):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super57):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super58):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super59):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super60):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super61):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super62):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super63):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += -1;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super64):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super65):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super66):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super67):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super68):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super69):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super70):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super71):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super72):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super73):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super74):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super75):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super76):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super77):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super78):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super79):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super80):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super81):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super82):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super83):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super84):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super85):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super86):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super87):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super88):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super89):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super90):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super91):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super92):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super93):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super94):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super95):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super96):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super97):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* useraddr ( #u -- a_addr ) */
NAME("useraddr")
{
UCell u;
Cell * a_addr;
vm_Cell2u(_IP0,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 2455 "./prim"
a_addr = (Cell *)(up+u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_addr,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super98):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super99):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super100):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super101):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super102):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super103):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super104):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super105):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* useraddr ( #u -- a_addr ) */
NAME("useraddr")
{
UCell u;
Cell * a_addr;
vm_Cell2u(_IP0,u);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u=", vm_out); printarg_u(u);
}
#endif
{
#line 2455 "./prim"
a_addr = (Cell *)(up+u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_addr=", vm_out); printarg_a_(a_addr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_addr,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super106):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super107):
{
DEF_CA
Cell _sp0;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super108):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super109):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super110):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super111):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super112):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super113):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super114):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super115):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super116):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super117):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super118):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super119):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super120):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super121):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super122):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -3;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super123):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super124):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super125):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super126):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super127):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super128):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super129):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super130):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super131):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super132):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super133):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super134):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super135):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super136):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super137):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super138):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super139):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super140):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super141):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super142):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super143):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super144):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super145):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super146):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super147):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super148):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super149):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super150):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super151):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super152):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super153):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -2;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super154):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super155):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super156):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super157):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super158):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super159):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super160):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super161):
{
DEF_CA
Cell _sp0;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super162):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super163):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super164):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
rp += -3;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[2]);
vm_Cell2Cell(_rp1,rp[1]);
vm_Cell2Cell(_rp2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super165):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super166):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
rp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super167):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super168):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += -3;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super169):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super170):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super171):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super172):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super173):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super174):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super175):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super176):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super177):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super178):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super179):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super180):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super181):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super182):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super183):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super184):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super185):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super186):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super187):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super188):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super189):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super190):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super191):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super192):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super193):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super194):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super195):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super196):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super197):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super198):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super199):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super200):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super201):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super202):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super203):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super204):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super205):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super206):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super207):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super208):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super209):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super210):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super211):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super212):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super213):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super214):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super215):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super216):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super217):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super218):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super219):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super220):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super221):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super222):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super223):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super224):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super225):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super226):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super227):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[2],_rp0);
vm_Cell2Cell(rp[1],_rp1);
vm_Cell2Cell(rpTOS,_rp2);
sp += -2;
rp += 3;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super228):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super229):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super230):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super231):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super232):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super233):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super234):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super235):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super236):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super237):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super238):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super239):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super240):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super241):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super242):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super243):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super244):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super245):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super246):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super247):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super248):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super249):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super250):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super251):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super252):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super253):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super254):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super255):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super256):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(spTOS,_sp0);
sp += 1;
rp += -2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super257):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
rp += -3;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[2]);
vm_Cell2Cell(_rp1,rp[1]);
vm_Cell2Cell(_rp2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super258):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super259):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super260):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super261):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super262):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super263):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 3;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super264):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 3;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super265):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super266):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super267):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super268):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super269):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super270):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super271):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super272):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super273):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[3],_rp0);
vm_Cell2Cell(rp[2],_rp1);
vm_Cell2Cell(rp[1],_rp2);
vm_Cell2Cell(rpTOS,_rp3);
sp += -4;
rp += 4;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super274):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super275):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super276):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super277):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super278):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super279):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super280):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super281):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super282):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super283):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super284):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super285):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super286):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super287):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super288):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super289):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super290):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super291):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super292):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super293):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super294):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super295):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super296):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super297):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super298):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super299):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super300):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super301):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super302):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super303):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super304):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super305):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super306):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super307):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp2););
vm_w2Cell(w1,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super308):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super309):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super310):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super311):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super312):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super313):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super314):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super315):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super316):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super317):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super318):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super319):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super320):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super321):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super322):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super323):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super324):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super325):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super326):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -3;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super327):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super328):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super329):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super330):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super331):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super332):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super333):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super334):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super335):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super336):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super337):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super338):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp2););
vm_w2Cell(w1,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super339):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp2););
vm_w2Cell(w1,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super340):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super341):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super342):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super343):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super344):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super345):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super346):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super347):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super348):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super349):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super350):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super351):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 0< ( n -- f ) */
NAME("0<")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n<0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super352):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += -1;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super353):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(2);
sp += -2;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super354):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(2);
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super355):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super356):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super357):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super358):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super359):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super360):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super361):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
rp += -2;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super362):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super363):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super364):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super365):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super366):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super367):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super368):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super369):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
rp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super370):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* within ( u1 u2 u3 -- f ) */
NAME("within")
{
UCell u1;
UCell u2;
UCell u3;
Bool f;
vm_Cell2u(_sp0,u1);
vm_Cell2u(_sp1,u2);
vm_Cell2u(_sp2,u3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
}
#endif
{
#line 2455 "./prim"
f = FLAG(u1-u2 < u3-u2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super371):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* within ( u1 u2 u3 -- f ) */
NAME("within")
{
UCell u1;
UCell u2;
UCell u3;
Bool f;
vm_Cell2u(_sp0,u1);
vm_Cell2u(_sp1,u2);
vm_Cell2u(_sp2,u3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
}
#endif
{
#line 2455 "./prim"
f = FLAG(u1-u2 < u3-u2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super372):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -3;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
NEXT_P2;}

LABEL(super373):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -3;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
NEXT_P2;}

LABEL(super374):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -4;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
NEXT_P2;}

LABEL(super375):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -4;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp5,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
NEXT_P2;}

LABEL(super376):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp5,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d1)
vm_twoCell2d((Cell)_sp4, (Cell)_sp5, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super377):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp4);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp5,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp5);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d1)
vm_twoCell2d((Cell)_sp4, (Cell)_sp5, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super378):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super379):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super380):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super381):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super382):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super383):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp1);
vm_w2Cell(w2,_rp2);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super384):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
rp += -2;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super385):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
rp += -2;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super386):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
rp += -2;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super387):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
rp += -2;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super388):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
rp += -2;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super389):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -3;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
NEXT_P2;}

LABEL(super390):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -3;
rp += 1;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp1);
vm_w2Cell(w2,_rp2);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super391):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super392):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super393):
{
DEF_CA
Cell _sp0;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super394):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super395):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
rp += -1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super396):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
sp += -2;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super397):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super398):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super399):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super400):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super401):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super402):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += -2;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp3,w1);
vm_Cell2w(_sp4,w2);
vm_Cell2w(_sp5,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp3);
vm_w2Cell(w3,_sp4);
vm_w2Cell(w1,_sp5);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
NEXT_P2;}

LABEL(super403):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += -2;
rp += 1;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp3,w1);
vm_Cell2w(_sp4,w2);
vm_Cell2w(_sp5,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp3);
vm_w2Cell(w3,_sp4);
vm_w2Cell(w1,_sp5);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super404):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super405):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super406):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 3;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super407):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super408):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super409):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super410):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super411):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super412):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super413):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 3;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super414):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[5],_sp0);
vm_Cell2Cell(sp[4],_sp1);
vm_Cell2Cell(sp[3],_sp2);
vm_Cell2Cell(sp[2],_sp3);
vm_Cell2Cell(sp[1],_sp4);
vm_Cell2Cell(spTOS,_sp5);
sp += 3;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
NAME("-rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w3,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super415):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[5],_sp0);
vm_Cell2Cell(sp[4],_sp1);
vm_Cell2Cell(sp[3],_sp2);
vm_Cell2Cell(sp[2],_sp3);
vm_Cell2Cell(sp[1],_sp4);
vm_Cell2Cell(spTOS,_sp5);
sp += 1;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
NAME("-rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w3,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
NEXT_P2;}

LABEL(super416):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[5],_sp0);
vm_Cell2Cell(sp[4],_sp1);
vm_Cell2Cell(sp[3],_sp2);
vm_Cell2Cell(sp[2],_sp3);
vm_Cell2Cell(sp[1],_sp4);
vm_Cell2Cell(spTOS,_sp5);
sp += 4;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
NAME("-rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w3,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super417):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[5],_sp0);
vm_Cell2Cell(sp[4],_sp1);
vm_Cell2Cell(sp[3],_sp2);
vm_Cell2Cell(sp[2],_sp3);
vm_Cell2Cell(sp[1],_sp4);
vm_Cell2Cell(spTOS,_sp5);
sp += 5;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
NAME("-rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w3,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super418):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(sp[5],_sp0);
vm_Cell2Cell(sp[4],_sp1);
vm_Cell2Cell(sp[3],_sp2);
vm_Cell2Cell(sp[2],_sp3);
vm_Cell2Cell(sp[1],_sp4);
vm_Cell2Cell(spTOS,_sp5);
vm_Cell2Cell(rpTOS,_rp0);
sp += 5;
rp += 1;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp1);
vm_w2Cell(w2,_rp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* -rot ( w1 w2 w3 -- w3 w1 w2 ) */
NAME("-rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w3,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super419):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += 1;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super420):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += 2;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super421):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rp[2],_rp0);
vm_Cell2Cell(rp[1],_rp1);
vm_Cell2Cell(rpTOS,_rp2);
sp += 2;
rp += 3;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super422):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super423):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super424):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super425):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super426):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super427):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super428):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super429):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super430):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super431):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super432):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super433):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super434):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super435):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* 0< ( n -- f ) */
NAME("0<")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n<0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super436):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super437):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* 0< ( n -- f ) */
NAME("0<")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n<0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super438):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -3;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[2]);
vm_Cell2Cell(_rp1,rp[1]);
vm_Cell2Cell(_rp2,rpTOS);
NEXT_P2;}

LABEL(super439):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super440):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super441):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super442):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super443):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super444):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super445):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super446):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super447):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super448):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super449):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super450):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super451):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super452):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rp[2],_rp0);
vm_Cell2Cell(rp[1],_rp1);
vm_Cell2Cell(rpTOS,_rp2);
INC_IP(1);
rp += 3;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super453):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super454):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp2,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super455):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp2,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super456):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super457):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super458):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super459):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* branch ( #ndisp -- ) */
NAME("branch")
{
Cell ndisp;
vm_Cell2n(_IP0,ndisp);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super460):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super461):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super462):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super463):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super464):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super465):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super466):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super467):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 4;
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super468):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 4;
rp += 1;
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super469):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super470):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super471):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
rp += -2;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super472):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 3;
rp += -4;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp2);
vm_w2Cell(w2,_rp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputs(" _rp3=", vm_out); printarg_Cell(_rp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[3]);
vm_Cell2Cell(_rp1,rp[2]);
vm_Cell2Cell(_rp2,rp[1]);
vm_Cell2Cell(_rp3,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super473):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
Cell _rp4;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 3;
rp += -5;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp2);
vm_w2Cell(w2,_rp3);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp4);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputs(" _rp3=", vm_out); printarg_Cell(_rp3);
fputs(" _rp4=", vm_out); printarg_Cell(_rp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[4]);
vm_Cell2Cell(_rp1,rp[3]);
vm_Cell2Cell(_rp2,rp[2]);
vm_Cell2Cell(_rp3,rp[1]);
vm_Cell2Cell(_rp4,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super474):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
rp += -3;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[2]);
vm_Cell2Cell(_rp1,rp[1]);
vm_Cell2Cell(_rp2,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super475):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
rp += -4;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputs(" _rp3=", vm_out); printarg_Cell(_rp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[3]);
vm_Cell2Cell(_rp1,rp[2]);
vm_Cell2Cell(_rp2,rp[1]);
vm_Cell2Cell(_rp3,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super476):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[4],_sp0);
vm_Cell2Cell(sp[3],_sp1);
vm_Cell2Cell(sp[2],_sp2);
vm_Cell2Cell(sp[1],_sp3);
vm_Cell2Cell(spTOS,_sp4);
INC_IP(1);
sp += 1;
rp += -4;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp3,w1);
vm_Cell2w(_sp4,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp3);
}
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputs(" _rp3=", vm_out); printarg_Cell(_rp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rp[3]);
vm_Cell2Cell(_rp1,rp[2]);
vm_Cell2Cell(_rp2,rp[1]);
vm_Cell2Cell(_rp3,rpTOS);
NEXT_P2;}

LABEL(super477):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
Cell _rp4;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[4],_sp0);
vm_Cell2Cell(sp[3],_sp1);
vm_Cell2Cell(sp[2],_sp2);
vm_Cell2Cell(sp[1],_sp3);
vm_Cell2Cell(spTOS,_sp4);
INC_IP(2);
sp += 1;
rp += -5;
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp3,w1);
vm_Cell2w(_sp4,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp3);
}
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp4);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputs(" _rp3=", vm_out); printarg_Cell(_rp3);
fputs(" _rp4=", vm_out); printarg_Cell(_rp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rp[4]);
vm_Cell2Cell(_rp1,rp[3]);
vm_Cell2Cell(_rp2,rp[2]);
vm_Cell2Cell(_rp3,rp[1]);
vm_Cell2Cell(_rp4,rpTOS);
NEXT_P2;}

LABEL(super478):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super479):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += 2;
rp += 2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super480):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
Cell _rp4;
Cell _rp5;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[5],_rp0);
vm_Cell2Cell(rp[4],_rp1);
vm_Cell2Cell(rp[3],_rp2);
vm_Cell2Cell(rp[2],_rp3);
vm_Cell2Cell(rp[1],_rp4);
vm_Cell2Cell(rpTOS,_rp5);
sp += -6;
rp += 6;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp4,w1);
vm_Cell2w(_rp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super481):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
Cell _rp4;
Cell _rp5;
Cell _rp6;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[6],_rp0);
vm_Cell2Cell(rp[5],_rp1);
vm_Cell2Cell(rp[4],_rp2);
vm_Cell2Cell(rp[3],_rp3);
vm_Cell2Cell(rp[2],_rp4);
vm_Cell2Cell(rp[1],_rp5);
vm_Cell2Cell(rpTOS,_rp6);
sp += -6;
rp += 7;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp5,w1);
vm_Cell2w(_rp6,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp3,w1);
vm_Cell2w(_rp4,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super482):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
Cell _rp4;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[4],_rp0);
vm_Cell2Cell(rp[3],_rp1);
vm_Cell2Cell(rp[2],_rp2);
vm_Cell2Cell(rp[1],_rp3);
vm_Cell2Cell(rpTOS,_rp4);
sp += -4;
rp += 5;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp3,w1);
vm_Cell2w(_rp4,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super483):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
rp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super484):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
rp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super485):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
rp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super486):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super487):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super488):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 3;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp2,w);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super489):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 3;
rp += 1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp2,w);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super490):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
rp += -1;
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super491):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super492):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super493):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super494):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super495):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super496):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super497):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super498):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super499):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super500):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += -1;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super501):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super502):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[2],_rp0);
vm_Cell2Cell(rp[1],_rp1);
vm_Cell2Cell(rpTOS,_rp2);
rp += 3;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super503):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super504):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super505):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += 1;
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* (loop) ( #ndisp R:nlimit R:n1 -- R:nlimit R:n2 ) */
NAME("(loop)")
{
Cell ndisp;
Cell nlimit;
Cell n1;
Cell n2;
vm_Cell2n(_IP0,ndisp);
vm_Cell2n(_rp0,nlimit);
vm_Cell2n(_rp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2=n1+1;
#line 256
if (n2 != nlimit) {
#line 256
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 256

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_rp1);
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 256
}
#line 256
SUPER_CONTINUE;
#line 256
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super506):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super507):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super508):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super509):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super510):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super511):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super512):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super513):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super514):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super515):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super516):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super517):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super518):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super519):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super520):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super521):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super522):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super523):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super524):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super525):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rp[2],_rp0);
vm_Cell2Cell(rp[1],_rp1);
vm_Cell2Cell(rpTOS,_rp2);
INC_IP(2);
rp += 3;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super526):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super527):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super528):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super529):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super530):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super531):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super532):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super533):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super534):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super535):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rp[3],_rp0);
vm_Cell2Cell(rp[2],_rp1);
vm_Cell2Cell(rp[1],_rp2);
vm_Cell2Cell(rpTOS,_rp3);
INC_IP(2);
sp += -2;
rp += 4;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super536):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(rp[3],_rp0);
vm_Cell2Cell(rp[2],_rp1);
vm_Cell2Cell(rp[1],_rp2);
vm_Cell2Cell(rpTOS,_rp3);
INC_IP(3);
sp += -3;
rp += 4;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super537):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(rp[3],_rp0);
vm_Cell2Cell(rp[2],_rp1);
vm_Cell2Cell(rp[1],_rp2);
vm_Cell2Cell(rpTOS,_rp3);
INC_IP(3);
sp += -1;
rp += 4;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super538):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(rp[3],_rp0);
vm_Cell2Cell(rp[2],_rp1);
vm_Cell2Cell(rp[1],_rp2);
vm_Cell2Cell(rpTOS,_rp3);
INC_IP(4);
sp += -2;
rp += 4;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super539):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(rp[3],_rp0);
vm_Cell2Cell(rp[2],_rp1);
vm_Cell2Cell(rp[1],_rp2);
vm_Cell2Cell(rpTOS,_rp3);
INC_IP(4);
rp += 4;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp2,w1);
vm_Cell2w(_rp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super540):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
Cell _rp3;
Cell _rp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(rp[4],_rp0);
vm_Cell2Cell(rp[3],_rp1);
vm_Cell2Cell(rp[2],_rp2);
vm_Cell2Cell(rp[1],_rp3);
vm_Cell2Cell(rpTOS,_rp4);
INC_IP(4);
rp += 5;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp3,w1);
vm_Cell2w(_rp4,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp1,w1);
vm_Cell2w(_rp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super541):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp0);
vm_n2Cell(n4,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super542):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super543):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
rp += -1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super544):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 1;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d1)
vm_twoCell2d((Cell)_sp4, (Cell)_sp5, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super545):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d1)
vm_twoCell2d((Cell)_sp4, (Cell)_sp5, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super546):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += -1;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d1)
vm_twoCell2d((Cell)_sp4, (Cell)_sp5, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp3);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super547):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super548):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super549):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super550):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super551):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super552):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 3;
rp += 1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super553):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super554):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super555):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super556):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super557):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super558):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super559):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super560):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super561):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super562):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += 1;
rp += 2;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super563):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super564):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
rp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super565):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 3;
rp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super566):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super567):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
sp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super568):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
sp += 4;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super569):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 4;
rp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
vm_Cell2w(_sp3,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w3,_sp2);
vm_w2Cell(w1,_sp3);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super570):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 2;
rp += -1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super571):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 3;
rp += -1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super572):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super573):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
sp += 1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super574):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
sp += 4;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super575):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 4;
rp += 1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super576):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super577):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super578):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super579):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += 2;
rp += 2;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super580):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super581):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 3;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super582):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super583):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 3;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super584):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super585):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super586):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super587):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super588):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
rp += -1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super589):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super590):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 3;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super591):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super592):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super593):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super594):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super595):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super596):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super597):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super598):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super599):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super600):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super601):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super602):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super603):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super604):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super605):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super606):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super607):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super608):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super609):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super610):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 0<> ( n -- f ) */
NAME("0<>")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n!=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super611):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 0<> ( n -- f ) */
NAME("0<>")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n!=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super612):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 0<> ( n -- f ) */
NAME("0<>")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n!=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super613):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super614):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
rp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super615):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super616):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super617):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
rp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super618):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super619):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super620):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super621):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super622):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super623):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super624):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super625):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super626):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super627):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super628):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super629):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super630):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super631):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super632):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super633):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super634):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super635):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super636):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super637):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super638):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super639):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super640):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super641):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* branch ( #ndisp -- ) */
NAME("branch")
{
Cell ndisp;
vm_Cell2n(_IP0,ndisp);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super642):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* branch ( #ndisp -- ) */
NAME("branch")
{
Cell ndisp;
vm_Cell2n(_IP1,ndisp);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super643):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super644):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super645):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super646):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super647):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super648):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super649):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super650):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super651):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super652):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super653):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super654):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super655):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super656):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super657):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super658):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super659):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* 2drop ( w1 w2 -- ) */
NAME("2drop")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* drop ( w -- ) */
NAME("drop")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super660):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
rp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super661):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super662):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super663):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super664):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super665):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super666):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super667):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super668):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super669):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super670):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super671):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super672):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super673):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super674):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super675):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super676):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super677):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super678):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super679):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super680):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super681):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super682):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super683):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super684):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super685):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super686):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super687):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super688):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super689):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super690):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super691):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super692):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super693):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super694):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super695):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super696):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super697):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super698):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super699):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super700):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super701):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super702):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super703):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super704):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super705):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super706):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super707):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super708):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super709):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super710):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super711):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super712):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super713):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super714):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super715):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super716):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super717):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super718):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super719):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super720):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super721):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super722):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super723):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super724):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super725):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super726):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* 0<> ( n -- f ) */
NAME("0<>")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n!=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super727):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* 0<> ( n -- f ) */
NAME("0<>")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n!=0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super728):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super729):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super730):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super731):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super732):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super733):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super734):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super735):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super736):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super737):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super738):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super739):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super740):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super741):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super742):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super743):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super744):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super745):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super746):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super747):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super748):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super749):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super750):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super751):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super752):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super753):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super754):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super755):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super756):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super757):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super758):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super759):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super760):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super761):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super762):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super763):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super764):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
}
/* nip ( w1 w2 -- w2 ) */
NAME("nip")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super765):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super766):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super767):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super768):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super769):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super770):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super771):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super772):
{
DEF_CA
Cell _sp0;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super773):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super774):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super775):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super776):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super777):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP0,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super778):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP0,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super779):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super780):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super781):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP1,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super782):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super783):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super784):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
rp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP1,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super785):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP1,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super786):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super787):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super788):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP2,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super789):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super790):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super791):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super792):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
sp += 4;
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super793):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super794):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super795):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super796):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super797):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 3;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super798):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(4);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super799):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(4);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super800):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(4);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super801):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super802):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super803):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super804):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super805):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super806):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super807):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super808):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super809):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super810):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super811):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super812):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 2;
rp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super813):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super814):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super815):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super816):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super817):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super818):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super819):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super820):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super821):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super822):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super823):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super824):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super825):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super826):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super827):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(5);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super828):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super829):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super830):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super831):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super832):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super833):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super834):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(5);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super835):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super836):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super837):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super838):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super839):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(5);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super840):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(5);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super841):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super842):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super843):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super844):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super845):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super846):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super847):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(5);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super848):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super849):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super850):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super851):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super852):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super853):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super854):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super855):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super856):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super857):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super858):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super859):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(4);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super860):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super861):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super862):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super863):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super864):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(5);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super865):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(5);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super866):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super867):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super868):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super869):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
INC_IP(5);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super870):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
INC_IP(5);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super871):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _IP4;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(IP[4],_IP4);
INC_IP(5);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP4,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super872):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super873):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* negate ( n1 -- n2 ) */
NAME("negate")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
/* use minus as alias */
n2 = -n1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super874):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super875):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super876):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super877):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super878):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super879):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super880):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 2;
rp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super881):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super882):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super883):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super884):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super885):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super886):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super887):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super888):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super889):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super890):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super891):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super892):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super893):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super894):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -4;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
NEXT_P2;}

LABEL(super895):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super896):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
rp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super897):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super898):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super899):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
rp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super900):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super901):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super902):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super903):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super904):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += 1;
rp += 2;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super905):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super906):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super907):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super908):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super909):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
rp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super910):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super911):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super912):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super913):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super914):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super915):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp0);
vm_n2Cell(n4,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super916):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
rp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp0);
vm_n2Cell(n4,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super917):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
rp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w1,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super918):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
rp += -1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super919):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super920):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super921):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super922):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super923):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super924):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
rp += -1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super925):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super926):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super927):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super928):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super929):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super930):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super931):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super932):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super933):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super934):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super935):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super936):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super937):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super938):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp0);
vm_n2Cell(n4,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super939):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp0);
vm_n2Cell(n4,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super940):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp1);
vm_n2Cell(n4,_sp2);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w1,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super941):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super942):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super943):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super944):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super945):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super946):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super947):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
rp += 2;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super948):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super949):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super950):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
rp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super951):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super952):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
rp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super953):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super954):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super955):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super956):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* /mod ( n1 n2 -- n3 n4 ) */
NAME("/mod")
{
Cell n1;
Cell n2;
Cell n3;
Cell n4;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n4 = n1/n2;
n3 = n1%n2; /* !! is this correct? look into C standard! */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n3=", vm_out); printarg_n(n3);
fputs(" n4=", vm_out); printarg_n(n4);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n3,_sp2);
vm_n2Cell(n4,_sp3);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super957):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
rp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp1);
vm_w2Cell(w1,_sp2);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super958):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
rp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super959):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super960):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super961):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 2;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super962):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
}
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super963):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super964):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super965):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
rp += 2;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super966):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super967):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super968):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super969):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super970):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super971):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super972):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super973):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super974):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super975):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super976):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super977):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super978):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super979):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super980):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super981):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super982):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super983):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super984):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super985):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super986):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP0,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super987):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
rp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP0,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super988):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
rp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP0,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super989):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP1,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super990):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super991):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super992):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super993):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super994):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super995):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super996):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super997):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super998):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super999):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1000):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1001):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1002):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1003):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1004):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1005):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1006):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1007):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1008):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1009):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1010):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1011):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1012):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1013):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1014):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* abs ( n -- u ) */
NAME("abs")
{
Cell n;
UCell u;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
if (n<0)
  u = -n;
else
  u = n;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" u=", vm_out); printarg_u(u);
fputc('\n', vm_out);
}
#endif
vm_u2Cell(u,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1015):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1016):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1017):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1018):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1019):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1020):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1021):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1022):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1023):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1024):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1025):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1026):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1027):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1028):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1029):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1030):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1031):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
rp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1032):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* branch ( #ndisp -- ) */
NAME("branch")
{
Cell ndisp;
vm_Cell2n(_IP0,ndisp);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1033):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* branch ( #ndisp -- ) */
NAME("branch")
{
Cell ndisp;
vm_Cell2n(_IP1,ndisp);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1034):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1035):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1036):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1037):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1038):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1039):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1040):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1041):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1042):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1043):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1044):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1045):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1046):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1047):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1048):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1049):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1050):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1051):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1052):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1053):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1054):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* xor ( w1 w2 -- w ) */
NAME("xor")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1^w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1055):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1056):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1057):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1058):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1059):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1060):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1061):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1062):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1063):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1064):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1065):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1066):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1067):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1068):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1069):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1070):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1071):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1072):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 2;
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1073):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1074):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1075):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1076):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1077):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1078):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1079):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1080):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1081):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1082):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1083):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1084):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1085):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1086):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1087):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1088):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1089):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1090):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1091):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1092):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1093):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1094):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1095):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1096):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1097):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1098):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1099):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1100):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* move ( c_from c_to ucount -- ) */
NAME("move")
{
Char * c_from;
Char * c_to;
UCell ucount;
vm_Cell2c_(_sp0,c_from);
vm_Cell2c_(_sp1,c_to);
vm_Cell2u(_sp2,ucount);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
{
#line 2455 "./prim"
/* !! note that the standard specifies addr, not c-addr */
memmove(c_to,c_from,ucount);
/* make an Ifdef for bsd and others? */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1101):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 3;
rp += 1;
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* move ( c_from c_to ucount -- ) */
NAME("move")
{
Char * c_from;
Char * c_to;
UCell ucount;
vm_Cell2c_(_sp0,c_from);
vm_Cell2c_(_sp1,c_to);
vm_Cell2u(_sp2,ucount);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_from=", vm_out); printarg_c_(c_from);
fputs(" c_to=", vm_out); printarg_c_(c_to);
fputs(" ucount=", vm_out); printarg_u(ucount);
}
#endif
{
#line 2455 "./prim"
/* !! note that the standard specifies addr, not c-addr */
memmove(c_to,c_from,ucount);
/* make an Ifdef for bsd and others? */
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1102):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1103):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1104):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1105):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1106):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1107):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1108):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1109):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1110):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1111):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1112):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1113):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1114):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1115):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1116):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1117):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1118):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1119):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1120):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1121):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1122):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1123):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1124):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 2;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1125):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(4);
sp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1126):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(4);
sp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1127):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1128):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1129):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1130):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1131):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1132):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1133):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1134):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1135):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1136):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1137):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1138):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1139):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1140):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1141):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1142):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1143):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1144):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1145):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1146):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
rp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* (?do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
NAME("(?do)")
{
Cell ndisp;
Cell nlimit;
Cell nstart;
vm_Cell2n(_IP1,ndisp);
vm_Cell2n(_sp0,nlimit);
vm_Cell2n(_sp1,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
{
#line 2455 "./prim"
if (nstart == nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(nlimit,_rp0);
vm_n2Cell(nstart,_rp1);
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(nlimit,_rp0);
vm_n2Cell(nstart,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1147):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1148):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
rp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* (?do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
NAME("(?do)")
{
Cell ndisp;
Cell nlimit;
Cell nstart;
vm_Cell2n(_IP1,ndisp);
vm_Cell2n(_sp0,nlimit);
vm_Cell2n(_sp1,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
{
#line 2455 "./prim"
if (nstart == nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(nlimit,_rp0);
vm_n2Cell(nstart,_rp1);
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
}
SUPER_CONTINUE;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(nlimit,_rp0);
vm_n2Cell(nstart,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1149):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
rp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* (?do) ( #ndisp nlimit nstart -- R:nlimit R:nstart ) */
NAME("(?do)")
{
Cell ndisp;
Cell nlimit;
Cell nstart;
vm_Cell2n(_IP2,ndisp);
vm_Cell2n(_sp0,nlimit);
vm_Cell2n(_sp1,nstart);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" nstart=", vm_out); printarg_n(nstart);
}
#endif
{
#line 2455 "./prim"
if (nstart == nlimit) {
    SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
    
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(nlimit,_rp0);
vm_n2Cell(nstart,_rp1);
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;
}
SUPER_CONTINUE;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(nlimit,_rp0);
vm_n2Cell(nstart,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1150):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1151):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1152):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += -1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1153):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1154):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1155):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1156):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += -2;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1157):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += -1;
rp += 2;
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp2,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1158):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1159):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1160):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1161):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1162):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1163):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -3;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1164):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1165):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1166):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
rp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1167):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1168):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1169):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp0, (Cell)_sp1, d1)
vm_twoCell2d((Cell)_sp2, (Cell)_sp3, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1170):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
rp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1171):
{
DEF_CA
Cell _sp0;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1172):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1173):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1174):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1175):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _sp6;
Cell _sp7;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += -4;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
vm_Cell2w(_sp4,w3);
vm_Cell2w(_sp5,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp5););
vm_w2Cell(w1,_sp6);
vm_w2Cell(w2,_sp7);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputs(" _sp6=", vm_out); printarg_Cell(_sp6);
fputs(" _sp7=", vm_out); printarg_Cell(_sp7);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[7]);
vm_Cell2Cell(_sp1,sp[6]);
vm_Cell2Cell(_sp2,sp[5]);
vm_Cell2Cell(_sp3,sp[4]);
vm_Cell2Cell(_sp4,sp[3]);
vm_Cell2Cell(_sp5,sp[2]);
vm_Cell2Cell(_sp6,sp[1]);
vm_Cell2Cell(_sp7,spTOS);
NEXT_P2;}

LABEL(super1176):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _sp6;
Cell _sp7;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += -4;
rp += 1;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
vm_Cell2w(_sp4,w3);
vm_Cell2w(_sp5,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp5););
vm_w2Cell(w1,_sp6);
vm_w2Cell(w2,_sp7);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputs(" _sp6=", vm_out); printarg_Cell(_sp6);
fputs(" _sp7=", vm_out); printarg_Cell(_sp7);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[7]);
vm_Cell2Cell(_sp1,sp[6]);
vm_Cell2Cell(_sp2,sp[5]);
vm_Cell2Cell(_sp3,sp[4]);
vm_Cell2Cell(_sp4,sp[3]);
vm_Cell2Cell(_sp5,sp[2]);
vm_Cell2Cell(_sp6,sp[1]);
vm_Cell2Cell(_sp7,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1177):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += -2;
rp += 1;
/* 2over ( w1 w2 w3 w4 -- w1 w2 w3 w4 w1 w2 ) */
NAME("2over")
{
Cell w1;
Cell w2;
Cell w3;
Cell w4;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
vm_Cell2w(_sp3,w4);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
fputs(" w4=", vm_out); printarg_w(w4);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w4,_sp3););
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1178):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1179):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -3;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1180):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1181):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1182):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1183):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1184):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1185):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1186):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1187):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP0,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1188):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1189):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1190):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1191):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1192):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1193):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1194):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1+ ( n1 -- n2 ) */
NAME("1+")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1+1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1195):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
sp += 1;
rp += 2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1196):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* does-exec ( #a_cfa -- R:nest a_pfa ) */
NAME("does-exec")
{
Cell * a_cfa;
Cell nest;
Cell * a_pfa;
vm_Cell2a_(_IP1,a_cfa);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_cfa=", vm_out); printarg_a_(a_cfa);
}
#endif
{
#line 2455 "./prim"
a_pfa = PFA(a_cfa);
nest = (Cell)ip;
IF_spTOS(spTOS = sp[0]);
#ifdef DEBUG
    {
      CFA_TO_NAME(a_cfa);
      fprintf(stderr,"%08lx: does %08lx %.*s\n",
	      (Cell)ip,(Cell)a_cfa,len,name);
    }
#endif
SET_IP(DOES_CODE1(a_cfa));
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" nest=", vm_out); printarg_n(nest);
fputs(" a_pfa=", vm_out); printarg_a_(a_pfa);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(nest,_rp0);
vm_a_2Cell(a_pfa,_sp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1197):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1198):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1199):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1200):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
rp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1201):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1202):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1203):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 2;
rp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1204):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
rp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1205):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
rp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1206):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
rp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1207):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1208):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1209):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1210):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1211):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1212):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1213):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1214):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1215):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1216):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1217):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1218):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1219):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1220):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1221):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1222):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1223):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1224):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1225):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1226):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1227):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1228):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1229):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1230):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1231):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1232):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1233):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1234):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1235):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1236):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1237):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1238):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1239):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1240):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1241):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1242):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1243):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1244):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1245):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1246):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1247):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1248):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1249):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1250):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1251):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* rot ( w1 w2 w3 -- w2 w3 w1 ) */
NAME("rot")
{
Cell w1;
Cell w2;
Cell w3;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2w(_sp2,w3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" w3=", vm_out); printarg_w(w3);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w3,_sp1);
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1252):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1253):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1254):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1255):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1256):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1257):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1258):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1259):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1260):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1261):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1262):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1263):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1264):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 3;
rp += -1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1265):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1266):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1267):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1268):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* > ( n1 n2 -- f ) */
NAME(">")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1>n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1269):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1270):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(sp[4],_sp0);
vm_Cell2Cell(sp[3],_sp1);
vm_Cell2Cell(sp[2],_sp2);
vm_Cell2Cell(sp[1],_sp3);
vm_Cell2Cell(spTOS,_sp4);
sp += 4;
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1271):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[4],_sp0);
vm_Cell2Cell(sp[3],_sp1);
vm_Cell2Cell(sp[2],_sp2);
vm_Cell2Cell(sp[1],_sp3);
vm_Cell2Cell(spTOS,_sp4);
vm_Cell2Cell(rpTOS,_rp0);
sp += 4;
rp += 1;
/* d= ( d1 d2 -- f ) */
NAME("d=")
{
DCell d1;
DCell d2;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d1)
vm_twoCell2d((Cell)_sp3, (Cell)_sp4, d2)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d1=", vm_out); printarg_d(d1);
fputs(" d2=", vm_out); printarg_d(d2);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 918
f = FLAG(d1.lo==d2.lo && d1.hi==d2.hi);
#line 918
#else
#line 918
f = FLAG(d1==d2);
#line 918
#endif
#line 918
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1272):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1273):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1274):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(3);
sp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1275):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(4);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1276):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1277):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1278):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1279):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1280):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1281):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1282):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1283):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1284):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1285):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1286):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* fill ( c_addr u c -- ) */
NAME("fill")
{
Char * c_addr;
UCell u;
Char c;
vm_Cell2c_(_sp0,c_addr);
vm_Cell2u(_sp1,u);
vm_Cell2c(_sp2,c);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c=", vm_out); printarg_c(c);
}
#endif
{
#line 2455 "./prim"
memset(c_addr,c,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1287):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 3;
rp += 1;
/* fill ( c_addr u c -- ) */
NAME("fill")
{
Char * c_addr;
UCell u;
Char c;
vm_Cell2c_(_sp0,c_addr);
vm_Cell2u(_sp1,u);
vm_Cell2c(_sp2,c);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c=", vm_out); printarg_c(c);
}
#endif
{
#line 2455 "./prim"
memset(c_addr,c,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1288):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* fill ( c_addr u c -- ) */
NAME("fill")
{
Char * c_addr;
UCell u;
Char c;
vm_Cell2c_(_sp0,c_addr);
vm_Cell2u(_sp1,u);
vm_Cell2c(_sp2,c);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" c_addr=", vm_out); printarg_c_(c_addr);
fputs(" u=", vm_out); printarg_u(u);
fputs(" c=", vm_out); printarg_c(c);
}
#endif
{
#line 2455 "./prim"
memset(c_addr,c,u);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1289):
{
DEF_CA
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1290):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1291):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super1292):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1293):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -3;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1294):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1295):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1296):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1297):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1298):
{
DEF_CA
Cell _IP0;
Cell _sp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1299):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1300):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1301):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
rp += -2;
/* >r ( w -- R:w ) */
NAME(">r")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_rp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1302):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1303):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1304):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1305):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1306):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super1307):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 1- ( n1 -- n2 ) */
NAME("1-")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1-1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1308):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1309):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1310):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1311):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1312):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1313):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1314):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1315):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1316):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1317):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1318):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1319):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1320):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1321):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1322):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1323):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1324):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1325):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1326):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1327):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1328):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1329):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1330):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1331):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1332):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1333):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1334):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1335):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -2;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1336):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += -1;
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1337):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1338):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1339):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
rp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1340):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
sp += -2;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP3,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1341):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP2,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1342):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1343):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1344):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1345):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1346):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1347):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1348):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1349):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1350):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1351):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1352):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1353):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1354):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1355):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1356):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1357):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1358):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1359):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1360):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1361):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1362):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += -1;
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1363):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1364):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1365):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1366):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1367):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1368):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1369):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1370):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1371):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1372):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
rp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1373):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1374):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1375):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1376):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1377):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1378):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1379):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1380):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1381):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1382):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1383):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1384):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1385):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1386):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1387):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1388):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1389):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1390):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1391):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1392):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1393):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(4);
sp += -1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1394):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1395):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1396):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* tuck ( w1 w2 -- w2 w1 w2 ) */
NAME("tuck")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1397):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 4;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1398):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 4;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1399):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 4;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1400):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
sp += 4;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1401):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1402):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 3;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1403):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1404):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[4],_sp0);
vm_Cell2Cell(sp[3],_sp1);
vm_Cell2Cell(sp[2],_sp2);
vm_Cell2Cell(sp[1],_sp3);
vm_Cell2Cell(spTOS,_sp4);
INC_IP(1);
sp += 5;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp3,w);
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1405):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[4],_sp0);
vm_Cell2Cell(sp[3],_sp1);
vm_Cell2Cell(sp[2],_sp2);
vm_Cell2Cell(sp[1],_sp3);
vm_Cell2Cell(spTOS,_sp4);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 5;
rp += 1;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp3,w);
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1406):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* tuck ( w1 w2 -- w2 w1 w2 ) */
NAME("tuck")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1407):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* tuck ( w1 w2 -- w2 w1 w2 ) */
NAME("tuck")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1408):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* tuck ( w1 w2 -- w2 w1 w2 ) */
NAME("tuck")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp1,w);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1409):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
sp += 4;
/* tuck ( w1 w2 -- w2 w1 w2 ) */
NAME("tuck")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp3,w);
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1410):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 4;
rp += 1;
/* tuck ( w1 w2 -- w2 w1 w2 ) */
NAME("tuck")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp2,w1);
vm_Cell2w(_sp3,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp2);
vm_w2Cell(w1,_sp3);
vm_w2Cell(w2,_sp4);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp3,w);
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp3,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* 2! ( w1 w2 a_addr -- ) */
NAME("2!")
{
Cell w1;
Cell w2;
Cell * a_addr;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
a_addr[0] = w2;
a_addr[1] = w1;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1411):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
INC_IP(1);
rp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1412):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
rp += -3;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* 2>r ( w1 w2 -- R:w1 R:w2 ) */
NAME("2>r")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_rp0);
vm_w2Cell(w2,_rp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp2);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputs(" _rp2=", vm_out); printarg_Cell(_rp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[2]);
vm_Cell2Cell(_rp1,rp[1]);
vm_Cell2Cell(_rp2,rpTOS);
NEXT_P2;}

LABEL(super1413):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1414):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1415):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1416):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1417):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1418):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1419):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1420):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1421):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1422):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1423):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1424):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1425):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1426):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1427):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1428):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1429):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1430):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}
/* d0= ( d -- f ) */
NAME("d0=")
{
DCell d;
Bool f;
vm_twoCell2d((Cell)_sp1, (Cell)_sp2, d)
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" d=", vm_out); printarg_d(d);
}
#endif
{
#line 2455 "./prim"
#ifdef BUGGY_LONG_LONG
#line 919
f = FLAG(d.lo==DZERO.lo && d.hi==DZERO.hi);
#line 919
#else
#line 919
f = FLAG(d==DZERO);
#line 919
#endif
#line 919
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1431):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1432):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1433):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1434):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1435):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1436):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1437):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1438):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1439):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1440):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1441):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1442):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1443):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1444):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1445):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1446):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1447):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1448):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1449):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1450):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1451):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1452):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1453):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1454):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1455):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1456):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1457):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1458):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1459):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1460):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1461):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1462):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1463):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1464):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1465):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1466):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1467):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1468):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(4);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1469):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1470):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1471):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1472):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1473):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1474):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1475):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1476):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1477):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1478):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1479):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1480):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1481):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1482):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1483):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* 0< ( n -- f ) */
NAME("0<")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n<0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1484):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1485):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
NEXT_P2;}

LABEL(super1486):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1487):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -2;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1488):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(spTOS,_sp0);
sp += -1;
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* <> ( n1 n2 -- f ) */
NAME("<>")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1!=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1489):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp0);
vm_w2Cell(w2,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* <> ( n1 n2 -- f ) */
NAME("<>")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1!=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1490):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -3;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp4);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1491):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -4;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp4);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1492):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _sp6;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -5;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp4);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp5););
vm_w2Cell(w1,_sp6);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputs(" _sp6=", vm_out); printarg_Cell(_sp6);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[6]);
vm_Cell2Cell(_sp1,sp[5]);
vm_Cell2Cell(_sp2,sp[4]);
vm_Cell2Cell(_sp3,sp[3]);
vm_Cell2Cell(_sp4,sp[2]);
vm_Cell2Cell(_sp5,sp[1]);
vm_Cell2Cell(_sp6,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1493):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _sp6;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += -4;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp4);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp5););
vm_w2Cell(w1,_sp6);
}
/* <> ( n1 n2 -- f ) */
NAME("<>")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp5,n1);
vm_Cell2n(_sp6,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1!=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp5);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _sp5=", vm_out); printarg_Cell(_sp5);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[5]);
vm_Cell2Cell(_sp1,sp[4]);
vm_Cell2Cell(_sp2,sp[3]);
vm_Cell2Cell(_sp3,sp[2]);
vm_Cell2Cell(_sp4,sp[1]);
vm_Cell2Cell(_sp5,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1494):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _sp4;
Cell _sp5;
Cell _sp6;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += -3;
/* 2dup ( w1 w2 -- w1 w2 w1 w2 ) */
NAME("2dup")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
vm_w2Cell(w2,_sp3);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp4);
}
/* 2@ ( a_addr -- w1 w2 ) */
NAME("2@")
{
Cell * a_addr;
Cell w1;
Cell w2;
vm_Cell2a_(_sp4,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w2 = a_addr[0];
w1 = a_addr[1];
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp4);
vm_w2Cell(w2,_sp5);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp4,w1);
vm_Cell2w(_sp5,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp5););
vm_w2Cell(w1,_sp6);
}
/* <> ( n1 n2 -- f ) */
NAME("<>")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp5,n1);
vm_Cell2n(_sp6,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1!=n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp5);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp5,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputs(" _sp4=", vm_out); printarg_Cell(_sp4);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[4]);
vm_Cell2Cell(_sp1,sp[3]);
vm_Cell2Cell(_sp2,sp[2]);
vm_Cell2Cell(_sp3,sp[1]);
vm_Cell2Cell(_sp4,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1495):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* within ( u1 u2 u3 -- f ) */
NAME("within")
{
UCell u1;
UCell u2;
UCell u3;
Bool f;
vm_Cell2u(_sp0,u1);
vm_Cell2u(_sp1,u2);
vm_Cell2u(_sp2,u3);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" u1=", vm_out); printarg_u(u1);
fputs(" u2=", vm_out); printarg_u(u2);
fputs(" u3=", vm_out); printarg_u(u3);
}
#endif
{
#line 2455 "./prim"
f = FLAG(u1-u2 < u3-u2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1496):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1497):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
rp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* - ( n1 n2 -- n ) */
NAME("-")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1-n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1498):
{
DEF_CA
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
sp += 1;
/* < ( n1 n2 -- f ) */
NAME("<")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1<n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1499):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
rp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp0,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1500):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1501):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
rp += -1;
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1502):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
Cell _rp0;
NEXT_P0;
IF_rpTOS(rp[0] = rpTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
rp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp0);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1503):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1504):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1505):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1506):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1507):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1508):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1509):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
sp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1510):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[3],_sp0);
vm_Cell2Cell(sp[2],_sp1);
vm_Cell2Cell(sp[1],_sp2);
vm_Cell2Cell(spTOS,_sp3);
INC_IP(1);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1511):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rp[1],_rp0);
vm_Cell2Cell(rpTOS,_rp1);
INC_IP(1);
sp += 2;
/* ! ( w a_addr -- ) */
NAME("!")
{
Cell w;
Cell * a_addr;
vm_Cell2w(_sp0,w);
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
*a_addr = w;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
/* (loop) ( #ndisp R:nlimit R:n1 -- R:nlimit R:n2 ) */
NAME("(loop)")
{
Cell ndisp;
Cell nlimit;
Cell n1;
Cell n2;
vm_Cell2n(_IP0,ndisp);
vm_Cell2n(_rp0,nlimit);
vm_Cell2n(_rp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" nlimit=", vm_out); printarg_n(nlimit);
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2=n1+1;
#line 256
if (n2 != nlimit) {
#line 256
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 256

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_rp1);
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 256
}
#line 256
SUPER_CONTINUE;
#line 256
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1512):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
rp += 1;
/* 0= ( n -- f ) */
NAME("0=")
{
Cell n;
Bool f;
vm_Cell2n(_sp1,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n==0);
#line 866
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1513):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
sp += 1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1514):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
sp += 1;
rp += -1;
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP0,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1515):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(1);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rpTOS);
NEXT_P2;}

LABEL(super1516):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
rp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* i ( R:n -- R:n n ) */
NAME("i")
{
Cell n;
vm_Cell2n(_rp0,n);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n=", vm_out); printarg_n(n);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* call ( #a_callee -- R:a_retaddr ) */
NAME("call")
{
Cell * a_callee;
Cell * a_retaddr;
vm_Cell2a_(_IP1,a_callee);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_callee=", vm_out); printarg_a_(a_callee);
}
#endif
{
#line 2455 "./prim"
#ifdef DEBUG
    {
      CFA_TO_NAME((((Cell *)a_callee)-2));
      fprintf(stderr,"%08lx: call %08lx %.*s\n",(Cell)ip,(Cell)a_callee,
	      len,name);
    }
#endif
a_retaddr = (Cell *)IP;
SET_IP((Xt *)a_callee);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" a_retaddr=", vm_out); printarg_a_(a_retaddr);
fputc('\n', vm_out);
}
#endif
vm_a_2Cell(a_retaddr,_rp1);
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _rp0=", vm_out); printarg_Cell(_rp0);
fputs(" _rp1=", vm_out); printarg_Cell(_rp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
vm_Cell2Cell(_rp0,rp[1]);
vm_Cell2Cell(_rp1,rpTOS);
NEXT_P2;}

LABEL(super1517):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
Cell _rp1;
Cell _rp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(rp[2],_rp0);
vm_Cell2Cell(rp[1],_rp1);
vm_Cell2Cell(rpTOS,_rp2);
sp += -3;
rp += 3;
/* r> ( R:w -- w ) */
NAME("r>")
{
Cell w;
vm_Cell2w(_rp2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* 2r> ( R:w1 R:w2 -- w1 w2 ) */
NAME("2r>")
{
Cell w1;
Cell w2;
vm_Cell2w(_rp0,w1);
vm_Cell2w(_rp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w1,_sp1);
vm_w2Cell(w2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1518):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1519):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1520):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1521):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1522):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1523):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 2;
rp += 1;
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1524):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1525):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1526):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1527):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1528):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1529):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(2);
sp += 2;
rp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1530):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1531):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1532):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1533):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1534):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1535):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1536):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1537):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1538):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1539):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1540):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1541):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1542):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1543):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1544):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
rp += 1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1545):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1546):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1547):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1548):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1549):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1550):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _rp0;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
vm_Cell2Cell(rpTOS,_rp0);
INC_IP(3);
sp += 1;
rp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* ;s ( R:w -- ) */
NAME(";s")
{
Cell w;
vm_Cell2w(_rp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
SET_IP((Xt *)w);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
IF_rpTOS(rpTOS = rp[0]);
NEXT_P2;}

LABEL(super1551):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1552):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1553):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1554):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1555):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
INC_IP(3);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1556):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _IP3;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
IF_spTOS(sp[0] = spTOS);
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(IP[3],_IP3);
INC_IP(4);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp0,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP2,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* * ( n1 n2 -- n ) */
NAME("*")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1*n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP3,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1557):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* swap ( w1 w2 -- w2 w1 ) */
NAME("swap")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w2,_sp0);
vm_w2Cell(w1,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* and ( w1 w2 -- w ) */
NAME("and")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1&w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1558):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
sp += 2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1559):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 3;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1560):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1561):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1562):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1563):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1564):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1565):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1566):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1567):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp0,n1);
vm_Cell2n(_sp1,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp0);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1568):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1569):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1570):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1571):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1572):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1573):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1574):
{
DEF_CA
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1575):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += -1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1576):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1577):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1578):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(1);
sp += 1;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1579):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[2],_sp0);
vm_Cell2Cell(sp[1],_sp1);
vm_Cell2Cell(spTOS,_sp2);
INC_IP(2);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1580):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 2;
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP0,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1581):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1582):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp1,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1583):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(1);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1584):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -3;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1585):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1586):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -2;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1587):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(2);
sp += -1;
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1588):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(spTOS,_sp0);
INC_IP(3);
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp0););
vm_w2Cell(w,_sp1);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1589):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1590):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += 2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp1,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp0);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP1,ndisp);
vm_Cell2f(_sp0,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
NEXT_P1;
IF_spTOS(spTOS = sp[0]);
NEXT_P2;}

LABEL(super1591):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1592):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -2;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1593):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1594):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
sp += -1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1595):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(2);
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[1]);
vm_Cell2Cell(_sp1,spTOS);
NEXT_P2;}

LABEL(super1596):
{
DEF_CA
Cell _IP0;
Cell _IP1;
Cell _IP2;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(IP[1],_IP1);
vm_Cell2Cell(IP[2],_IP2);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(3);
sp += 1;
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp1);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* cells ( n1 -- n2 ) */
NAME("cells")
{
Cell n1;
Cell n2;
vm_Cell2n(_sp2,n1);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
}
#endif
{
#line 2455 "./prim"
n2 = n1 * sizeof(Cell);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n2=", vm_out); printarg_n(n2);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n2,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp2);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp2,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp2);
}
/* or ( w1 w2 -- w ) */
NAME("or")
{
Cell w1;
Cell w2;
Cell w;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
w = w1|w2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp1);
}
/* ?branch ( #ndisp f -- ) */
NAME("?branch")
{
Cell ndisp;
Bool f;
vm_Cell2n(_IP2,ndisp);
vm_Cell2f(_sp1,f);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" ndisp=", vm_out); printarg_n(ndisp);
fputs(" f=", vm_out); printarg_f(f);
}
#endif
{
#line 2455 "./prim"
if (f==0) {
#line 209
	SET_IP((Xt *)(((Cell)(IP-1))+ndisp));
#line 209

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;
#line 209
}
#line 209
SUPER_CONTINUE;
#line 209
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
}
SUPER_END;

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,spTOS);
NEXT_P2;}

LABEL(super1597):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1598):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

LABEL(super1599):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -1;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[2]);
vm_Cell2Cell(_sp1,sp[1]);
vm_Cell2Cell(_sp2,spTOS);
NEXT_P2;}

LABEL(super1600):
{
DEF_CA
Cell _IP0;
Cell _sp0;
Cell _sp1;
Cell _sp2;
Cell _sp3;
NEXT_P0;
vm_Cell2Cell(IPTOS,_IP0);
vm_Cell2Cell(sp[1],_sp0);
vm_Cell2Cell(spTOS,_sp1);
INC_IP(1);
sp += -2;
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp0,w1);
vm_Cell2w(_sp1,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp1););
vm_w2Cell(w1,_sp2);
}
/* + ( n1 n2 -- n ) */
NAME("+")
{
Cell n1;
Cell n2;
Cell n;
vm_Cell2n(_sp1,n1);
vm_Cell2n(_sp2,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
n = n1+n2;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" n=", vm_out); printarg_n(n);
fputc('\n', vm_out);
}
#endif
vm_n2Cell(n,_sp1);
}
/* dup ( w -- w w ) */
NAME("dup")
{
Cell w;
vm_Cell2w(_sp1,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w,_sp1););
vm_w2Cell(w,_sp2);
}
/* lit ( #w -- w ) */
NAME("lit")
{
Cell w;
vm_Cell2w(_IP0,w);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w=", vm_out); printarg_w(w);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* @ ( a_addr -- w ) */
NAME("@")
{
Cell * a_addr;
Cell w;
vm_Cell2a_(_sp3,a_addr);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" a_addr=", vm_out); printarg_a_(a_addr);
}
#endif
{
#line 2455 "./prim"
w = *a_addr;
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" w=", vm_out); printarg_w(w);
fputc('\n', vm_out);
}
#endif
vm_w2Cell(w,_sp3);
}
/* = ( n1 n2 -- f ) */
NAME("=")
{
Cell n1;
Cell n2;
Bool f;
vm_Cell2n(_sp2,n1);
vm_Cell2n(_sp3,n2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" n1=", vm_out); printarg_n(n1);
fputs(" n2=", vm_out); printarg_n(n2);
}
#endif
{
#line 2455 "./prim"
f = FLAG(n1==n2);
#line 867
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" f=", vm_out); printarg_f(f);
fputc('\n', vm_out);
}
#endif
vm_f2Cell(f,_sp2);
}
/* over ( w1 w2 -- w1 w2 w1 ) */
NAME("over")
{
Cell w1;
Cell w2;
vm_Cell2w(_sp1,w1);
vm_Cell2w(_sp2,w2);
#ifdef VM_DEBUG
if (vm_debug) {
fputs(" w1=", vm_out); printarg_w(w1);
fputs(" w2=", vm_out); printarg_w(w2);
}
#endif
{
#line 2455 "./prim"
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputc('\n', vm_out);
}
#endif
IF_spTOS(vm_w2Cell(w2,_sp2););
vm_w2Cell(w1,_sp3);
}

#ifdef VM_DEBUG
if (vm_debug) {
fputs(" -- ", vm_out); fputs(" _sp0=", vm_out); printarg_Cell(_sp0);
fputs(" _sp1=", vm_out); printarg_Cell(_sp1);
fputs(" _sp2=", vm_out); printarg_Cell(_sp2);
fputs(" _sp3=", vm_out); printarg_Cell(_sp3);
fputc('\n', vm_out);
}
#endif
NEXT_P1;
vm_Cell2Cell(_sp0,sp[3]);
vm_Cell2Cell(_sp1,sp[2]);
vm_Cell2Cell(_sp2,sp[1]);
vm_Cell2Cell(_sp3,spTOS);
NEXT_P2;}

#endif
