\ faked-genes.fs
\ 	$Id: faked-genes.fs,v 1.1 2001/01/03 13:44:29 f Exp $	

\ Some genes produced different result on different FORTHs.
\ This file is for debugging such genes, providing a faked test environment.
\ You can give the gene and parameters in the form the log file provides them.

include system-dependent.fs

variable A-quality
variable B-quality
variable C-quality

: qualities! ( A B C -- )	\ cut&paste A B C from log file.
    C-quality !
    B-quality !
    A-quality ! ;

variable organ-A
variable organ-B
variable organ-C
variable organ-D
variable organ-E
variable organ-F
variable organ-G

: organs! ( A B C D E F G -- )	\ cut&paste A B C D E F G from log file.
    organ-G !
    organ-F !
    organ-E !
    organ-D !
    organ-C !
    organ-B !
    organ-A ! ;
    
variable <food>
variable energy

: skip-string ( -- )   [char] " parse 2drop ;

: start" ( -- )   skip-string ; immediate
: end" ( -- )   skip-string ; immediate
: instack" ( -- )   skip-string ; immediate
: outstack" ( -- )   skip-string ; immediate

: .results
    cr s" organs: "
    organ-A @ .
    organ-B @ .
    organ-C @ .
    organ-D @ .
    organ-E @ .
    organ-F @ .
    organ-G @ .
    ." 	energy w/o costs: " energy @ .
    cr s" qualities: "
    A-quality @ .
    B-quality @ .
    C-quality @ .
    ." 	<food>: " <food> @ .
    cr ;

: GENE:			: ;		immediate
: ;gene			POSTPONE ; ;	immediate
: >internal		2drop ;
: primitive>internal	2drop ;
: last-gene-into-pool	drop ;
: ?/ ( n n -- n|0 )   ['] / CATCH IF 2drop 0 THEN ;

include genes/genes-conditionals.fs
include genes/genes-basic-stack.fs
include genes/genes-basic-arithmetics.fs
include genes/genes-organs.fs
include genes/genes-qualities.fs
include genes/genes-fetch.fs
include genes/genes-store-normalised.fs
include genes/genes-store.fs

false [if] \ genes/insight.fs needs some more variables:
    variable age
    variable age-threshold
    variable reproduction-threshold

    include genes/insight.fs
[then]

: ;gene ; \ redefined to noop

false [if] \ you could use this to cut&paste for initialization

    organ-A !
    organ-B !
    organ-C !
    organ-D !
    organ-E !
    organ-F !
    organ-G !

    A-quality !
    B-quality !
    C-quality !

    <food> !
    energy !

    false [if] \ genes/insight.fs needs some more variables:
	age !
	age-threshold !
	reproduction-threshold !
    [then]

[then]

\ How to use it:
\ Do initialization (see 'before:' tag in log file):
\ A B C qualities!
\ <food> !
\ A B C D E F G organs!
\ energy !

\ Insert gene here ( from log file ):

\ Insert eating procedure here:

\ Display results:
.results bye
