\ genes-store-normalised.fs
\ 	$Id: genes-store-normalised.fs,v 1.11 2001/02/03 22:25:27 f Exp $	

\ simple attempt to scale and/or normalize integer values
\ to deal with integer overflow when adding and so.

decimal
1024 VALUE gene-normalize-max		\ VALUE's are faster than variables

\ a word to normalize integers somehow
true [if]

gene-normalize-max 2/ VALUE gene-normalize/2
gene-normalize/2   2/ VALUE gene-normalize/4

: some ( n -- n' )
    dup 0< >r	( n  r: sign )

    abs
    dup gene-normalize/2 > IF
	2/ gene-normalize/4 +		\ increases half as steep
	abs gene-normalize-max min	\ just cut at abs gene-normalize-max
    THEN

    r> IF negate THEN ;
[else]		\ simple version
: some ( n -- n' )
    dup 0< >r	( n  r: sign )
    abs gene-normalize-max min	\ just cut at abs gene-normalize-max
    r> IF negate THEN ;
[then]

false [if] 	\ some tests
    cr 0 some .
    512 some .
    1024 some .
    9999 some .
    cr
    -512 some .
    -1024 some .
    -9999 some .
    cr
[then]

: $$ ( n X -- n' X )   >r some r> ;	\ normalizes *second* stack item

GENE: !(some)	$$	!	;gene
s" na-"	primitive>internal 10 last-gene-into-pool

GENE: +!(some)	$$	+!	;gene
s" na-"	primitive>internal 10 last-gene-into-pool

GENE: -!(some) swap some negate swap +! ;gene
s" na-"	primitive>internal 10 last-gene-into-pool

GENE: swap!(some)	some	swap !	;gene
s" an-"	primitive>internal 10 last-gene-into-pool

\ ok, it's not storing but fetching, but might be interesting anyway:
\ taking an normalized amount off at a spezified address.
GENE: take-some  dup >r @ some dup negate r> +! ;gene
s" a-n" primitive>internal 10 last-gene-into-pool

[UNDEFINED] g-off [IF]
    s" a-" ' off declare-primitive	2 last-gene-into-pool
[THEN]
